<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

// #### load required phrase groups ############################################
$phrase['groups'] = array(
        'administration'
);

// #### load required javascript ###############################################
$jsinclude = array(
        'tabfx',
        'countries'
);

// #### setup script location ##################################################
define('LOCATION','admin');

// #### require backend ########################################################
require_once('./../functions/config.php');

// #### setup default breadcrumb ###############################################
$navcrumb = array("$ilpage[subscribers]" => $ilcrumbs["$ilpage[subscribers]"]);

$v3nav = $ilance->admincp->print_admincp_nav($_SESSION['ilancedata']['user']['slng'], $ilpage['subscribers']);

if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0 AND $_SESSION['ilancedata']['user']['isadmin'] == '1')
{
        $id = isset($ilance->GPC['id']) ? intval($ilance->GPC['id']) : 0;
        
        // #### NON-PROFITS MANAGER ############################################
        if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'nonprofits')
        {
                $area_title = $phrase['_nonprofits'];
                $page_title = SITE_NAME . ' - ' . $phrase['_nonprofits'];
                
                ($apihook = $ilance->api('admincp_nonprofits_settings')) ? eval($apihook) : false;
                
                $subnav_settings = $ilance->admincp->print_admincp_subnav($ilpage['subscribers'], $ilpage['subscribers'] . '?cmd=nonprofits', $_SESSION['ilancedata']['user']['slng']);
                
                // #### DELETE A NON-PROFIT ####################################
                if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == 'remove-nonprofit' AND isset($ilance->GPC['id']) AND $ilance->GPC['id'] > 0)
                {
                        $ilance->db->query("
                                DELETE FROM " . DB_PREFIX . "charities
                                WHERE charityid = '" . intval($ilance->GPC['id']) . "'
                                LIMIT 1
                        ");
                        
                        print_action_success('The selected nonprofit was removed from the system.', $ilpage['subscribers'] . '?cmd=nonprofits');
                        exit();
                }
                
                // #### ADD NEW NON-PROFIT #####################################
                if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == 'add-nonprofit' AND !empty($ilance->GPC['title']) AND !empty($ilance->GPC['description']) AND !empty($ilance->GPC['url']))
                {
                        $ilance->db->query("
                                INSERT INTO " . DB_PREFIX . "charities
                                (charityid, title, description, url, visible)
                                VALUES (
                                NULL,
                                '" . $ilance->db->escape_string($ilance->GPC['title']) . "',
                                '" . $ilance->db->escape_string($ilance->GPC['description']) . "',
                                '" . $ilance->db->escape_string($ilance->GPC['url']) . "',
                                '1')
                        ");
                        
                        print_action_success('The selected nonprofit was added to the system ready to receive donations from sellers.', $ilpage['subscribers'] . '?cmd=nonprofits');
                        exit();
                }
                
                // #### non-profits ############################################
                $total1 = 0;
                $total2 = 0;
                $show['charities'] = false;
                $row_count = 0;
                $sql = $ilance->db->query("
                        SELECT charityid, title, description, url, earnings, donations, visible
                        FROM " . DB_PREFIX . "charities
                        ORDER BY charityid DESC
                ");
                if ($ilance->db->num_rows($sql) > 0)
                {
                        $show['charities'] = true;
                        while ($res = $ilance->db->fetch_array($sql))
                        {
                                $res['class'] = ($row_count % 2) ? 'alt2' : 'alt1';
                                
                                $total1 += $res['donations'];
                                $total2 += $res['earnings'];
                                
                                $res['earnings'] = $ilance->currency->format($res['earnings']);
                                $res['action'] = '<span class="blue"><a href="' . $ilpage['subscribers'] . '?cmd=nonprofits&amp;subcmd=update-nonprofit&amp;id=' . $res['charityid'] . '#updatenonprofit">' . $phrase['_edit'] . '</a> &nbsp;&nbsp;&nbsp;<a href="' . $ilpage['subscribers'] . '?cmd=nonprofits&amp;subcmd=remove-nonprofit&amp;id=' . $res['charityid'] . '">' . $phrase['_delete'] . '</a></span>';
                                $nonprofits[] = $res;
                                $row_count++;
                        }        
                }
                
                $total2 = $ilance->currency->format($total2);
                
                $configuration_nonprofits = $ilance->admincp->construct_admin_input('nonprofits', $ilpage['subscribers'] . '?cmd=nonprofits');
                
                $pprint_array = array('ilanceversion','login_include_admin','total1','total2','configuration_nonprofits','submit','subcmd','subcat_pulldown','question_inputtype_pulldown','questionid','cid','slng','categoryname','language_pulldown','slng','checked_question_cansearch','checked_question_active','checked_question_required','subcategory_pulldown','formdefault','multiplechoice','question','description','formname','sort','submit_category_question','question_id_hidden','question_subcmd','question_inputtype_pulldown','subcatid','subcatname','catname','service_subcategories','product_categories','subcmd','id','submit','description','name','checked_profile_group_active','input_style','remote_addr','rid','login_include','headinclude','area_title','page_title','lanceads_header','lanceads_footer');
                
                ($apihook = $ilance->api('admincp_nonprofits_end')) ? eval($apihook) : false;
                
                $ilance->template->load_file('main', 'nonprofits.html', 1);
                $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                $ilance->template->parse_loop('main', 'v3nav');
                $ilance->template->parse_loop('main', 'subnav_settings');
                $ilance->template->parse_loop('main', 'nonprofits');
                $ilance->template->parse_if_blocks('main');
                $ilance->template->pprint('main', $pprint_array);
                exit();        
        }
        // #### ABUSE REPORT MANAGER ###########################################
        else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'abuse')
        {
                $area_title = $phrase['_abuse_report_management'];
                $page_title = SITE_NAME . ' - ' . $phrase['_abuse_report_management'];
                
                ($apihook = $ilance->api('admincp_abuse_report_settings')) ? eval($apihook) : false;
                
                $subnav_settings = $ilance->admincp->print_admincp_subnav($ilpage['subscribers'], $ilpage['subscribers'] . '?cmd=abuse', $_SESSION['ilancedata']['user']['slng']);
                
                // #### DISMISS AN ABUSE REPORT ################################
                if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == 'dismiss' AND isset($ilance->GPC['abuseid']) AND $ilance->GPC['abuseid'] > 0)
                {
                        $ilance->db->query("
                                UPDATE " . DB_PREFIX . "abuse_reports
                                SET status = '0'
                                WHERE abuseid = '" . intval($ilance->GPC['abuseid']) . "'
                        ");
                        
                        print_action_success($phrase['_the_selected_abuse_report_was_dismissed'], $ilpage['subscribers'] . '?cmd=abuse');
                        exit();
                }
                
                // #### listings abuse #########################################
                $show['listingabuse'] = false;
                $row_count = 0;
                $sql = $ilance->db->query("
                        SELECT abuseid, regarding, username, email, itemid, status, dateadded, type
                        FROM " . DB_PREFIX . "abuse_reports
                        WHERE abusetype = 'listing'
                                AND status = '1'
                        ORDER BY dateadded DESC
                ");
                if ($ilance->db->num_rows($sql) > 0)
                {
                        $show['listingabuse'] = true;
                        while ($res = $ilance->db->fetch_array($sql))
                        {
                                $res['action'] = '<a href="' . $ilpage['subscribers'] . '?cmd=abuse&amp;subcmd=dismiss&amp;abuseid=' . $res['abuseid'] . '">' . $phrase['_dismiss'] . '</a>';
                                $res['fullregarding'] = trim(addslashes(nl2br(strip_tags($res['regarding']))));
                                $res['regarding'] = short_string($res['regarding'], 75, $symbol = ' .....');
                                if ($res['type'] == 'service')
                                {
                                        $res['ref'] = '<a href="' . HTTP_SERVER . $ilpage['rfp'] . '?id=' . $res['itemid'] . '" target="_blank">' . $res['itemid'] . '</a>';
                                }
                                else
                                {
                                        $res['ref'] = '<a href="' . HTTP_SERVER . $ilpage['merch'] . '?id=' . $res['itemid'] . '" target="_blank">' . $res['itemid'] . '</a>';
                                }
                                $res['class'] = ($row_count % 2) ? 'alt2' : 'alt1';
                                $listingabuse[] = $res;
                                $row_count++;
                        }        
                }
                
                // #### portfolio abuse ########################################
                $show['portfolioabuse'] = false;
                $row_count = 0;
                $sql = $ilance->db->query("
                        SELECT abuseid, regarding, username, email, itemid, status, dateadded, type
                        FROM " . DB_PREFIX . "abuse_reports
                        WHERE abusetype = 'portfolio'
                                AND status = '1'
                        ORDER BY dateadded DESC
                ");
                if ($ilance->db->num_rows($sql) > 0)
                {
                        $show['portfolioabuse'] = true;
                        while ($res = $ilance->db->fetch_array($sql))
                        {
                                $res['action'] = '<a href="' . $ilpage['subscribers'] . '?cmd=abuse&amp;subcmd=dismiss&amp;abuseid=' . $res['abuseid'] . '">' . $phrase['_dismiss'] . '</a>';
                                $res['fullregarding'] = trim(addslashes(nl2br(strip_tags($res['regarding']))));
                                $res['regarding'] = short_string($res['regarding'], 75, $symbol = ' .....');
                                $res['ref'] = '<a href="' . HTTPS_SERVER . $ilpage['attachment'] . '?id=' . $res['itemid'] . '" target="_blank">' . $res['itemid'] . '</a>';
                                $res['class'] = ($row_count % 2) ? 'alt2' : 'alt1';
                                $portfolioabuse[] = $res;
                                $row_count++;
                        }        
                }
                
                // #### profiles abuse #########################################
                $show['profilesabuse'] = false;
                $row_count = 0;
                $sql = $ilance->db->query("
                        SELECT abuseid, regarding, username, email, itemid, status, dateadded, type
                        FROM " . DB_PREFIX . "abuse_reports
                        WHERE abusetype = 'profile'
                                AND status = '1'
                        ORDER BY dateadded DESC
                ");
                if ($ilance->db->num_rows($sql) > 0)
                {
                        $show['profilesabuse'] = true;
                        while ($res = $ilance->db->fetch_array($sql))
                        {
                                $res['action'] = '<a href="' . $ilpage['subscribers'] . '?cmd=abuse&amp;subcmd=dismiss&amp;abuseid=' . $res['abuseid'] . '">' . $phrase['_dismiss'] . '</a>';
                                $res['fullregarding'] = trim(addslashes(nl2br(strip_tags($res['regarding']))));
                                $res['regarding'] = short_string($res['regarding'], 75, $symbol = ' .....');
                                $res['ref'] = '<a href="' . HTTP_SERVER . $ilpage['members'] . '?id=' . $res['itemid'] . '" target="_blank">' . $res['itemid'] . '</a>';
                                $res['class'] = ($row_count % 2) ? 'alt2' : 'alt1';
                                $profilesabuse[] = $res;
                                $row_count++;
                        }        
                }
                
                // #### pmb abuse ##############################################
                $show['pmbabuse'] = false;
                $row_count = 0;
                $sql = $ilance->db->query("
                        SELECT abuseid, regarding, username, email, itemid, status, dateadded, type
                        FROM " . DB_PREFIX . "abuse_reports
                        WHERE abusetype = 'pmb'
                                AND status = '1'
                        ORDER BY dateadded DESC
                ");
                if ($ilance->db->num_rows($sql) > 0)
                {
                        $show['pmbabuse'] = true;
                        while ($res = $ilance->db->fetch_array($sql))
                        {
                                $res['action'] = '<a href="' . $ilpage['subscribers'] . '?cmd=abuse&amp;subcmd=dismiss&amp;abuseid=' . $res['abuseid'] . '">' . $pjrase['_dismiss'] . '</a>';
                                $res['fullregarding'] = trim(addslashes(nl2br(strip_tags($res['regarding']))));
                                $res['regarding'] = short_string($res['regarding'], 75, $symbol = ' .....');
                                $res['ref'] = '<a href="' . HTTPS_SERVER . $ilpage['attachment'] . '?id=' . $res['itemid'] . '" target="_blank">' . $res['itemid'] . '</a>';
                                $res['class'] = ($row_count % 2) ? 'alt2' : 'alt1';
                                $pmbabuse[] = $res;
                                $row_count++;
                        }
                }
                
                $pprint_array = array('ilanceversion','login_include_admin','submit','subcmd','subcat_pulldown','question_inputtype_pulldown','questionid','cid','slng','categoryname','language_pulldown','slng','checked_question_cansearch','checked_question_active','checked_question_required','subcategory_pulldown','formdefault','multiplechoice','question','description','formname','sort','submit_category_question','question_id_hidden','question_subcmd','question_inputtype_pulldown','subcatid','subcatname','catname','service_subcategories','product_categories','subcmd','id','submit','description','name','checked_profile_group_active','input_style','remote_addr','rid','login_include','headinclude','area_title','page_title','lanceads_header','lanceads_footer');
                
                ($apihook = $ilance->api('admincp_abuse_reports_end')) ? eval($apihook) : false;
                
                $ilance->template->load_file('main', 'abuse_reports.html', 1);               
                $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                $ilance->template->parse_loop('main', 'v3nav');
                $ilance->template->parse_loop('main', 'subnav_settings');
                $ilance->template->parse_loop('main', 'listingabuse');
                $ilance->template->parse_loop('main', 'biddingabuse');
                $ilance->template->parse_loop('main', 'portfolioabuse');
                $ilance->template->parse_loop('main', 'profilesabuse');
                $ilance->template->parse_loop('main', 'feedbackabuse');
                $ilance->template->parse_loop('main', 'pmbabuse');
                $ilance->template->parse_if_blocks('main');
                $ilance->template->pprint('main', $pprint_array);
                exit();
                
        }
        // #### SKILLS MANAGER #################################################
        else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'skills')
        {
                $area_title = $phrase['_skills_management'];
                $page_title = SITE_NAME . ' - ' . $phrase['_skills_management'];
                
                ($apihook = $ilance->api('admincp_skills_settings')) ? eval($apihook) : false;
                
                $subnav_settings = $ilance->admincp->print_admincp_subnav($ilpage['subscribers'], $ilpage['subscribers'] . '?cmd=skills', $_SESSION['ilancedata']['user']['slng']);
                
                $ilance->categories_pulldown = construct_object('api.categories_pulldown');
                $ilance->categories_skills = construct_object('api.categories_skills');
                
                // #### ADD OR EDIT SKILL ######################################
                if (isset($ilance->GPC['subcmd']) AND ($ilance->GPC['subcmd'] == 'editskill' OR $ilance->GPC['subcmd'] == 'addskill'))
                {
                        // #### EDIT SKILL #####################################
                        if ($ilance->GPC['subcmd'] == 'editskill')
                        {
                                $categorycache = $ilance->categories_skills->build_array_skills($_SESSION['ilancedata']['user']['slng']);
                                $cid = intval($ilance->GPC['cid']);
                                $pid = $ilance->categories_skills->parentid(fetch_site_slng(), $cid);
                                $subcat_pulldown = $ilance->categories_pulldown->print_cat_pulldown($pid, 'skills', 'level', 'pid', $showpleaseselectoption = 1, fetch_site_slng(), $nooptgroups = 1, $prepopulate = '', $mode = 4, $showallcats = 0, $dojs = 0, $width = '540px', $uid = 0, $forcenocount = 1, $expertspulldown = 0, $canassigntoall = false, $showbestmatching = false, $categorycache);
                                unset($categorycache);
                                    
                                // we are editing a particular skill
                                $submit = '<input type="submit" name="submit" value=" ' . $phrase['_save'] . ' " style="font-size:15px" class="buttons" />';
                                $subcmd = 'updateskill';
                
                                $sql = $ilance->db->query("
                                        SELECT *
                                        FROM " . DB_PREFIX . "skills
                                        WHERE cid = '" . intval($ilance->GPC['cid']) . "'
                                ");
                                if ($ilance->db->num_rows($sql) > 0)
                                {
                                        while ($res = $ilance->db->fetch_array($sql))
                                        {
                                                $res['keywords'] = '<input type="text" name="keywords" value="' . $ilance->categories_skills->keywords(fetch_site_slng(), $cid, $commaafter = false, $showinputkeywords = false) . '" style="font-family: verdana; width:98%" />';
                                                $servicecategory[] = $res;
                                        }
                                }
                                
                                // multilanguage question and description
                                $row_count = 0;
                                $languages = $ilance->db->query("SELECT * FROM " . DB_PREFIX . "language");
                                while ($language = $ilance->db->fetch_array($languages))
                                {
                                        $language['slng'] = mb_strtolower(mb_substr($language['languagecode'], 0, 3));
                                        $language['language'] = $language['title'];
                                        
                                        // fetch title in this language
                                        $sql = $ilance->db->query("
                                                SELECT title_" . $language['slng'] . " AS title, description_" . $language['slng'] . " AS description
                                                FROM " . DB_PREFIX . "skills
                                                WHERE cid = '" . $cid . "'
                                        ");
                                        if ($ilance->db->num_rows($sql) > 0)
                                        {
                                                while ($res = $ilance->db->fetch_array($sql))
                                                {
                                                        $language['title'] = $res['title'];
                                                        $language['description'] = $res['description'];
                                                }
                                        }
                                        $servicelanguages[] = $language;
                                        $row_count++;
                                }
                        }
                        
                        // #### ADD NEW SKILL ##################################
                        else if ($ilance->GPC['subcmd'] == 'addskill')
                        {
                                // adding new service cat
                                $cid = intval($ilance->GPC['cid']);
                                $categorycache = $ilance->categories_skills->build_array_skills($_SESSION['ilancedata']['user']['slng']);
                                $subcat_pulldown = $ilance->categories_pulldown->print_cat_pulldown($cid, 'skills', 'level', 'pid', $showpleaseselectoption = 1, fetch_site_slng(), $nooptgroups = 1, $prepopulate = '', $mode = 4, $showallcats = 1, $dojs = 0, $width = '540px', $uid = 0, $forcenocount = 1, $expertspulldown = 0, $canassigntoall = false, $showbestmatching = false, $categorycache);
                                
                                foreach ($categorycache AS $key => $value)
                                {
                                        if ($value['cid'] == $cid AND $value['level'] > 1)
                                        {
                                                print_action_failed('Sorry, you can only create new skill categories based on 2 levels (example: Main Category : Sub Category).  Please try again.', $ilpage['subscribers'] . '?cmd=skills');
                                                exit();         
                                        }
                                }
                                unset($categorycache);
                                    
                                // we are editing a particular question
                                $submit = '<input type="submit" value=" ' . $phrase['_save'] . ' " style="font-size:15px" class="buttons" />';
                                $subcmd = 'insertskill';
                                
                                $res['keywords'] = '<input type="text" name="keywords" value="" style="font-family: verdana; width:98%" />';
                                $res['sort'] = '0';
                                
                                $servicecategory[] = $res;        
                                
                                // multilanguage question and description
                                $row_count = 0;
                                $languages = $ilance->db->query("
                                        SELECT *
                                        FROM " . DB_PREFIX . "language
                                ");
                                while ($language = $ilance->db->fetch_array($languages))
                                {
                                        $language['slng'] = mb_strtolower(mb_substr($language['languagecode'], 0, 3));
                                        $language['language'] = $language['title'];
                                        $language['title'] = '';	
                                        $servicelanguages[] = $language;
                                        $row_count++;
                                }
                        }
                        
                        $pprint_array = array('ilanceversion','login_include_admin','submit','subcmd','subcat_pulldown','question_inputtype_pulldown','questionid','cid','slng','categoryname','language_pulldown','slng','checked_question_cansearch','checked_question_active','checked_question_required','subcategory_pulldown','formdefault','multiplechoice','question','description','formname','sort','submit_category_question','question_id_hidden','question_subcmd','question_inputtype_pulldown','subcatid','subcatname','catname','service_subcategories','product_categories','subcmd','id','submit','description','name','checked_profile_group_active','input_style','remote_addr','rid','login_include','headinclude','area_title','page_title','lanceads_header','lanceads_footer');
                        
                        ($apihook = $ilance->api('admincp_skills_edit_end')) ? eval($apihook) : false;
                        
                        $ilance->template->load_file('main', 'skills_edit.html', 1);
                        $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                        $ilance->template->parse_loop('main', 'v3nav');
                        $ilance->template->parse_loop('main', 'subnav_settings');
                        $ilance->template->parse_loop('main', 'servicecategory');
                        $ilance->template->parse_loop('main', 'servicelanguages');
                        $ilance->template->parse_if_blocks('main');
                        $ilance->template->pprint('main', $pprint_array);
                        exit();	
                }
                
                // #### UPDATE SKILL ###########################################
                else if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == 'updateskill')
                {
                        $query1 = '';
                        if (!empty($ilance->GPC['title']))
                        {
                                foreach ($ilance->GPC['title'] as $slng => $value)
                                {
                                        $query1 .= "title_" . mb_strtolower($slng) . " = '" . $ilance->db->escape_string($value) . "',";
                                }
                        }
                        
                        $query2 = '';
                        if (!empty($ilance->GPC['description']))
                        {
                                foreach ($ilance->GPC['description'] as $slng => $value)
                                {
                                        $query2 .= "description_" . mb_strtolower($slng) . " = '" . $ilance->db->escape_string($value) . "',";
                                }
                        }
                        
                        $ilance->db->query("
                                UPDATE " . DB_PREFIX . "skills
                                SET parentid = '".intval($ilance->GPC['pid'])."',
                                $query1
                                $query2
                                keywords = '".$ilance->db->escape_string($ilance->GPC['keywords'])."',
                                sort = '".intval($ilance->GPC['sort'])."'
                                WHERE cid = '".intval($ilance->GPC['cid'])."'
                        ");
                        
                        // update the new level bit for the category structure system.
                        $ilance->categories_skills->set_levels_skills();
                        
                        refresh($ilance->GPC['return']);
                        exit();
                }
                
                // #### CREATE NEW SKILL HANDLER ###############################
                else if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == 'insertskill')
                {
                        $cid = isset($ilance->GPC['cid']) ? intval($ilance->GPC['cid']) : 0;
                        $pid = isset($ilance->GPC['pid']) ? intval($ilance->GPC['pid']) : 0;
                        
                        // handle multilanguage titles
                        $titleerror = 0;
                        if (!empty($ilance->GPC['title']))
                        {
                                $titlefields = '';
                                $titlevalues = '';
                                foreach ($ilance->GPC['title'] as $slng => $title)
                                {
                                        if (!empty($slng) AND !empty($title))
                                        {
                                                $titlefields .= 'title_' . $ilance->db->escape_string(mb_strtolower($slng)) . ', ';
                                                $titlevalues .= "'" . $ilance->db->escape_string($title) . "',";
                                        }
                                        else 
                                        {
                                                $titleerror = 1;
                                        }
                                }
                                
                                if ($titleerror)
                                {
                                        print_action_failed($phrase['_sorry_to_create_a_new_skill_category_you_must_define_a_title'], $ilpage['subscribers'] . '?cmd=skills&subcmd=addskill&cid=' . $cid);
                                        exit();	
                                }
                        }
                        else 
                        {
                                print_action_failed($phrase['_sorry_to_create_a_new_skill_category_you_must_define_a_title_for_all_available'], $ilpage['subscribers'] . '?cmd=skills&subcmd=addskill&cid=' . $cid);
                                exit();		
                        }
                        
                        // handle multilanguage descriptions
                        $descriptionerror = false;
                        if (!empty($ilance->GPC['description']))
                        {
                                $descriptionfields = '';
                                $descriptionvalues = '';
                                foreach ($ilance->GPC['description'] as $slng => $title)
                                {
                                        if (!empty($slng) AND !empty($title))
                                        {
                                                $descriptionfields .= 'description_' . $ilance->db->escape_string(mb_strtolower($slng)) . ', ';
                                                $descriptionvalues .= "'" . $ilance->db->escape_string($title) . "',";
                                        }
                                        else 
                                        {
                                                $descriptionerror = true;
                                        }
                                }
                                
                                if ($descriptionerror)
                                {
                                        //print_action_failed("Sorry, to create a new category you must define a description all available languages in your system.", $ilpage['distribution'].'?cmd=categories&subcmd=addproductcat&cid='.$cid);
                                        //exit();	
                                }
                        }
                        else 
                        {
                                //print_action_failed("Sorry, to create a new category you must define a description for all available languages in your system.", $ilpage['distribution'].'?cmd=categories&subcmd=addproductcat&cid='.$cid);
                                //exit();		
                        }
                            
                        $keywords = isset($ilance->GPC['keywords']) ? $ilance->db->escape_string($ilance->GPC['keywords']) : '';
                        $sort = isset($ilance->GPC['sort']) ? intval($ilance->GPC['sort']) : '0';
                        
                        $ilance->db->query("
                                INSERT INTO " . DB_PREFIX . "skills
                                (parentid, $titlefields $descriptionfields keywords, sort)
                                VALUES(
                                '" . $pid . "',
                                $titlevalues
                                $descriptionvalues
                                '" . $keywords . "',
                                '" . $sort . "')
                        ");
                        $insid = $ilance->db->insert_id();
                        
                        // update the new level bit for the category structure system.
                        $ilance->categories_skills->set_levels_skills();
                        
                        print_action_success($phrase['_new_skill_category_was_added'], $ilance->GPC['return']);
                        exit();
                }
                
                // #### REMOVE SKILL ###########################################
                else if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == 'removeskill' AND isset($ilance->GPC['cid']))
                {
                        if ($ilance->categories_skills->can_remove_skill_categories())
                        {
                                $ilance->categories_skills->remove_skills_category_recursive(intval($ilance->GPC['cid']));
                                $ilance->categories_skills->set_levels_skills();
                        
                                print_action_success($phrase['_the_selected_skill_category_was_removed_from_the_category_system'], $ilpage['subscribers']."?cmd=skills");
                                exit();
                        }
                        else 
                        {
                                print_action_failed($phrase['_sorry_you_must_have_at_least_1_skill_category_in_the_system_please_update_or_modify_this_category_instead'], $ilpage['subscribers']."?cmd=skills");
                                exit();	
                        }        
                }
                
                // #### SKILLS MAIN LANDING PAGE ###############################
                else
                {
                        if ($ilconfig['globalauctionsettings_serviceauctionsenabled'])
                        {
                                $row_count = 0;
                                
                                $ilance->categories->cats = $ilance->categories_skills->build_array_skills($_SESSION['ilancedata']['user']['slng']);
                                $count = count($ilance->categories->cats);
                                for ($i = 0; $i < $count; $i++)
                                {
                                        if (isset($ilance->categories->cats[$i]['cid']) AND !empty($ilance->categories->cats[$i]['cid']) AND $ilance->categories->cats[$i]['cid'] > 0)
                                        {
                                                if ($ilance->categories->cats[$i]['level'] == 1)
                                                {
                                                        if ($ilance->categories->cats[$i]['parentid'] == 0)
                                                        {
                                                                $ilance->categories->cats[$i]['auctioncount'] = $ilance->categories_skills->fetch_skills_category_recursive_count($ilance->categories->cats[$i]['cid']);
                                                                $ilance->categories->cats[$i]['title'] = '<a href="' . $ilpage['subscribers'] . '?cmd=skills&amp;subcmd=editskill&amp;cid=' . $ilance->categories->cats[$i]['cid'] . '" title="' . $ilance->categories->cats[$i]['description'] . '"><strong>' . $ilance->categories->cats[$i]['title'] . '</strong></a>';
                                                        }
                                                        else
                                                        {
                                                                $ilance->categories->cats[$i]['auctioncount'] = $ilance->categories_skills->fetch_skills_category_count($ilance->categories->cats[$i]['cid']);
                                                                $ilance->categories->cats[$i]['title'] = '<a href="' . $ilpage['subscribers'] . '?cmd=skills&amp;subcmd=editskill&amp;cid=' . $ilance->categories->cats[$i]['cid'] . '" title="' . $ilance->categories->cats[$i]['description'] . '">' . $ilance->categories->cats[$i]['title'] . '</a>';
                                                        }
                                                }
                                                else if ($ilance->categories->cats[$i]['level'] > 1)
                                                {
                                                        if ($ilance->categories->cats[$i]['parentid'] == 0)
                                                        {
                                                                // treat category as main non-posting category
                                                                $ilance->categories->cats[$i]['auctioncount'] = $ilance->categories_skills->fetch_skills_category_recursive_count($ilance->categories->cats[$i]['cid']);
                                                                $ilance->categories->cats[$i]['title'] = str_repeat('<span class="gray">--</span> ', $ilance->categories->cats[$i]['level']) . '<a href="' . $ilpage['subscribers'] . '?cmd=skills&amp;subcmd=editskill&amp;cid=' . $ilance->categories->cats[$i]['cid'].'" title="' . $ilance->categories->cats[$i]['description'] . '"><strong>' . $ilance->categories->cats[$i]['title'] . '</strong></a>';
                                                        }
                                                        else 
                                                        {
                                                                $ilance->categories->cats[$i]['auctioncount'] = $ilance->categories_skills->fetch_skills_category_count($ilance->categories->cats[$i]['cid']);
                                                                $ilance->categories->cats[$i]['title'] = str_repeat('<span class="gray">--</span> ', $ilance->categories->cats[$i]['level']) . '<a href="' . $ilpage['subscribers'] . '?cmd=skills&amp;subcmd=editskill&amp;cid=' . $ilance->categories->cats[$i]['cid'].'" title="' . $ilance->categories->cats[$i]['description'] . '">' . $ilance->categories->cats[$i]['title'] . '</a>';
                                                        }
                                                }
                                                
                                                $ilance->categories->cats[$i]['class'] = ($row_count % 2) ? 'alt2' : 'alt1';
                                                $servicecategories[] = $ilance->categories->cats[$i];
                                                $row_count++;       
                                        }
                                }
                        }
        
                        // head javascript ajax includes
                        $headinclude .= "
<script type=\"text/javascript\">
function category_jump(catinfo)
{
    if (catinfo == 0)
    {
            alert('" . $phrase['_please_select_a_category'] . "');
            return;
    }
    else if (typeof(document.ilform.cid) != 'undefined')
    {
            action = document.ilform.controls.options[document.ilform.controls.selectedIndex].value;
    }
    else
    {
            action = eval(\"document.ilform.cid\" + catinfo + \".options[document.ilform.cid\" + catinfo + \".selectedIndex].value\");
    }
    
    if (action != '')
    {
            switch (action)
            {
                    case 'edit': page = \"" . $ilpage['subscribers'] . "?cmd=skills&subcmd=editskill&cid=\"; break;
                    case 'add': page = \"" . $ilpage['subscribers'] . "?cmd=skills&subcmd=addskill&cid=\"; break;
                    case 'remove': page = \"" . $ilpage['subscribers'] . "?cmd=skills&subcmd=removeskill&cid=\"; break;
            }
            
            document.ilform.reset();
            jumptopage = page + catinfo + \"\";
            
            if (action == 'remove')
            {
                    var agree = confirm_js(\"" . $phrase['_please_take_a_moment_to_confirm_your_action_continue'] . "\");
                    if (agree)
                    { 
                            return window.location = jumptopage;
                    }
                    else
                    {
                            return false;
                    }
            }
            else
            {
                    window.location = jumptopage;
            }
    }
    else
    {
            alert(\"Invalid Action\");
    }
}

function js_returnid()
{
        return document.ilform.cid.value;
}
</script>

<script language=\"Javascript\">
<!--
checked = false;
function check_uncheck_all(formid)
{
        if (checked == false)
        {
                checked = true
        }
        else
        {
                checked = false
        }
        for (var i = 0; i < fetch_js_object(formid).elements.length; i++)
        {
                fetch_js_object(formid).elements[i].checked = checked;
        }
}
//-->
</script>";
                }
                
                $configuration_skills = $ilance->admincp->construct_admin_input('skills', $ilpage['subscribers'] . '?cmd=skills');
                
                $pprint_array = array('ilanceversion','login_include_admin','configuration_skills','incrementgrouppulldown','incsort','inchidden','incform','incsubmit','incamount','incfrom','incto','hiddenincrementgroupid2','incrementgroupname','incrementgroupdescription','submitincrement','subcmdincrementgroup','language_pulldown','slng','checked_question_cansearch','checked_question_active','checked_question_required','subcategory_pulldown','formdefault','multiplechoice','question','description','formname','sort','submit_category_question','question_id_hidden','question_subcmd','question_inputtype_pulldown','subcatid','subcatname','catname','service_subcategories','product_categories','subcmd','id','submit','description','name','checked_profile_group_active','input_style','remote_addr','rid','login_include','headinclude','area_title','page_title','lanceads_header','lanceads_footer');
                
                ($apihook = $ilance->api('admincp_skills_end')) ? eval($apihook) : false;

                $ilance->template->load_file('main', 'skills.html', 1);
                $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                $ilance->template->parse_loop('main', 'v3nav');
                $ilance->template->parse_loop('main', 'subnav_settings');                
                $ilance->template->parse_loop('main', 'servicecategories');
                $ilance->template->parse_if_blocks('main');
                $ilance->template->pprint('main', $pprint_array);
                exit();
        }
        
        // #### UPDATE USER REGISTRATION QUESTIONS #############################
        else if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == '_update-customer-profile-questions' AND isset($ilance->GPC['uid']) AND $ilance->GPC['uid'] > 0)
        {
                // process custom registration questions
                if (!empty($ilance->GPC['custom']) AND is_array($ilance->GPC['custom']))
                {
                        //$ilance->registration = construct_object('api.registration');
                        //$ilance->registration->process_custom_register_questions($ilance->GPC['custom'], intval($ilance->GPC['uid']));
                }
                
                print_action_success($phrase['_profile_answers_were_updated_for_this_profile_an_email_was_not_sent'], $ilpage['subscribers'] . '?subcmd=_update-customer&id='.intval($ilance->GPC['uid']));
                exit();        
        }
        
        // #### UPDATE USER REGISTRATION QUESTIONS #############################
        else if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == '_update-customer-register-questions' AND isset($ilance->GPC['uid']) AND $ilance->GPC['uid'] > 0)
        {
                // process custom registration questions
                if (!empty($ilance->GPC['custom']) AND is_array($ilance->GPC['custom']))
                {
                        $ilance->registration = construct_object('api.registration');
                        $ilance->registration->process_custom_register_questions($ilance->GPC['custom'], intval($ilance->GPC['uid']));
                }
                
                print_action_success($phrase['_registration_answers_were_updated_for_this_profile_an_email_was_not_sent_to_the_customer'], $ilpage['subscribers'].'?subcmd=_update-customer&id='.intval($ilance->GPC['uid']));
                exit();        
        }
        
        // #### REMOVE CUSTOM REGISTRATION ANSWER FOR A SUBSCRIBER #############
        else if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == '_remove-answer' AND isset($ilance->GPC['id']) AND $ilance->GPC['id'] > 0 AND isset($ilance->GPC['uid']) AND $ilance->GPC['uid'] > 0)
        {
                $ilance->db->query("
                        DELETE FROM " . DB_PREFIX . "register_answers
                        WHERE answerid = '" . intval($ilance->GPC['id']) . "'
                        AND user_id = '".intval($ilance->GPC['uid'])."'
                ");
                
                print_action_success($phrase['_you_have_removed_a_registration_answer_for_this_user_an_email_was_not_sent'], $ilpage['subscribers'].'?subcmd=_update-customer&id='.intval($ilance->GPC['uid']));
                exit();
        }
    
        // #### save role ######################################################
        else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == '_do-role-change')
        {
                if (!empty($ilance->GPC['roleid']) AND !empty($ilance->GPC['uid']))
                {
                        // admin is changing the role for this user
                        $ilance->db->query("
                                UPDATE " . DB_PREFIX . "subscription_user
                                SET roleid = '".intval($ilance->GPC['roleid'])."'
                                WHERE user_id = '".intval($ilance->GPC['uid'])."'
                        ");
                }
                
                print_action_success($phrase['_you_have_updated_the_role_for_this_user'], $ilpage['subscribers'].'?subcmd=_update-customer&id='.intval($ilance->GPC['uid']));		
        }
            
        // #### REMOVE SINGLE SUBSCRIBER (CANNOT BE UNDONE) ####################
        else if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == '_remove-customer' AND $ilance->GPC['id'] > 0)
        {
                $sql = $ilance->db->query("
                        SELECT *
                        FROM " . DB_PREFIX . "users
                        WHERE user_id = '" . intval($ilance->GPC['id']) . "'
                ");
                if ($ilance->db->num_rows($sql) > 0)
                {
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "attachment WHERE user_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "attachment_folder WHERE buyer_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "attachment_folder WHERE seller_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "audit WHERE user_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "bankaccounts WHERE user_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "creditcards WHERE user_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "emaillog WHERE user_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "invoicelog WHERE user_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "messages WHERE user_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "portfolio WHERE user_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "register_answers WHERE user_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "profile_answers WHERE user_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "profile_categories WHERE user_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "profile_filter_auction_answers WHERE user_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "project_bid_retracts WHERE user_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "project_invitations WHERE buyer_user_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "project_invitations WHERE seller_user_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "referral_data WHERE user_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "sessions WHERE userid = '" . intval($ilance->GPC['id']) . "' AND isuser = '1'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "subscriptionlog WHERE user_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "subscription_user WHERE user_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "subscription_user_exempt WHERE user_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "users WHERE user_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "watchlist WHERE user_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "watchlist WHERE watching_user_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "search_users WHERE user_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "search_favorites WHERE user_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "sessions WHERE userid = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "skills_answers WHERE user_id = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "calendar WHERE userid = '" . intval($ilance->GPC['id']) . "'");
                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "feedback_ratings WHERE user_id = '" . intval($ilance->GPC['id']) . "'");
                        
                        // invoices
                        // $ilance->db->query("DELETE FROM " . DB_PREFIX . "invoices WHERE user_id = '" . intval($userid) . "'");
                        // $ilance->db->query("DELETE FROM " . DB_PREFIX . "invoices WHERE p2b_user_id = '" . intval($userid) . "'");
                        
                        // projects
                        // $ilance->db->query("DELETE FROM " . DB_PREFIX . "projects WHERE user_id = '" . intval($userid) . "'");
                        
                        // projects escrow
                        // $ilance->db->query("DELETE FROM " . DB_PREFIX . "projects_escrow WHERE user_id = '" . intval($ilance->GPC['id']) . "'");
                        // $ilance->db->query("DELETE FROM " . DB_PREFIX . "projects_escrow WHERE project_user_id = '" . intval($ilance->GPC['id']) . "'");
                        
                        // buy now orders
                        // $ilance->db->query("DELETE FROM " . DB_PREFIX . "buynow_orders WHERE owner_id = '" . intval($userid) . "'");
                        // $ilance->db->query("DELETE FROM " . DB_PREFIX . "buynow_orders WHERE buyer_id = '" . intval($userid) . "'");
                        
                        // bids
                        // $ilance->db->query("DELETE FROM " . DB_PREFIX . "project_bids WHERE user_id = '" . intval($userid) . "'");
                        // $ilance->db->query("DELETE FROM " . DB_PREFIX . "project_bid_retracts WHERE user_id = '" . intval($userid) . "'");
                        // $ilance->db->query("DELETE FROM " . DB_PREFIX . "projects_uniquebids WHERE user_id = '" . intval($userid) . "'");
                        // $ilance->db->query("DELETE FROM " . DB_PREFIX . "projects_uniquebids WHERE project_user_id = '" . intval($userid) . "'");
                        // $ilance->db->query("DELETE FROM " . DB_PREFIX . "project_realtimebids WHERE user_id = '" . intval($userid) . "'");
                        // $ilance->db->query("DELETE FROM " . DB_PREFIX . "proxybid WHERE user_id = '" . intval($userid) . "'");
                        
                        print_action_success($phrase['_the_selected_user_was_removed_from_the_marketplace_indefinately'], $ilpage['subscribers']);
                        exit();
                }
                else
                {
                        print_action_failed($phrase['_the_selected_user_was_not_found_to_be_removed_from_the_marketplace'], $ilpage['subscribers']);
                        exit();
                }
        }
        
        // #### REMOVE MULTIPLE SUBSCRIBERS ####################################
        else if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == '_remove-customers')
        {
                if (isset($ilance->GPC['user_id']) AND is_array($ilance->GPC['user_id']))
                {
                        // empty inline cookie
                        set_cookie('inlinemembers', '', false);
                        
                        $removedusers = '';
                        foreach ($ilance->GPC['user_id'] as $inc => $userid)
                        {
                                $sql = $ilance->db->query("
                                        SELECT *
                                        FROM " . DB_PREFIX . "users
                                        WHERE user_id = '" . intval($userid) . "'
                                ");
                                if ($ilance->db->num_rows($sql) > 0)
                                {
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "attachment WHERE user_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "attachment_folder WHERE buyer_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "attachment_folder WHERE seller_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "audit WHERE user_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "bankaccounts WHERE user_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "creditcards WHERE user_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "emaillog WHERE user_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "invoicelog WHERE user_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "messages WHERE user_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "portfolio WHERE user_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "register_answers WHERE user_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "profile_answers WHERE user_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "profile_categories WHERE user_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "profile_filter_auction_answers WHERE user_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "project_bid_retracts WHERE user_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "project_invitations WHERE buyer_user_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "project_invitations WHERE seller_user_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "referral_data WHERE user_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "sessions WHERE userid = '" . intval($userid) . "' AND isuser = '1'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "subscriptionlog WHERE user_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "subscription_user WHERE user_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "subscription_user_exempt WHERE user_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "users WHERE user_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "watchlist WHERE user_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "watchlist WHERE watching_user_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "search_users WHERE user_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "search_favorites WHERE user_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "sessions WHERE userid = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "skills_answers WHERE user_id = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "calendar WHERE userid = '" . intval($userid) . "'");
                                        $ilance->db->query("DELETE FROM " . DB_PREFIX . "feedback_ratings WHERE user_id = '" . intval($userid) . "'");
                                        
                                        // invoices
                                        // $ilance->db->query("DELETE FROM " . DB_PREFIX . "invoices WHERE user_id = '" . intval($userid) . "'");
                                        // $ilance->db->query("DELETE FROM " . DB_PREFIX . "invoices WHERE p2b_user_id = '" . intval($userid) . "'");
                                        
                                        // projects
                                        // $ilance->db->query("DELETE FROM " . DB_PREFIX . "projects WHERE user_id = '" . intval($userid) . "'");
                                        
                                        // projects escrow
                                        // $ilance->db->query("DELETE FROM " . DB_PREFIX . "projects_escrow WHERE user_id = '" . intval($ilance->GPC['id']) . "'");
                                        // $ilance->db->query("DELETE FROM " . DB_PREFIX . "projects_escrow WHERE project_user_id = '" . intval($ilance->GPC['id']) . "'");
                                        
                                        // buy now orders
                                        // $ilance->db->query("DELETE FROM " . DB_PREFIX . "buynow_orders WHERE owner_id = '" . intval($userid) . "'");
                                        // $ilance->db->query("DELETE FROM " . DB_PREFIX . "buynow_orders WHERE buyer_id = '" . intval($userid) . "'");
                                        
                                        // bids
                                        // $ilance->db->query("DELETE FROM " . DB_PREFIX . "project_bids WHERE user_id = '" . intval($userid) . "'");
                                        // $ilance->db->query("DELETE FROM " . DB_PREFIX . "project_bid_retracts WHERE user_id = '" . intval($userid) . "'");
                                        // $ilance->db->query("DELETE FROM " . DB_PREFIX . "projects_uniquebids WHERE user_id = '" . intval($userid) . "'");
                                        // $ilance->db->query("DELETE FROM " . DB_PREFIX . "projects_uniquebids WHERE project_user_id = '" . intval($userid) . "'");
                                        // $ilance->db->query("DELETE FROM " . DB_PREFIX . "project_realtimebids WHERE user_id = '" . intval($userid) . "'");
                                        // $ilance->db->query("DELETE FROM " . DB_PREFIX . "proxybid WHERE user_id = '" . intval($userid) . "'");
                                        
                                        $removedusers .= '<strong>'.fetch_user('username', intval($userid)).'</strong>, ';
                                }   
                        }
                        
                        $removedusers = mb_substr($removedusers, 0, -2);
                        
                        print_action_success($phrase['_the_selected_users_were_removed_from_the_marketplace_indefinately'] . " " . $removedusers . ". " . $phrase['_these_customers_will_not_be_able_to_login_to_the_marketplace_unless'], $ilpage['subscribers']);
                        exit();
                }
                else
                {
                        print_action_failed($phrase['_no_customers_were_selected_for_removal_please_try_again'], $ilpage['subscribers']);
                        exit();
                }
        }
            
        // #### REMOVE SUBSCRIPTION PERMISSION EXEMPTION #######################
        else if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == '_remove-exemption' AND isset($ilance->GPC['id']) AND $ilance->GPC['id'] > 0 AND isset($ilance->GPC['uid']) AND $ilance->GPC['uid'] > 0)
        {
                $ilance->db->query("
                        DELETE FROM " . DB_PREFIX . "subscription_user_exempt
                        WHERE exemptid = '" . intval($ilance->GPC['id']) . "'
                            AND user_id = '".$ilance->GPC['uid']."'
                        LIMIT 1
                ");
                
                print_action_success($phrase['_the_selected_exemption_was_removed_from_the_customers_subscription'], $ilpage['subscribers'].'?subcmd=_update-customer&amp;id='.intval($ilance->GPC['uid']));
                exit();
        }
            
        // #### SUSPEND CUSTOMER ###############################################
        else if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == '_suspend-customer' AND $ilance->GPC['id'] > 0)
        {
                $ilance->db->query("
                        UPDATE " . DB_PREFIX . "users
                        SET status = 'suspended'
                        WHERE user_id = '" . intval($ilance->GPC['id']) . "'
                        LIMIT 1
                ");
                
                print_action_success($phrase['_the_selected_customer_was_suspended_this_customer_will_not_be_able'], $ilpage['subscribers']);
                exit();
        }
        
        // #### ACTIVATE CUSTOMER ##############################################
        else if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == '_activate-customer' AND $ilance->GPC['id'] > 0)
        {
                $ilance->db->query("
                        UPDATE " . DB_PREFIX . "users
                        SET status = 'active'
                        WHERE user_id = '" . intval($ilance->GPC['id']) . "'
                        LIMIT 1
                ");
                
                print_action_success($phrase['_the_selected_customer_was_reactivated_from_the_existing_status'], $ilpage['subscribers']);
                exit();
        }
            
        // #### CREATE NEW CUSTOMER ############################################
        else if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == '_create-new-customer' AND $ilance->GPC['password'] == $ilance->GPC['password2'] AND isset($ilance->GPC['username']) AND isset($ilance->GPC['email']) AND isset($ilance->GPC['secretanswer']))
        {           
                $sql = $ilance->db->query("
                        SELECT locationid
                        FROM " . DB_PREFIX . "locations
                        WHERE location_" . $_SESSION['ilancedata']['user']['slng'] . " = '" . $ilance->db->escape_string($ilance->GPC['country']) . "'
                        LIMIT 1
                ");
                $res = $ilance->db->fetch_array($sql);
                        
                $salt = construct_password_salt($length = 5);
                
                $ilance->GPC['isadmin'] = (isset($ilance->GPC['isadmin']) AND $ilance->GPC['isadmin']) ? 1 : 0;
                $ilance->GPC['dob'] = '0000-00-00';
                
                $newuserid = $ilance->admincp->construct_new_member(
                        $ilance->GPC['username'],
                        md5(md5($ilance->GPC['password']) . $salt),
                        $salt,
                        $ilance->GPC['secretquestion'],
                        md5($ilance->GPC['secretanswer']),
                        $ilance->GPC['email'],
                        $ilance->GPC['firstname'],
                        $ilance->GPC['lastname'],
                        $ilance->GPC['address'],
                        $ilance->GPC['address2'],
                        $ilance->GPC['city'],
                        $ilance->GPC['state'],
                        $ilance->GPC['zipcode'],
                        $ilance->GPC['phone'],
                        $res['locationid'],
                        $ilance->GPC['dob'],
                        create_referral_code(6),
                        $ilconfig['globalserverlanguage_defaultlanguage'],
                        $ilconfig['globalserverlocale_defaultcurrency'],
                        $ilconfig['globalserverlocale_officialtimezone'],
                        $usertimezone_dst = 0,
                        $categories = '',
                        $ilance->GPC['isadmin']
                );
                
                // is account bonus active?
                $accountbonus = 0;
                if ($ilconfig['registrationupsell_bonusactive'] AND empty($ilance->GPC['bonusdisable']))
                {
                        $accountbonus = construct_account_bonus($newuserid, 'active');
                }
                
                // let's build users subscription
                $ilance->registration = construct_object('api.registration');
                
                // role id
                $ilance->GPC['roleid'] = isset($ilance->GPC['roleid']) ? intval($ilance->GPC['roleid']) : '-1';
                
                // invoice methods can be:
                // account, purchaseorder
                $ilance->registration->build_user_subscription($newuserid, intval($ilance->GPC['subscriptionid']), 'account', $promocode = '', $ilance->GPC['roleid']);
                
                $ilance->email = construct_dm_object('email', $ilance);
                
                if (isset($ilance->GPC['notifyregister']) AND $ilance->GPC['notifyregister'])
                {  
                            $ilance->email->mail = $ilance->GPC['email'];
                            $ilance->email->slng = fetch_user_slng($newuserid);
                            
                            $ilance->email->get('register_welcome_email_admincp');		
                            $ilance->email->set(array(
                                    '{{username}}' => $ilance->GPC['username'],
                                    '{{user_id}}' => $newuserid,
                                    '{{first_name}}' => $ilance->GPC['firstname'],
                                    '{{last_name}}' => $ilance->GPC['lastname'],
                                    '{{phone}}' => $ilance->GPC['phone'],
                                    '{{email}}' => $ilance->GPC['email'],
                            ));
                            
                            $ilance->email->send();
                }
                
                $ilance->email->mail = SITE_EMAIL;
                $ilance->email->slng = fetch_site_slng();
                    
                $ilance->email->get('register_welcome_email_admin_admincp');		
                $ilance->email->set(array(
                        '{{username}}' => $ilance->GPC['username'],
                        '{{user_id}}' => $newuserid,
                        '{{first_name}}' => $ilance->GPC['firstname'],
                        '{{last_name}}' => $ilance->GPC['lastname'],
                        '{{phone}}' => $ilance->GPC['phone'],
                        '{{email}}' => $ilance->GPC['email'],
                ));
                    
                $ilance->email->send();
                
                print_action_success($phrase['_the_new_customer_was_created_the_new_customer_will_be_required_to'], $ilance->GPC['return']);
                exit();
        }
    
        // #### UPDATE CUSTOMER PROFILE ########################################	
        else if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == '_update-customer-profile' AND $ilance->GPC['id'] > 0)
        {
                $country = $ilance->db->escape_string($ilance->GPC['country']);
                $ilance->GPC['locationid'] = intval(fetch_country_id($country));
                
                $ipres = '0';
                if (isset($ilance->GPC['iprestrict']) AND $ilance->GPC['iprestrict'])
                {
                        $ipres = '1';
                }
        
                $passwordsql = '';
                if (!empty($ilance->GPC['password']))
                {
                        $newsalt = construct_password_salt($length = 5);
                        $newpassword = md5(md5($ilance->db->escape_string($ilance->GPC['password'])) . $newsalt);
                        $passwordsql = "password = '" . $newpassword . "',";
                        $passwordsql .= "salt = '" . $newsalt . "',";
                }
        
                $status = isset($ilance->GPC['status']) ? $ilance->db->escape_string($ilance->GPC['status']) : 'unverified';
                $dob = isset($ilance->GPC['dob']) ? $ilance->db->escape_string($ilance->GPC['dob']) : '0000-00-00';
                $isadmin = isset($ilance->GPC['isadmin']) ? intval($ilance->GPC['isadmin']) : '0';
        
                // detect if this user is moderated and if admin is changing status from 'moderated' to 'active'
                $oldstatus = fetch_user('status', intval($ilance->GPC['id']));
                if ($oldstatus == 'moderated' AND $status == 'active')
                {
                        // user is moderated and admin is now validating him
                        $ilance->email = construct_dm_object('email', $ilance);
                
                        $ilance->email->mail = $ilance->GPC['email'];
                        $ilance->email->slng = fetch_user_slng(intval($ilance->GPC['id']));
                        
                        $ilance->email->get('register_welcome_email');		
                        $ilance->email->set(array(
                                '{{username}}' => $ilance->GPC['username'],
                                '{{user_id}}' => intval($ilance->GPC['id']),
                                '{{first_name}}' => $ilance->GPC['first_name'],
                                '{{last_name}}' => $ilance->GPC['last_name'],
                                '{{phone}}' => $ilance->GPC['phone'],
                                '{{email}}' => $ilance->GPC['email'],
                        ));
                        
                        $ilance->email->send();
                        
                        // additionally, we'll run our account bonus function so this email is also dispatched
                        $registerbonus = '0.00';
                        if ($ilconfig['registrationupsell_bonusactive'])
                        {
                                // lets construct a little payment bonus for new member, we will:
                                // - create a transaction and send email to user and admin
                                // - return the bonus amount so we can update the users account
                                $registerbonus = construct_account_bonus(intval($ilance->GPC['id']), $status);
                                if ($registerbonus > 0)
                                {
                                        // update register bonus credit to online account data
                                        $ilance->db->query("
                                                UPDATE " . DB_PREFIX . "users
                                                SET total_balance = total_balance + " . $registerbonus . ",
                                                available_balance = available_balance + " . $registerbonus . "
                                                WHERE user_id = '" . intval($ilance->GPC['id']) . "'
                                        ");
                                }
                        }
                }
        
                
                // check if username already exists!!
                // quick username checkup
                $show['error_username'] = false;
                
                if (isset($ilance->GPC['username']) AND $ilance->GPC['username'] != '')
                {
                        $unicode_name = preg_replace('/&#([0-9]+);/esiU', "convert_int2utf8('\\1')", $ilance->GPC['username']);
                        
                        // username ban checkup
                        if ($ilance->common->is_username_banned($ilance->GPC['username']) OR $ilance->common->is_username_banned($unicode_name))
                        {
                                $show['error_username'] = true;
                        }
                        else
                        {
                                $sqlusercheck = $ilance->db->query("
                                        SELECT *
                                        FROM " . DB_PREFIX . "users
                                        WHERE username IN ('" . addslashes(htmlspecialchars_uni($ilance->GPC['username'])) . "', '" . addslashes(htmlspecialchars_uni($unicode_name)) . "')
                                                AND user_id != '" . intval($ilance->GPC['id']) . "'
                                ");
                                if ($ilance->db->num_rows($sqlusercheck) > 0)
                                {
                                        $show['error_username'] = true;
                                }
                                else
                                {
                                        $ilance->GPC['username'] = stripslashes(strip_tags(trim($ilance->GPC['username'])));
                                }
                        }
                }
                else
                {
                        $show['error_username'] = true;
                }
                
                if ($show['error_username'])
                {
                        print_action_failed($phrase['_sorry_the_username_you_entered_appears_to_be_in_the_username_ban_list'], $ilpage['subscribers'] . '?subcmd=_update-customer&id=' . intval($ilance->GPC['id']));
                        exit();
                }

                $ilance->db->query("
                        UPDATE " . DB_PREFIX . "users
                        SET username = '" . $ilance->db->escape_string($ilance->GPC['username']) . "',
                        $passwordsql
                        email = '" . $ilance->db->escape_string($ilance->GPC['email']) . "',
                        first_name = '" . $ilance->db->escape_string($ilance->GPC['first_name']) . "',
                        last_name = '" . $ilance->db->escape_string($ilance->GPC['last_name']) . "',
                        address = '" . $ilance->db->escape_string($ilance->GPC['address']) . "',
                        address2 = '" . $ilance->db->escape_string($ilance->GPC['address2']) . "',
                        city = '" . $ilance->db->escape_string($ilance->GPC['city']) . "',
                        state = '" . $ilance->db->escape_string($ilance->GPC['state']) . "',
                        zip_code = '" . $ilance->db->escape_string($ilance->GPC['zip_code']) . "',
                        phone = '" . $ilance->db->escape_string($ilance->GPC['phone']) . "',
                        country = '" . $ilance->GPC['locationid'] . "',
                        ipaddress = '" . $ilance->db->escape_string($ilance->GPC['ipaddress']) . "',
                        iprestrict = '" . $ipres . "',
                        status = '" . $status . "',
                        dob = '" . $dob . "',
                        isadmin = '" . $isadmin . "'
                        WHERE user_id = '" . intval($ilance->GPC['id']) . "'
                        LIMIT 1
                ");
                    
                if (isset($ilance->GPC['emailuser']) AND $ilance->GPC['emailuser'])
                {
                        $notice = $phrase['_the_customers_profile_has_been_updated_with_new_changes_and_the_password_was_reset'];                        
                        $email['message'] = $phrase['_dear'] . " " . $ilance->GPC['username'] . ",\n\nThis email is to inform you that you password was reset by an ".SITE_NAME." staff member as you have requested.  Please find your new login information below:\n\n===========================\nUsername: ".$ilance->GPC['username']."\nPassword: ".$ilance->GPC['password']."\n===========================\n\nSincerely,\n".SITE_NAME." ".HTTP_SERVER;
                        
                        send_email($ilance->GPC['email'], "Your email address was changed at " . SITE_NAME . " - Please read", $email['message'], SITE_EMAIL);
                }
                else
                {
                        $notice = $phrase['_the_customers_profile_has_been_updated_with_new_changes_changes'];
                }
                
                print_action_success($notice, $ilpage['subscribers'] . '?subcmd=_update-customer&amp;id=' . intval($ilance->GPC['id']));
                exit();
        }
            
        // #### SUBSCRIPTION PLAN RE-ASSIGNMENT ################################
        else if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == '_create-subscription' AND $ilance->GPC['id'] > 0)
        {
                $ilance->admincp->upgrade_subscription(intval($ilance->GPC['id']), intval($ilance->GPC['subscriptionid']), $ilance->GPC['txndescription'], $ilance->GPC['action']);
                
                print_action_success($phrase['_the_customer_has_been_reassigned_with_the_selected_subscription_plan'], $ilpage['subscribers'].'?subcmd=_update-customer&amp;id='.intval($ilance->GPC['id']));
                exit();
        }
            
        // #### ADMIN ASSIGNS NEW SUBSCRIPTION EXEMPTION PERMISSION TO MEMBER
        else if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == '_create-exemption' AND isset($ilance->GPC['id']) AND $ilance->GPC['id'] > 0)
        {
                $ilance->subscription = construct_object('api.subscription');
                if ($ilance->subscription->construct_subscription_exemption(intval($ilance->GPC['id']), $ilance->GPC['accessname'], $ilance->GPC['exemptvalue'], $ilance->GPC['exemptcost'], $ilance->GPC['exemptdays'], $ilance->GPC['logic'], $ilance->GPC['description']))
                {
                        print_action_success($phrase['_the_customer_has_been_assigned_with_the_selected_subscription_permission_exemption'], $ilpage['subscribers'].'?subcmd=_update-customer&amp;id='.intval($ilance->GPC['id']));
                        exit();
                }
                else 
                {
                        print_action_failed($phrase['_there_was_a_problem_with_the_action_selected_this_may_be_due_to_the_customer_not_having_sufficient_funds'], $ilpage['subscribers'].'?subcmd=_update-customer&amp;id='.intval($ilance->GPC['id']));
                        exit();
                }
        }
            
        // #### MANUALLY AUTHORIZE CUSTOMER CREDIT CARD FOR USAGE ##############
        else if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == '_authorize-creditcard' AND $ilance->GPC['id'] > 0 AND $ilance->GPC['uid'] > 0)
        {
                $ilance->db->query("
                        UPDATE " . DB_PREFIX . "creditcards
                        SET authorized = 'yes'
                        WHERE cc_id = '" . intval($ilance->GPC['id']) . "'
                        LIMIT 1
                ");
                
                if (isset($ilance->GPC['ccmgr']) AND $ilance->GPC['ccmgr'] == 1)
                {
                        print_action_success($phrase['_the_selected_credit_card_was_manually_authorized_verified_from_administration'], $ilpage['accounting'] . '?cmd=creditcards');
                        exit();
                }
                else
                {
                        print_action_success($phrase['_the_selected_credit_card_was_manually_authorized_verified_from_administration'], $ilpage['subscribers'] . '?subcmd=_update-customer&amp;id=' . intval($ilance->GPC['uid']));
                        exit();
                }
        }
            
        else if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == '_unauthorize-creditcard' AND isset($ilance->GPC['id']) AND $ilance->GPC['id'] > 0  AND isset($ilance->GPC['uid']) AND $ilance->GPC['uid'] > 0)
        {
                $ilance->db->query("
                        UPDATE " . DB_PREFIX . "creditcards
                        SET authorized = 'no'
                        WHERE cc_id = '" . intval($ilance->GPC['id']) . "'
                        LIMIT 1
                ");

                if (isset($ilance->GPC['ccmgr']) AND $ilance->GPC['ccmgr'] == 1)
                {
                        print_action_success($phrase['_the_selected_credit_card_was_manually_unauthorized_and_this_customer_will_be_required_to_manually_verify'], $ilpage['accounting'] . '?cmd=creditcards');
                        exit();
                }
                else
                {
                        print_action_success($phrase['_the_selected_credit_card_was_manually_unauthorized_and_this_customer_will_be_required_to_manually_verify'], $ilpage['subscribers'] . '?subcmd=_update-customer&amp;id=' . intval($ilance->GPC['uid']));
                        exit();
                }
        }
            
        else if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == '_remove-creditcard' AND $ilance->GPC['id'] > 0 AND $ilance->GPC['uid'] > 0)
        {
                $ilance->db->query("
                        DELETE FROM " . DB_PREFIX . "creditcards
                        WHERE cc_id = '" . intval($ilance->GPC['id']) . "'
                        LIMIT 1
                ");
                
                if (isset($ilance->GPC['ccmgr']) AND $ilance->GPC['ccmgr'] == 1)
                {
                        print_action_success($phrase['_the_selected_credit_card_was_removed_from_the_customers_profile_this_customer_will_be_required_to_verify_any'], $ilpage['accounting'] . '?cmd=creditcards');
                        exit();
                }
                else
                {
                        print_action_success($phrase['_the_selected_credit_card_was_removed_from_the_customers_profile_this_customer_will_be_required_to_verify_any'], $ilpage['subscribers'] . '?subcmd=_update-customer&amp;id=' . intval($ilance->GPC['uid']));
                        exit();
                }
        }
        else if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == '_remove-bankaccount' AND $ilance->GPC['id'] > 0 AND $ilance->GPC['uid'] > 0)
        {
                $ilance->db->query("
                        DELETE FROM " . DB_PREFIX . "bankaccounts
                        WHERE bank_id = '" . intval($ilance->GPC['id']) . "'
                ");
                
                print_action_success($phrase['_the_selected_bank_account_was_removed_from_the_customers_profile'], $ilpage['subscribers'].'?subcmd=_update-customer&amp;id='.intval($ilance->GPC['uid']));
                exit();
        }
        else if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == '_remove-transaction' AND $ilance->GPC['id'] > 0 AND $ilance->GPC['uid'] > 0)
        {
                $ilance->db->query("
                        DELETE FROM " . DB_PREFIX . "invoices
                        WHERE invoiceid = '" . intval($ilance->GPC['id']) . "'
                ");
                
                print_action_success($phrase['_the_selected_transaction_was_removed_from_the_transaction_system'], $ilpage['subscribers'].'?subcmd=_update-customer&amp;id='.intval($ilance->GPC['uid']));
                exit();
        }
        else if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == '_create-transaction' AND $ilance->GPC['id'] > 0)
        {
                if (isset($ilance->GPC['action']) AND $ilance->GPC['action'] == "debit" AND $ilance->GPC['amount'] > 0)
                {
                        $sql = $ilance->db->query("
                                SELECT available_balance, total_balance
                                FROM " . DB_PREFIX . "users
                                WHERE user_id = '" . intval($ilance->GPC['id']) . "'
                        ");
                        if ($ilance->db->num_rows($sql) > 0)
                        {
                                $res = $ilance->db->fetch_array($sql);
                                $new_debit_amount = $ilance->GPC['amount'];
                                
                                $total_now = $res['total_balance'];
                                $avail_now = $res['available_balance'];
                                
                                $new_total_now = ($total_now - $new_debit_amount);
                                $new_avail_now = ($avail_now - $new_debit_amount);
                                
                                $ilance->db->query("
                                        UPDATE " . DB_PREFIX . "users
                                        SET total_balance = '" . $new_total_now . "',
                                        available_balance = '" . $new_avail_now . "'
                                        WHERE user_id = '" . intval($ilance->GPC['id']) . "'
                                ");
                        
                                $ilance->accounting = construct_object('api.accounting');
                                $ilance->accounting->insert_transaction(
                                        0,
                                        0,
                                        0,
                                        intval($ilance->GPC['id']),
                                        0,
                                        0,
                                        0,
                                        $ilance->GPC['description'],
                                        sprintf("%01.2f", $new_debit_amount),
                                        sprintf("%01.2f", $new_debit_amount),
                                        'paid',
                                        'debit',
                                        'account',
                                        DATETIME24H,
                                        DATEINVOICEDUE,
                                        DATETIME24H,
                                        $ilance->GPC['custom'],
                                        0,
                                        0,
                                        0
                                );
                                    
                                $sqlemail = $ilance->db->query("
                                        SELECT email, username, first_name, last_name
                                        FROM " . DB_PREFIX . "users
                                        WHERE user_id = '" . intval($ilance->GPC['id']) . "'
                                ");
                                if ($ilance->db->num_rows($sqlemail) > 0)
                                {
                                        $resemail = $ilance->db->fetch_array($sqlemail);
                                        
                                        $ilance->email = construct_dm_object('email', $ilance);
                
                                        $ilance->email->mail = $resemail['email'];
                                        $ilance->email->slng = fetch_user_slng(intval($ilance->GPC['id']));
                                        
                                        $ilance->email->get('account_debit_notification');		
                                        $ilance->email->set(array(
                                                '{{customer}}' => $resemail['username'],
                                                '{{amount}}' => $ilance->currency->format($ilance->GPC['amount']),
                                        ));
                                        
                                        $ilance->email->send();
                                        
                                        $ilance->email->mail = SITE_EMAIL;
                                        $ilance->email->slng = fetch_site_slng();
                                        
                                        $ilance->email->get('account_debit_notification_admin');		
                                        $ilance->email->set(array(
                                                '{{customer}}' => $resemail['username'],
                                                '{{amount}}' => $ilance->currency->format($ilance->GPC['amount']),
                                        ));
                                        
                                        $ilance->email->send();
                                        
                                        print_action_success($phrase['_a_new_transaction_debit_was_successfully_created_and_the_customers'], $ilpage['subscribers'].'?subcmd=_update-customer&amp;id='.intval($ilance->GPC['id']));
                                        exit();
                                }
                        }
                }
                else if (isset($ilance->GPC['action']) AND $ilance->GPC['action'] == 'credit' AND $ilance->GPC['amount'] > 0)
                {
                        $sql = $ilance->db->query("
                                SELECT available_balance, total_balance
                                FROM " . DB_PREFIX . "users
                                WHERE user_id = '" . intval($ilance->GPC['id']) . "'
                        ");
                        if ($ilance->db->num_rows($sql) > 0)
                        {
                                $res = $ilance->db->fetch_array($sql);
                                $new_credit_amount = $ilance->GPC['amount'];
                                
                                $total_now = $res['total_balance'];
                                $avail_now = $res['available_balance'];
                                
                                $new_total_now = ($total_now + $new_credit_amount);
                                $new_avail_now = ($avail_now + $new_credit_amount);
                                
                                $ilance->db->query("
                                        UPDATE " . DB_PREFIX . "users
                                        SET total_balance = '" . $new_total_now . "',
                                        available_balance = '" . $new_avail_now . "'
                                        WHERE user_id = '" . intval($ilance->GPC['id']) . "'");
                
                                $ilance->accounting = construct_object('api.accounting');
                                $ilance->accounting->insert_transaction(
                                        0,
                                        0,
                                        0,
                                        intval($ilance->GPC['id']),
                                        0,
                                        0,
                                        0,
                                        $ilance->GPC['description'],
                                        sprintf("%01.2f", $new_credit_amount),
                                        sprintf("%01.2f", $new_credit_amount),
                                        'paid',
                                        'credit',
                                        'account',
                                        DATETIME24H,
                                        DATEINVOICEDUE,
                                        DATETIME24H,
                                        $ilance->GPC['custom'],
                                        0,
                                        0,
                                        0
                                );
                    
                                $sqlemail = $ilance->db->query("
                                        SELECT email, username, first_name, last_name
                                        FROM " . DB_PREFIX . "users
                                        WHERE user_id = '" . intval($ilance->GPC['id']) . "'
                                ");
                                if ($ilance->db->num_rows($sqlemail) > 0)
                                {
                                        $resemail = $ilance->db->fetch_array($sqlemail);
                                        
                                        $ilance->email = construct_dm_object('email', $ilance);
                
                                        $ilance->email->mail = $resemail['email'];
                                        $ilance->email->slng = fetch_user_slng(intval($ilance->GPC['id']));
                                        
                                        $ilance->email->get('account_credit_notification');		
                                        $ilance->email->set(array(
                                                '{{customer}}' => $resemail['username'],
                                                '{{amount}}' => $ilance->currency->format($ilance->GPC['amount']),
                                        ));
                                        
                                        $ilance->email->send();
                                        
                                        $ilance->email->mail = SITE_EMAIL;
                                        $ilance->email->slng = fetch_site_slng();
                                        
                                        $ilance->email->get('account_credit_notification_admin');		
                                        $ilance->email->set(array(
                                                '{{customer}}' => $resemail['username'],
                                                '{{amount}}' => $ilance->currency->format($ilance->GPC['amount']),
                                        ));
                                        
                                        $ilance->email->send();
                                        
                                        print_action_success($phrase['_a_new_transaction_credit_was_successfully_created_and_the_customers'], $ilpage['subscribers'].'?subcmd=_update-customer&amp;id='.intval($ilance->GPC['id']));
                                        exit();						
                                }
                        }
                }
        }
        else
        {
                $ilance->subscription = construct_object('api.subscription');
            
                if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == '_update-customer' AND isset($ilance->GPC['id']) AND $ilance->GPC['id'] > 0)
                {
                        $area_title = $phrase['_viewing_customer_profile_id'] . '' . intval($ilance->GPC['id']);
                        $page_title = SITE_NAME.' - ' . $phrase['_viewing_customer_profile_id'] . '' . intval($ilance->GPC['id']);
                        
                        $subnav_settings = $ilance->admincp->print_admincp_subnav($ilpage['subscribers'], $ilpage['subscribers'], $_SESSION['ilancedata']['user']['slng']);
                        
                        $show['show_update'] = true;
                        $show['show_search'] = false;
                        
                        $sql = $ilance->db->query("
                                SELECT *
                                FROM " . DB_PREFIX . "users
                                WHERE user_id = '" . intval($ilance->GPC['id']) . "'
                                LIMIT 1
                        ");
                        if ($ilance->db->num_rows($sql) > 0)
                        {
                                while ($res = $ilance->db->fetch_array($sql))
                                {
                                        $res['username'] = stripslashes($res['username']);
                                        $res['first_name'] = stripslashes($res['first_name']);
                                        $res['last_name'] = stripslashes($res['last_name']);
                                        $res['phone'] = stripslashes($res['phone']);
                                        $res['address'] = stripslashes($res['address']);
                                        $res['address2'] = stripslashes($res['address2']);
                                        $res['city'] = stripslashes(ucfirst($res['city']));
                                        $res['zip_code'] = stripslashes(mb_strtoupper($res['zip_code']));
                                        
                                        if ($res['iprestrict'] == '1')
                                        {
                                                $res['restrict'] = '<input type="checkbox" name="iprestrict" value="1" checked="checked" />';
                                        }
                                        else
                                        {
                                                $res['restrict'] = '<input type="checkbox" name="iprestrict" value="1" />';
                                        }
                                                        
                                        $res['added'] = print_date($res['date_added'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0);
                                        $res['lastseen'] = print_date($res['lastseen'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0);
                                        
                                        $customername = "(" . $res['username'] . ")";
                                        
                                        ## DYNAMIC JAVASCRIPT COUNTRY PULLDOWN
                                        $sql_loc = $ilance->db->query("
                                                SELECT location_" . $_SESSION['ilancedata']['user']['slng'] . " AS location
                                                FROM " . DB_PREFIX . "locations
                                                WHERE locationid = '" . $res['country'] . "'
                                        ");
                                        $res_loc = $ilance->db->fetch_array($sql_loc);
                                        
                                        $jscity = $res['city'];
                                        
                                        $countryid = fetch_country_id($res_loc['location'], $_SESSION['ilancedata']['user']['slng']);
                                        $res['country_js_pulldown'] = construct_country_pulldown($countryid, $res_loc['location']);
                                        $res['state_js_pulldown'] = '<div id="stateid" style="height:20px">' . construct_state_pulldown($countryid, $res['state']) . '</div>';
                                        
                                        $roleid = fetch_user_roleid($res['user_id']);
                                        $roleselected = isset($roleid) ? intval($roleid) : '';
                                        $rolepulldown = print_role_pulldown($roleselected, '', 0);
                                            
                                        switch ($res['status'])
                                        {
                                                case 'active':
                                                {
                                                        $sel1 = 'selected="selected"';
                                                        $sel2 = $sel3 = $sel4 = $sel5 = $sel6 = '';
                                                        break;
                                                }
                                                case 'suspended':
                                                {
                                                        $sel1 = $sel3 = $sel4 = $sel5 = $sel6 = '';
                                                        $sel2 = 'selected="selected"';
                                                        break;
                                                }
                                                case 'unverified':
                                                {
                                                        $sel1 = $sel2 = $sel4 = $sel5 = $sel6 = '';
                                                        $sel3 = 'selected="selected"';
                                                        break;
                                                }       
                                                case 'banned':
                                                {
                                                        $sel1 = $sel2 = $sel3 = $sel5 = $sel6 = '';
                                                        $sel4 = 'selected="selected"';
                                                        break;
                                                }
                                                case 'cancelled':
                                                {
                                                        $sel1 = $sel2 = $sel3 = $sel4 = $sel6 = '';
                                                        $sel5 = 'selected="selected"';
                                                        break;
                                                }
                                                case 'moderated':
                                                {
                                                        $sel1 = $sel2 = $sel3 = $sel4 = $sel5 = '';
                                                        $sel6 = 'selected="selected"';
                                                        break;
                                                }
                                        }
                                        
                                        $res['userstatus'] = '<select name="status" style="font-family: Verdana">';
                                        $res['userstatus'] .= '<option value="active" ' . $sel1 . '>' . $phrase['_active_can_signin'] . '</option>';
                                        $res['userstatus'] .= '<option value="suspended" ' . $sel2 . '>' . $phrase['_suspended_cannot_signin'] . '</option>';
                                        $res['userstatus'] .= '<option value="unverified" ' . $sel3 . '>' . $phrase['_unverified_email_cannot_signin'] . '</option>';
                                        $res['userstatus'] .= '<option value="banned" ' . $sel4 . '>' . $phrase['_banned_cannot_signin'] . '</option>';
                                        $res['userstatus'] .= '<option value="cancelled" ' . $sel5 . '>' . $phrase['_cancelled_can_signin'] . '</option>';
                                        $res['userstatus'] .= '<option value="moderated" ' . $sel6 . '>' . $phrase['_moderated_cannot_signin'] . '</option>';
                                        $res['userstatus'] .= '</select>';
                                        
                                        if ($res['isadmin'])
                                        {
                                                $res['isadministrator'] = '<input type="checkbox" name="isadmin" id="isadmin" value="1" checked="checked" />';
                                        }
                                        else
                                        {
                                                $res['isadministrator'] = '<input type="checkbox" name="isadmin" id="isadmin" value="1" onclick="alert_js(\'' . $phrase['_please_remember_enabling_this_user_as_an_admin_will_provide_access_to_let_this_profile_signin_to_the_admin_control_panel_interface'] . '\')" />';
                                        }
                                        
                                        $profile[] = $res;
                                }
                        }
                                
                        $sql = $ilance->db->query("
                                SELECT account_number, available_balance, total_balance
                                FROM " . DB_PREFIX . "users
                                WHERE user_id = '" . intval($ilance->GPC['id']) . "'
                        ");
                        if ($ilance->db->num_rows($sql) > 0)
                        {
                                while ($res = $ilance->db->fetch_array($sql))
                                {
                                        $res['accountnumber'] = $res['account_number'];
                                        $res['availablebalance'] = $ilance->currency->format($res['available_balance']);
                                        $res['totalbalance'] = $ilance->currency->format($res['total_balance']);
                                        $profileaccount[] = $res;
                                }
                        }
                        
                        $currency = print_left_currency_symbol();
                        
                        // #### TRANSACTIONS HISTORY ###########################
                        if (!isset($ilance->GPC['page']) OR isset($ilance->GPC['page']) AND $ilance->GPC['page'] <= 0)
                        {
                                $ilance->GPC['page'] = 1;
                        }
                        else
                        {
                                $ilance->GPC['page'] = intval($ilance->GPC['page']);
                        }
                        
                        $rowlimit = $ilconfig['globalfilters_maxrowsdisplay'];
                        $limit = ' ORDER BY invoiceid DESC LIMIT '.(($ilance->GPC['page']-1)*$rowlimit).','.$rowlimit;
                        
                        $cntexe = $ilance->db->query("
                                SELECT COUNT(*) AS number FROM " . DB_PREFIX . "invoices
                                WHERE user_id = '" . intval($ilance->GPC['id']) . "' 
                                    AND status != 'scheduled'
                        ");
            
                        $cntarr = $ilance->db->fetch_array($cntexe);
                        $number = (int)$cntarr['number'];
                        
                        $counter = ($ilance->GPC['page']-1)*$rowlimit;
                        $row_count = 0;
                        
                        $res = $ilance->db->query("
                                SELECT *
                                FROM " . DB_PREFIX . "invoices 
                                WHERE user_id = '" . intval($ilance->GPC['id']) . "' 
                                    AND status != 'scheduled' 
                                $limit
                        ");
                        if ($ilance->db->num_rows($res) > 0)
                        {
                                $altrows = 0;
                                while ($row = $ilance->db->fetch_array($res))
                                {
                                        $altrows++;
                                        if (floor($altrows/2) == ($altrows/2))
                                        {
                                                $row['class'] = 'alt2';
                                        }
                                        else
                                        {
                                                $row['class'] = 'alt1';
                                        }
                                        $row['createdate'] = print_date($row['createdate'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0, 1, 0);
                                        if ($row['duedate'] == "0000-00-00 00:00:00")
                                        {
                                                $row['duedate'] = '-';
                                        }
                                        else
                                        {
                                                $row['duedate'] = print_date($row['duedate'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0, 1, 0);
                                        }
                                        
                                        if ($row['paiddate'] == "0000-00-00 00:00:00")
                                        {
                                                $row['paiddate'] = '-';
                                        }
                                        else
                                        {
                                                $row['paiddate'] = print_date($row['paiddate'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0, 1, 0);
                                        }
                                        
                                        $row['description'] = stripslashes($row['description']);
                                        if ($row['amount'] > 0)
                                        {
                                                $row['amount'] = $ilance->currency->format($row['totalamount']);
                                        }
                                        else if ($row['amount'] == 0)
                                        {
                                                $row['amount'] = $phrase['_free'];
                                        }
                                        
                                        if ($row['paid'] > 0)
                                        {
                                                $row['paid'] = $ilance->currency->format($row['paid']);
                                        }
                                        else if ($row['paid'] == 0)
                                        {
                                                $row['paid'] = $phrase['_free'];
                                        }
                                        
                                        $row['method'] = print_paymethod_icon($row['paymethod']);
                                        
                                        if ($row['status'] == 'unpaid')
                                        {
                                                $row['action'] = "<a href='".$ilpage['subscribers']."?subcmd=_remove-transaction&amp;id=".$row['invoiceid']."&amp;uid=" . intval($ilance->GPC['id']) . "' target='_self' onClick=\"return confirm('".$phrase['_please_take_a_moment_to_confirm_your_action']."')\"><img src='" . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . "icons/delete.gif' border=0 alt=''></a>";
                                                $row['status'] = $phrase['_pending'];
                                        }
                                        else
                                        {
                                                $row['action'] = "<a href='".$ilpage['subscribers']."?subcmd=_remove-transaction&amp;id=".$row['invoiceid']."&amp;uid=" . intval($ilance->GPC['id']) . "' target='_self' onClick=\"return confirm('".$phrase['_please_take_a_moment_to_confirm_your_action']."')\"><img src='" . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . "icons/delete.gif' border=0 alt=''></a>";
                                        }
                                        $transaction_rows[] = $row;
                                        $row_count++;
                                }
                        }
                        else
                        {
                            $show['no_rows_returned'] = true;
                        }
                        
                        $transactionsprevnext = print_pagnation($number, $rowlimit, $ilance->GPC['page'], $counter, $ilpage['subscribers']."?subcmd=_update-customer&amp;id=".intval($ilance->GPC['id']));
                        
                        $sqlpaidplan = $ilance->db->query("
                                SELECT subscriptionid
                                FROM " . DB_PREFIX . "subscription_user
                                WHERE user_id = '" . intval($ilance->GPC['id']) . "'
                        ");
                        if ($ilance->db->num_rows($sqlpaidplan) > 0)
                        {
                                $resplan = $ilance->db->fetch_array($sqlpaidplan);
                                $whichplan = $ilance->db->query("
                                        SELECT cost
                                        FROM " . DB_PREFIX . "subscription
                                        WHERE subscriptionid = '" . $resplan['subscriptionid'] . "'
                                ");
                                if ($ilance->db->num_rows($whichplan) > 0)
                                {
                                        $respaid = $ilance->db->fetch_array($whichplan);
                                        $thiscost = $respaid['cost'];
                                        
                                        if ($thiscost > 0)
                                        {
                                                $paidplan = 1;
                                        }
                                        else
                                        {
                                                $paidplan = 0;
                                        }
                                }
                        }
                        
                        $SQL = "
                                SELECT UNIX_TIMESTAMP(u.renewdate) - UNIX_TIMESTAMP('" . DATETIME24H . "') AS countdown, s.title, s.description, s.cost, s.length, s.units, u.subscriptionid, u.user_id, u.paymethod, u.startdate, u.renewdate, u.active, i.invoiceid, i.subscriptionid, i.paiddate
                                FROM " . DB_PREFIX . "subscription as s,
                                " . DB_PREFIX . "subscription_user as u,
                                " . DB_PREFIX . "invoices as i
                                WHERE u.user_id = '" . intval($ilance->GPC['id']) . "'
                                    AND u.subscriptionid = s.subscriptionid
                        ";
                        if (isset($paidplain) AND $paidplan)
                        {
                                $SQL .= "
                                            AND u.user_id = i.user_id
                                            AND u.subscriptionid = i.subscriptionid
                                        ORDER BY u.renewdate DESC
                                        LIMIT 1
                                ";
                        }
                        else
                        {
                                $SQL .= "
                                        ORDER BY u.renewdate DESC 
                                        LIMIT 1
                                ";
                        }
                                
                        $res = $ilance->db->query($SQL);
                        if ($ilance->db->num_rows($res) > 0)
                        {
                                while ($row = $ilance->db->fetch_array($res))
                                {
                                        $clock_js = "";
                                        
                                        $row['subscriptionid'] = $row['subscriptionid'];
                                        $row['title'] = stripslashes($row['title']);
                                        $row['description'] = stripslashes($row['description']);
                                        $row['startdate'] = print_date($row['startdate'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0, 1, 0);
                                        $row['renewdate'] = print_date($row['renewdate'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0, 1, 0);
                                        $renewdate_workwith = $row['renewdate'];
                                        $raw_cost = $row['cost'];
                                        if ($row['cost'] > 0)
                                        {
                                                $row['cost'] = $ilance->currency->format($row['cost']);
                                        }
                                        else if ($row['cost'] == 0)
                                        {
                                                $row['cost'] = $phrase['_free'];
                                        }
                                        
                                        if ($row['active'] == 'yes')
                                        {
                                                $row['status'] = $phrase['_active'];
                                                $row['action'] = '--';
                                                $renewal_countdown = 1;
                                                $onload = '';
                                        }
                                        else
                                        {
                                                $row['startdate'] = '--';
                                                $row['renewdate'] = '--';
                                                $row['status'] = $phrase['_inactive'];
                                                $renewal_countdown = 0;
                                                $onload = '';
                                                if ($paidplan == 1)
                                                {
                                                        $row['action'] = "<a href='" . HTTPS_SERVER . $ilpage['invoicepayment'] . "?id=" . $row['invoiceid'] . "'><img src='" . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . "icons/invoice.gif' border='0' alt='".$phrase['_pay_invoice']."' /></a>";
                                                }
                                                else
                                                {
                                                        $row['status'] = $phrase['_inactive'];
                                                }
                                        }
                                        
                                        $row['paymethod'] = print_paymethod_icon($row['paymethod']);
                                        
                                        $future_date = $renewdate_workwith;
                                        $maxdate = getdate(strtotime ($future_date));
                                        $mindate = getdate(strtotime (DATETODAY));
                                        $difference = $maxdate[0]-$mindate[0];
                                        $difference = $difference/24;
                                        $difference = $difference/60;
                                        $difference = $difference/60;
                                        $subscription_length = $ilance->subscription->subscription_length($row['units'], $row['length']);
                                        $length = $subscription_length;
                                        $length_left = $difference;
                                        $length_paid = $raw_cost;
                                        $row['units'] = print_unit($row['units']);
                                        $row['cost_daily'] = $ilance->currency->format(($length_paid / $length));
                                        $row['class'] = ($row_count % 2) ? 'alt2' : 'alt1';
                                        $subscription_rows[] = $row;
                                        $row_count++;
                                }
                                
                                $show['no_subscription_rows'] = false;
                        }
                        else
                        {
                                $show['no_subscription_rows'] = true;
                        }
                                
                        $sqlexempt = $ilance->db->query("
                                SELECT *
                                FROM " . DB_PREFIX . "subscription_user_exempt
                                WHERE user_id = '" . intval($ilance->GPC['id']) . "'
                        ");
                        if ($ilance->db->num_rows($sqlexempt) > 0)
                        {
                                $row_count = 0;
                                while ($resexempt = $ilance->db->fetch_array($sqlexempt))
                                {
                                        $resexempt['cost'] = $ilance->currency->format($ilance->db->fetch_field(DB_PREFIX."invoices","invoiceid=".$resexempt['invoiceid'],"amount"));
                                        if ($resexempt['active'])
                                        {
                                                $resexempt['status'] = $phrase['_active'];
                                                $resexempt['action'] = '<a href="'.$ilpage['subscribers'].'?subcmd=_remove-exemption&amp;id='.$resexempt['exemptid'].'&amp;uid='.$resexempt['user_id'].'" onClick="return confirm(\''.$phrase['_please_take_a_moment_to_confirm_your_action'].'\')">'.$phrase['_remove'].'</a>';
                                        }
                                        else
                                        {
                                                $resexempt['status'] = $phrase['_expired'];
                                                $resexempt['action'] = '<a href="'.$ilpage['subscribers'].'?subcmd=_remove-exemption&amp;id='.$resexempt['exemptid'].'&amp;uid='.$resexempt['user_id'].'" onClick="return confirm(\''.$phrase['_please_take_a_moment_to_confirm_your_action'].'\')">'.$phrase['_remove'].'</a>';
                                        }
                                        $resexempt['accessvalue'] = $resexempt['value'];
                                        $resexempt['class'] = ($row_count % 2) ? 'alt2' : 'alt1';
                                        $resexempt['exemptfrom'] = print_date($resexempt['exemptfrom'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0, 1, 0);
                                        $resexempt['exemptto'] = print_date($resexempt['exemptto'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0, 1, 0);
                                        $exemptions[] = $resexempt;
                                        $row_count++;
                                }
                        }
                        else
                        {
                                $show['no_exemptions'] = true;
                        }
                        
                        #######################
                        ## CREDIT CARDS ON FILE
                        $sql = $ilance->db->query("
                                SELECT *
                                FROM " . DB_PREFIX . "creditcards
                                WHERE user_id = '" . intval($ilance->GPC['id']) . "'
                        ");
                        if ($ilance->db->num_rows($sql) > 0)
                        {
                                $row_count = 0;
                                while ($res = $ilance->db->fetch_array($sql))
                                {
                                        $res['ccnum'] = substr_replace($ilance->crypt->three_layer_decrypt($res['creditcard_number'], $ilconfig['key1'], $ilconfig['key2'], $ilconfig['key3']), 'XX XXXX XXXX ', 2 , (mb_strlen($ilance->crypt->three_layer_decrypt($res['creditcard_number'], $ilconfig['key1'], $ilconfig['key2'], $ilconfig['key3'])) - 6));
                                        $res['username'] = stripslashes($res['name_on_card']);
                                        $res['phone'] = $res['phone_of_cardowner'];
                                        $res['expiry'] = $res['creditcard_expiry'];
                                        
                                        if ($res['authorized'] == 'yes')
                                        {
                                                $res['status'] = ucfirst($res['creditcard_status']) . ' &amp; Authorized';
                                                $res['authenticated'] = '<a href="' . $ilpage['subscribers'] . '?subcmd=_unauthorize-creditcard&amp;id=' . $res['cc_id'] . '&amp;uid=' . intval($ilance->GPC['id']) . '&amp;ccmgr=1" onclick="return confirm(\''.$phrase['_please_take_a_moment_to_confirm_your_action'].'\')"><img src="'.$ilconfig['template_relativeimagepath'].$ilconfig['template_imagesfolder'].'checked.gif" alt="Click to unauthorize credit card" border="0"></a>';
                                        }
                                        else
                                        {
                                                $res['status'] = ucfirst($res['creditcard_status']) . ' &amp; Unauthorized';
                                                $res['authenticated'] = '<a href="' . $ilpage['subscribers'] . '?subcmd=_authorize-creditcard&amp;id=' . $res['cc_id'] . '&amp;uid=' . intval($ilance->GPC['id']) . '&amp;ccmgr=1" onclick="return confirm(\''.$phrase['_please_take_a_moment_to_confirm_your_action'].'\')"><img src="'.$ilconfig['template_relativeimagepath'].$ilconfig['template_imagesfolder'].'unchecked.gif" alt="Click to authorize credit card" border="0"></a>';
                                        }
                                        
                                        $res['address'] = $res['card_billing_address1'].", ";
                                        
                                        if ($res['card_billing_address2'] != "")
                                        {
                                                $res['address'] .= $res['card_billing_address2'].", ";
                                        }
                                        
                                        $res['address'] .= ucfirst($res['card_city']).", ".ucfirst($res['card_state']).", ".mb_strtoupper($res['card_postalzip']).", ";
                                        $res['address'] .= stripslashes($ilance->db->fetch_field(DB_PREFIX."locations","locationid=".$ilance->db->fetch_field(DB_PREFIX."creditcards","cc_id=".$res['cc_id'],"card_country"),"location_eng"));
                                        
                                        if ($res['creditcard_type'] == "visa")
                                        {
                                                $res['cardtype'] = '<img src="'.$ilconfig['template_relativeimagepath'].$ilconfig['template_imagesfolder'].'icons/visa.gif" border="0" alt="" />';
                                        }
                                        else if ($res['creditcard_type'] == "mc")
                                        {
                                                $res['cardtype'] = '<img src="'.$ilconfig['template_relativeimagepath'].$ilconfig['template_imagesfolder'].'icons/mc.gif" border="0" alt="" />';
                                        }
                                        else if ($res['creditcard_type'] == "amex")
                                        {
                                                $res['cardtype'] = '<img src="'.$ilconfig['template_relativeimagepath'].$ilconfig['template_imagesfolder'].'icons/amex.gif" border="0" alt="" />';
                                        }
                                        else if ($res['creditcard_type'] == "disc")
                                        {
                                                $res['cardtype'] = '<img src="'.$ilconfig['template_relativeimagepath'].$ilconfig['template_imagesfolder'].'icons/disc.gif" border="0" alt="" />';
                                        }
                                        
                                        $res['remove'] = '<a href="'.$ilpage['subscribers'].'?subcmd=_remove-creditcard&amp;id='.$res['cc_id'].'&amp;uid='.intval($ilance->GPC['id']).'" onClick="return confirm(\''.$phrase['_please_take_a_moment_to_confirm_your_action'].'\')"><img src="'.$ilconfig['template_relativeimagepath'].$ilconfig['template_imagesfolder'].'icons/delete.gif" alt="" border="0" /></a>';
                                        $res['class'] = ($row_count % 2) ? 'alt2' : 'alt1';
                                        $creditcards[] = $res;
                                        $row_count++;
                                }
                        }
                        else
                        {
                                $show['no_creditcards'] = true;
                        }
                        
                        ########################
                        ## BANK ACCOUNTS ON FILE
                        $sql = $ilance->db->query("
                                SELECT *
                                FROM " . DB_PREFIX . "bankaccounts
                                WHERE user_id = '" . intval($ilance->GPC['id']) . "'
                        ");
                        if ($ilance->db->num_rows($sql) > 0)
                        {
                                $row_count = 0;
                                while ($res = $ilance->db->fetch_array($sql))
                                {
                                        $res['bankname'] = stripslashes($res['beneficiary_bank_name']);
                                        $res['accountnum'] = $res['beneficiary_account_number'];
                                        $res['accounttype'] = ucfirst($res['bank_account_type']);
                                        $res['address'] = stripslashes($res['beneficiary_bank_address_1']);
                                        $res['swiftnum'] = $res['beneficiary_bank_routing_number_swift'];
                                        if ($res['beneficiary_bank_address_2'] != "")
                                        {
                                                $res['address'] .= ", ".stripslashes($res['beneficiary_bank_address_2']); 
                                        }
                                        $res['city'] = ucfirst($res['beneficiary_bank_city']);
                                        $res['zipcode'] = mb_strtoupper($res['beneficiary_bank_zipcode']);
                                        $res['country'] = stripslashes($ilance->db->fetch_field(DB_PREFIX."locations","locationid=".$ilance->db->fetch_field(DB_PREFIX."bankaccounts","bank_id=".$res['bank_id'],"beneficiary_bank_country_id"),"location_eng"));
                                        $res['currency'] = $ilance->db->fetch_field(DB_PREFIX."currency","currency_id=".$ilance->db->fetch_field(DB_PREFIX."bankaccounts","bank_id=".$res['bank_id'],"destination_currency_id"),"currency_abbrev");
                                        $res['remove'] = '<a href="'.$ilpage['subscribers'].'?subcmd=_remove-bankaccount&amp;id='.$res['bank_id'].'&amp;uid='.intval($ilance->GPC['id']).'" onClick="return confirm(\''.$phrase['_please_take_a_moment_to_confirm_your_action'].'\')"><img src="'.$ilconfig['template_relativeimagepath'].$ilconfig['template_imagesfolder'].'icons/delete.gif" alt="" border="0" /></a>';
                                        $res['class'] = ($row_count % 2) ? 'alt2' : 'alt1';
                                        $bankaccounts[] = $res;
                                        $row_count++;
                                }
                        }
                        else
                        {
                                $show['no_bankaccounts'] = true;
                        }
                }
                else
                {
                        $area_title = $phrase['_subscriber_management'];
                        $page_title = SITE_NAME . ' - ' . $phrase['_subscriber_management'];
                        
                        ($apihook = $ilance->api('admincp_subscriber_management')) ? eval($apihook) : false;
                        
                        $subnav_settings = $ilance->admincp->print_admincp_subnav($ilpage['subscribers'], $ilpage['subscribers'], $_SESSION['ilancedata']['user']['slng']);
                        
                        $show['show_update'] = false;
                        $show['show_search'] = true;
                        
                        $customername = '';
                        $reportrange = '<select name="rangepast" style="font-family: verdana"><option value="-1 day"';
                        if (isset($ilance->GPC['range']) AND $ilance->GPC['range'] == "past" AND isset($ilance->GPC['rangepast']) AND $ilance->GPC['rangepast'] == "-1 day")
                        {
                                $reportrange .= ' selected'; 
                        }
                        $reportrange .= '>'.$phrase['_the_past_day'].'</option><option value="-1 week"';
                        if (isset($ilance->GPC['range']) AND $ilance->GPC['range'] == "past" AND isset($ilance->GPC['rangepast']) AND $ilance->GPC['rangepast'] == "-1 week")
                        {
                                $reportrange .= ' selected'; 
                        }
                        $reportrange .= '>'.$phrase['_the_past_week'].'</option><option value="-1 month"';
                        if (isset($ilance->GPC['range']) AND $ilance->GPC['range'] == "past" AND isset($ilance->GPC['rangepast']) AND $ilance->GPC['rangepast'] == "-1 month")
                        {
                                $reportrange .= ' selected';
                        }
                        $reportrange .= '>'.$phrase['_the_past_month'].'</option><option value="-1 year"'; 
                        if (isset($ilance->GPC['range']) AND $ilance->GPC['range'] == "past" AND isset($ilance->GPC['rangepast']) AND $ilance->GPC['rangepast'] == "-1 year")
                        {
                                $reportrange .= ' selected; ';
                        }
                        $reportrange .= '>'.$phrase['_the_past_year'].'</option></select>';
                }
                
                if (!isset($ilance->GPC['page']) OR isset($ilance->GPC['page']) AND $ilance->GPC['page'] <= 0)
                {
                        $ilance->GPC['page'] = 1;
                }
                else
                {
                        $ilance->GPC['page'] = intval($ilance->GPC['page']);
                }
                
                $counter = ($ilance->GPC['page'] - 1) * $ilconfig['globalfilters_maxrowsdisplay'];
        
                // #### ADMIN SEARCHING SUBSCRIBERS ####################################
                if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'search')
                {
                        $show['advancedsearch'] = $show['showsearch'] = true;
                            
                        $filterby = (isset($ilance->GPC['filterby']) AND !empty($ilance->GPC['filterby'])) ? $ilance->GPC['filterby'] : 'user_id';
                        $filtervalue = (isset($ilance->GPC['filtervalue']) AND !empty($ilance->GPC['filtervalue'])) ? $ilance->GPC['filtervalue'] : '';
                        $orderby = (isset($ilance->GPC['orderby']) AND !empty($ilance->GPC['orderby'])) ? $ilance->GPC['orderby'] : 'desc';
                        $orderlimit = ' ORDER BY ' . $filterby . ' ' . mb_strtoupper($orderby) . ' LIMIT ' . (($ilance->GPC['page']-1)*$ilconfig['globalfilters_maxrowsdisplaysubscribers']).','.$ilconfig['globalfilters_maxrowsdisplaysubscribers'];
                            
                        // searching via specific user status only
                        $where = "WHERE user_id != '' ";
                        if (isset($ilance->GPC['status']) AND !empty($ilance->GPC['status']))
                        {
                                $where .= "AND status = '".$ilance->db->escape_string($ilance->GPC['status'])."'";
                        }
                        if (!empty($filtervalue) AND !empty($filterby))
                        {
                                $where .= "AND " . $filterby . " = '" . $filtervalue . "'";
                        }
                        
                        $scriptpage = $ilpage['subscribers'] . "?cmd=search";
                        foreach ($ilance->GPC as $cmd => $value)
                        {
                                if (!empty($cmd) AND !empty($value) AND $cmd != 'submit' AND $cmd != 'cmd' AND $cmd != 'page')
                                {
                                        $scriptpage .= '&amp;'.$cmd.'='.$value;
                                }
                        }
                        
                        $sqlsearchcustomers = $ilance->db->query("
                                SELECT user_id, username, first_name, last_name, email, phone, city, state, zip_code, status, available_balance, total_balance, isadmin, permissions
                                FROM " . DB_PREFIX . "users
                                $where
                                $orderlimit
                        ");
                        
                        $sqlsearchcustomers2 = $ilance->db->query("
                                SELECT user_id, username, first_name, last_name, email, phone, city, state, zip_code, status, available_balance, total_balance, isadmin, permissions
                                FROM " . DB_PREFIX . "users
                                $where
                        ");
                        $number = (int)$ilance->db->num_rows($sqlsearchcustomers2);
                        if ($ilance->db->num_rows($sqlsearchcustomers) > 0)
                        {
                                $row_count = 0;
                                while ($res = $ilance->db->fetch_array($sqlsearchcustomers))
                                {
                                        $res['edit'] = '<a href="'.$ilpage['subscribers'].'?subcmd=_update-customer&amp;id='.$res['user_id'].'"><img src="'.$ilconfig['template_relativeimagepath'].$ilconfig['template_imagesfolder'].'icons/pencil.gif" alt="" border="0"></a>';
                                        $res['remove'] = '<a href="'.$ilpage['subscribers'].'?subcmd=_remove-customer&amp;id='.$res['user_id'].'" onClick="return confirm(\''.$phrase['_please_take_a_moment_to_confirm_your_action'].'\')"><img src="'.$ilconfig['template_relativeimagepath'].$ilconfig['template_imagesfolder'].'icons/delete.gif" alt="" border="0"></a>';
                                        $res['balance'] = $ilance->currency->format($res['available_balance']);
                                        $res['subscription'] = $ilance->subscription->fetch_subscription_plan($res['user_id']);
                                        $res['role'] = print_role(fetch_user_roleid($res['user_id']));
                                        $res['action'] = '<input type="checkbox" name="user_id[]" value="'.$res['user_id'].'" id="members_'.$res['user_id'].'" />';
                                        if ($res['isadmin'])
                                        {
                                                $res['isadmin'] = '<img src="'.$ilconfig['template_relativeimagepath'].$ilconfig['template_imagesfolder'].'checked.gif" border="0" alt="'.$phrase['_yes'].'" />';
                                        }
                                        else
                                        {
                                                $res['isadmin'] = '<img src="'.$ilconfig['template_relativeimagepath'].$ilconfig['template_imagesfolder'].'unchecked.gif" border="0" alt="'.$phrase['_no'].'" />';
                                        }
                                        $res['class'] = ($row_count % 2) ? 'alt2' : 'alt1';
                                        if ($res['status'] == 'active')
                                        {
                                                $res['status'] = '<a href="'.$ilpage['subscribers'].'?subcmd=_suspend-customer&amp;id='.$res['user_id'].'"><img src="'.$ilconfig['template_relativeimagepath'].$ilconfig['template_imagesfolder'].'checked.gif" alt="Click to suspend customer (cannot log-in)" border="0"></a>';
                                        }
                                        else
                                        {
                                                $res['status'] = '<a href="'.$ilpage['subscribers'].'?subcmd=_activate-customer&amp;id='.$res['user_id'].'"><img src="'.$ilconfig['template_relativeimagepath'].$ilconfig['template_imagesfolder'].'unchecked.gif" alt="Click to re-activate customer (can log in)" border="0"></a>';
                                        }                                
                                        $searchcustomers[] = $res;
                                        $row_count++;
                                }
                                
                                $show['no_customers'] = true;
                                
                                $searchprevnext = print_pagnation($number, $ilconfig['globalfilters_maxrowsdisplay'], $ilance->GPC['page'], $counter, $scriptpage);
                                $prevnext = "";
                        }
                        else
                        {
                                $show['advancedsearch'] = true;
                                $show['no_searchcustomers'] = true;
                        }
                }
                else
                {
                        // field display order
                        $displayorderfields = array('asc', 'desc');
                        $displayorder = '&amp;displayorder=desc';
                        $realdisplayorder = $displayorder;
                        $displayordersql = 'ASC';
                        if (isset($ilance->GPC['displayorder']) AND $ilance->GPC['displayorder'] == 'asc')
                        {
                                $realdisplayorder = '&amp;displayorder=asc';
                                $displayorder = '&amp;displayorder=desc';
                        }
                        else if (isset($ilance->GPC['displayorder']) AND $ilance->GPC['displayorder'] == 'desc')
                        {
                                $realdisplayorder = '&amp;displayorder=desc';
                                $displayorder = '&amp;displayorder=asc';
                        }
                        if (isset($ilance->GPC['displayorder']) AND in_array($ilance->GPC['displayorder'], $displayorderfields))
                        {
                                $displayordersql = mb_strtoupper($ilance->GPC['displayorder']);
                        }
                        
                        // ordering by display logic
                        $orderbyfields = array('total_balance', 'user_id', 'username');
                        $orderby = '';
                        $orderbysql = 'user_id';
                        if (isset($ilance->GPC['orderby']) AND in_array($ilance->GPC['orderby'], $orderbyfields))
                        {
                                $orderbysql = mb_strtoupper($ilance->GPC['orderby']);
                                $orderby = '';
                        }
                        
                        $scriptpage = $ilpage['subscribers'] . '?cmd=listing' . $displayorder . $orderby;
                        $scriptpageprevnext = $ilpage['subscribers'] . '?cmd=listing' . $realdisplayorder . $orderby;
                        $show['showsearch'] = false;
                
                        $sql = $ilance->db->query("
                                SELECT user_id, username, first_name, last_name, email, phone, city, state, zip_code, status, available_balance, total_balance, isadmin, permissions
                                FROM " . DB_PREFIX . "users
                                ORDER BY $orderbysql
                                $displayordersql
                                LIMIT " . (($ilance->GPC['page'] - 1) * $ilconfig['globalfilters_maxrowsdisplaysubscribers']) . "," . $ilconfig['globalfilters_maxrowsdisplaysubscribers']
                        );
                        
                        $sql2 = $ilance->db->query("
                                SELECT user_id, username, first_name, last_name, email, phone, city, state, zip_code, status, available_balance, total_balance, isadmin, permissions
                                FROM " . DB_PREFIX . "users
                        ");
                        if ($ilance->db->num_rows($sql) > 0)
                        {
                                $number = (int)$ilance->db->num_rows($sql2);
                                $row_count = 0;
                                while ($res = $ilance->db->fetch_array($sql))
                                {
                                        if ($res['status'] == 'moderated')
                                        {
                                                $res['class'] = '#FFF7F9';   
                                        }
                                        else
                                        {
                                                $res['class'] = ($row_count % 2) ? 'alt2' : 'alt1';
                                        }
                                        if ($res['status'] == 'active')
                                        {
                                                $res['status'] = '<a href="'.$ilpage['subscribers'].'?subcmd=_suspend-customer&amp;id='.$res['user_id'].'"><img src="'.$ilconfig['template_relativeimagepath'].$ilconfig['template_imagesfolder'].'checked.gif" alt="Click to suspend customer (cannot log-in)" border="0"></a>';
                                        }
                                        else
                                        {
                                                $res['status'] = '<a href="'.$ilpage['subscribers'].'?subcmd=_activate-customer&amp;id='.$res['user_id'].'"><img src="'.$ilconfig['template_relativeimagepath'].$ilconfig['template_imagesfolder'].'unchecked.gif" alt="Click to re-activate customer (can log in)" border="0"></a>';
                                        }
                                        if ($res['isadmin'])
                                        {
                                                    $res['isadmin'] = '<img src="'.$ilconfig['template_relativeimagepath'].$ilconfig['template_imagesfolder'].'checked.gif" border="0" alt="'.$phrase['_yes'].'" />';
                                        }
                                        else
                                        {
                                                    $res['isadmin'] = '<img src="'.$ilconfig['template_relativeimagepath'].$ilconfig['template_imagesfolder'].'unchecked.gif" border="0" alt="'.$phrase['_no'].'" />';
                                        }
                                        $res['edit'] = '<a href="'.$ilpage['subscribers'].'?subcmd=_update-customer&amp;id='.$res['user_id'].'"><img src="'.$ilconfig['template_relativeimagepath'].$ilconfig['template_imagesfolder'].'icons/pencil.gif" alt="" border="0"></a>';
                                        $res['remove'] = '<a href="'.$ilpage['subscribers'].'?subcmd=_remove-customer&amp;id='.$res['user_id'].'" onClick="return confirm(\''.$phrase['_please_take_a_moment_to_confirm_your_action'].'\')"><img src="'.$ilconfig['template_relativeimagepath'].$ilconfig['template_imagesfolder'].'icons/delete.gif" alt="" border="0"></a>';
                                        if ($res['available_balance'] > 0)
                                        {
                                                $res['balance'] = $ilance->currency->format($res['available_balance']);
                                        }
                                        else
                                        {
                                                $res['balance'] = '<div class="gray">' . $phrase['_none'] . '</div>';
                                        }
                                        $res['subscription'] = $ilance->subscription->fetch_subscription_plan($res['user_id']);
                                        $res['role'] = print_role(fetch_user_roleid($res['user_id']));
                                        $res['action'] = '<input type="checkbox" name="user_id[]" value="'.$res['user_id'].'" id="members_'.$res['user_id'].'" />';
                                        $customers[] = $res;
                                        $row_count++;
                                }
                                
                                $searchprevnext = '';
                                $prevnext = print_pagnation($number, $ilconfig['globalfilters_maxrowsdisplaysubscribers'], $ilance->GPC['page'], $counter, $scriptpageprevnext);
                        }
                        else
                        {
                                $show['no_customers'] = true;
                        }
                }
                
                // #### UPDATE SUBSCRIBER LOGIC ########################################
                if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == '_update-customer')
                {
                        $ilance->GPC['id'] = isset($ilance->GPC['id']) ? intval($ilance->GPC['id']) : 0;
                        
                        // custom registration questions
                        $ilance->registration_questions = construct_object('api.registration_questions');
                        $customquestions = $ilance->registration_questions->construct_register_questions(0, 'updateprofileadmin', intval($ilance->GPC['id']));
                }
            
                // subscription plan pulldown menu
                $subscription_plan_pulldown = $ilance->subscription->plans_pulldown();
                $subscription_permissions_pulldown = $ilance->subscription->exemptions_pulldown();
                
                // construct countries / states pulldown
                $jscity = $ilconfig['registrationdisplay_defaultcity'];
                $countryid = fetch_country_id($ilconfig['registrationdisplay_defaultcountry'], $_SESSION['ilancedata']['user']['slng']);
                $country_js_pulldown = construct_country_pulldown($countryid, $ilconfig['registrationdisplay_defaultcountry']);
                $state_js_pulldown = '<div id="stateid" style="height:20px">' . construct_state_pulldown($countryid, $ilconfig['registrationdisplay_defaultstate']) . '</div>';
                
                $subscription_role_pulldown = print_role_pulldown('', '', 0);
                
                $ilance->GPC['script'] = (!empty($ilance->GPC['script']) ? $ilance->GPC['script'] : '');
                $ilance->GPC['user_id'] = (!empty($ilance->GPC['user_id']) ? $ilance->GPC['user_id'] : '');
                $ilance->GPC['admin_id'] = (!empty($ilance->GPC['admin_id']) ? $ilance->GPC['admin_id'] : '');
                
                $scripts_pulldown = $ilance->admincp->print_audit_scripts_pulldown($ilance->GPC['script']);
                //$members_pulldown = $ilance->admincp->print_members_pulldown($ilance->GPC['user_id']);
                $members_pulldown = '<input type="text" name="user_id" value="' . intval($ilance->GPC['user_id']) . '" />';
                
                $admins_pulldown = $ilance->admincp->print_admins_pulldown($ilance->GPC['admin_id']);
        
                // #### VIEWING TASK LOG ###########################################
                if (isset($ilance->GPC['do']) AND $ilance->GPC['do'] == 'view')
                {
                        // filters
                        $ilance->GPC['pp'] = isset($ilance->GPC['pp']) ? intval($ilance->GPC['pp']) : $ilconfig['globalfilters_maxrowsdisplay'];
                        $ilance->GPC['script'] = isset($ilance->GPC['script']) ? $ilance->GPC['script'] : '';
                        $ilance->GPC['user_id'] = isset($ilance->GPC['user_id']) ? intval($ilance->GPC['user_id']) : '';
                        $ilance->GPC['admin_id'] = isset($ilance->GPC['admin_id']) ? intval($ilance->GPC['admin_id']) : '';
                        $ilance->GPC['order'] = isset($ilance->GPC['order']) ? $ilance->GPC['order'] : 'ASC';
                        $ilance->GPC['where'] = '';
                        
                        if (!empty($ilance->GPC['script']))
                        {
                                $ilance->GPC['where'] = "AND script = '" . $ilance->db->escape_string($ilance->GPC['script']) . "'";
                        }
                        if (!empty($ilance->GPC['user_id']))
                        {
                                $ilance->GPC['where'] .= "AND user_id = '" . $ilance->GPC['user_id'] . "'";
                        }
                        if (!empty($ilance->GPC['admin_id']))
                        {
                                $ilance->GPC['where'] .= "AND user_id = '" . $ilance->GPC['admin_id'] . "'";
                        }
                        
                        if (!isset($ilance->GPC['page']) OR isset($ilance->GPC['page']) AND $ilance->GPC['page'] <= 0)
                        {
                                $ilance->GPC['page'] = 1;
                        }
                        else
                        {
                                $ilance->GPC['page'] = intval($ilance->GPC['page']);
                        }
                        
                        $ilance->GPC['limit'] = ' ORDER BY '.$ilance->db->escape_string($ilance->GPC['orderby']).' '.$ilance->GPC['order'].' LIMIT '.(($ilance->GPC['page']-1)*$ilance->GPC['pp']).','.$ilance->GPC['pp'];
                        
                        $audittmp = $ilance->db->query("SELECT * FROM " . DB_PREFIX . "audit WHERE logid > 0 ".$ilance->GPC['where']);
                        $ilance->GPC['totalcount'] = $ilance->db->num_rows($audittmp);
                        $ilance->GPC['counter'] = ($ilance->GPC['page']-1)*$ilance->GPC['pp'];
                        
                        $audit = $ilance->db->query("SELECT * FROM " . DB_PREFIX . "audit WHERE logid > 0 ".$ilance->GPC['where']." ".$ilance->GPC['limit']);
                        if ($ilance->db->num_rows($audit) > 0)
                        {
                                $count = 0;
                                while ($res = $ilance->db->fetch_array($audit))
                                {
                                        $res['class'] = ($count % 2) ? 'alt2' : 'alt1';
                                        $res['datetime'] = print_date($ilance->datetime->fetch_datetime_from_timestamp($res['datetime']), $ilconfig['globalserverlocale_globaltimeformat'], 0, 0);
                                        if ($res['user_id'] > 0)
                                        {
                                                $res['user'] = '<a href="' . $ilpage['subscribers'] . '?subcmd=_update-customer&id=' . $res['user_id'] . '">' . fetch_user('username', $res['user_id']) . '</a>';
                                        }
                                        else
                                        {
                                                $res['user'] = '--';
                                        }
                                        if ($res['admin_id'] > 0)
                                        {
                                                $res['admin'] = '<a href="' . $ilpage['settings'] . '?cmd=moderators">' . fetch_adminname($res['admin_id']) . '</a>';
                                        }
                                        else
                                        {
                                                $res['admin'] = '--';
                                        }
                                        $auditlog[] = $res;
                                        $count++;
                                }
                        }
                        
                        $prevnext = print_pagnation($ilance->GPC['totalcount'], $ilance->GPC['pp'], $ilance->GPC['page'], $ilance->GPC['counter'], $ilpage['subscribers'].'?cmd=auditlog&amp;do=view&amp;script='.$ilance->GPC['script'].'&amp;admin_id='.$ilance->GPC['admin_id'].'&amp;user_id='.$ilance->GPC['user_id'].'&amp;orderby='.$ilance->GPC['orderby'].'&amp;order='.$ilance->GPC['order']);
                }
                
                // #### PRUNE AUDIT LOG ################################################
                else if (isset($ilance->GPC['do']) AND $ilance->GPC['do'] == 'prune')
                {
                        $ilance->GPC['script'] = isset($ilance->GPC['script']) ? $ilance->GPC['script'] : '';
                        $ilance->GPC['user_id'] = isset($ilance->GPC['user_id']) ? intval($ilance->GPC['user_id']) : '';
                        $ilance->GPC['admin_id'] = isset($ilance->GPC['admin_id']) ? intval($ilance->GPC['admin_id']) : '';
                        $ilance->GPC['days'] = intval($ilance->GPC['days']);
                        $ilance->GPC['cutoff'] = TIMESTAMPNOW - (86400 * $ilance->GPC['days']);
                        
                        $conds = '';
                        if (!empty($ilance->GPC['script']))
                        {
                                $conds .= " AND script = '" . $ilance->db->escape_string($ilance->GPC['script']) . "'";
                        }
                        if (!empty($ilance->GPC['user_id']))
                        {
                                $conds .= " AND user_id = '" . intval($ilance->GPC['user_id']) . "'";
                        }
                        if (!empty($ilance->GPC['admin_id']))
                        {
                                $conds .= " AND admin_id = '" . intval($ilance->GPC['admin_id']) . "'";
                        }
                        
                        $sql = $ilance->db->query("
                                SELECT *
                                FROM " . DB_PREFIX . "audit
                                WHERE datetime < " . $ilance->GPC['cutoff'] . "
                                $conds
                        ");
                        $count = number_format($ilance->db->num_rows($sql));
                        
                        $ilance->db->query("
                                DELETE FROM " . DB_PREFIX . "audit
                                WHERE datetime < " . $ilance->GPC['cutoff'] . "
                                $conds
                        ");
                        
                        print_action_success($phrase['_audit_logs_pruned'] . ' ' .$count, $ilance->GPC['return']);
                        exit();    
                }
        
                $profilequestions = $phrase['_not_available_at_this_time'];
        
                $pprint_array = array('ilanceversion','login_include_admin','city_js_pulldown','scriptpage','profilequestions','customquestions','prevnext','admins_pulldown','members_pulldown','scripts_pulldown','rolepulldown','subscription_role_pulldown','dynamic_js_bodyend2','country_js_pulldown','state_js_pulldown','role_pulldown','subscription_permissions_pulldown','register_questions','reportrange','transactionsprevnext','id','customername','currency','subscription_plan_pulldown','dynamic_js_bodyend','searchprevnext','prevnext','number','get_filtervalue','phrases_selectlist','keyword','base_language_pulldown','limit_pulldown','language_pulldown','input_style','remote_addr','rid','login_include','headinclude','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer');
                
                ($apihook = $ilance->api('admincp_subscribers_end')) ? eval($apihook) : false;
        
                $ilance->template->load_file('main', 'subscribers.html', 1);
                $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                $ilance->template->parse_loop('main', 'v3nav');
                $ilance->template->parse_loop('main', 'subnav_settings');
                $ilance->template->parse_loop('main', 'customers');
                $ilance->template->parse_loop('main', 'searchcustomers');
                $ilance->template->parse_loop('main', 'registration_questions');
                $ilance->template->parse_loop('main', 'profile');
                $ilance->template->parse_loop('main', 'profileaccount');
                $ilance->template->parse_loop('main', 'transaction_rows');
                $ilance->template->parse_loop('main', 'subscription_rows');
                $ilance->template->parse_loop('main', 'creditcards');
                $ilance->template->parse_loop('main', 'bankaccounts');
                $ilance->template->parse_loop('main', 'exemptions');
                $ilance->template->parse_loop('main', 'auditlog');
                $ilance->template->parse_if_blocks('main');
                $ilance->template->pprint('main', $pprint_array);
                exit();
        }
}
else
{
	refresh($ilpage['login'] . '?redirect=' . urlencode(SCRIPT_URI), HTTPS_SERVER_ADMIN . $ilpage['login'] . '?redirect=' . urlencode(SCRIPT_URI));
	exit();
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: subscribers.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>