<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

/**
* Template columns class to generate user selectable table headers and display results when searching in the marketplace.
*
* @package      iLance
* @version	$Revision: 1.0.0 $
* @author       ILance
*/
class template_columns extends template
{
        /**
        * Default table column info
        */
        var $columninfo = array(
                'default' => array(
                                'width' => '5%',
                                'rowwidth' => '5%',
                                'class' => 'alt2',
                                'rowclass' => '',
                                'colspan' => '',
                                'nowrap' => 'nowrap="nowrap"',
                                'align' => 'left',
                                'valign' => 'top',
                                'id' => '',
                                'rowalign' => 'left',
                                'extra' => ''
                ),
                'title' => array(
                                'width' => '155',
                                'rowwidth' => '155',
                                'class' => 'alt2',
                                'rowclass' => '',
                                'colspan' => '',
                                'nowrap' => 'nowrap="nowrap"',
                                'align' => 'left',
                                'valign' => 'top',
                                'id' => '',
                                'rowalign' => 'left',
                                'extra' => ''
                ),
                'bids' => array(
                                'width' => '2%',
                                'rowwidth' => '2%',
                                'class' => 'alt2',
                                'rowclass' => '',
                                'colspan' => '',
                                'nowrap' => 'nowrap="nowrap"',
                                'align' => 'left',
                                'valign' => 'top',
                                'id' => '',
                                'rowalign' => 'left',
                                'extra' => ''
                ),
                'averagebid' => array(
                                'width' => '11%',
                                'rowwidth' => '11%',
                                'class' => 'alt2',
                                'rowclass' => '',
                                'colspan' => '',
                                'nowrap' => 'nowrap="nowrap"',
                                'align' => 'left',
                                'valign' => 'top',
                                'id' => '',
                                'rowalign' => 'left',
                                'extra' => ''
                ),
                'timeleft' => array(
                                'width' => '100',
                                'rowwidth' => '100',
                                'class' => 'alt2',
                                'rowclass' => '',
                                'colspan' => '',
                                'nowrap' => 'nowrap="nowrap"',
                                'align' => 'left',
                                'valign' => 'top',
                                'id' => '',
                                'rowalign' => 'left',
                                'extra' => ''
                ),
                'category' => array(
                                'width' => '15%',
                                'rowwidth' => '15%',
                                'class' => 'alt2',
                                'rowclass' => '',
                                'colspan' => '',
                                'nowrap' => 'nowrap="nowrap"',
                                'align' => 'left',
                                'valign' => 'top',
                                'id' => '',
                                'rowalign' => 'left',
                                'extra' => ''
                ),
                'views' => array(
                                'width' => '2%',
                                'rowwidth' => '2%',
                                'class' => 'alt2',
                                'rowclass' => '',
                                'colspan' => '',
                                'nowrap' => '',
                                'align' => 'left',
                                'valign' => 'top',
                                'id' => '',
                                'rowalign' => 'left',
                                'extra' => ''
                ),
                'budget' => array(
                                'width' => '15%',
                                'rowwidth' => '5%',
                                'class' => 'alt2',
                                'rowclass' => '',
                                'colspan' => '',
                                'nowrap' => '',
                                'align' => 'left',
                                'valign' => 'top',
                                'id' => '',
                                'rowalign' => 'left',
                                'extra' => ''
                ),
                'distance' => array(
                                'width' => '12%',
                                'rowwidth' => '12%',
                                'class' => 'alt2',
                                'rowclass' => '',
                                'colspan' => '',
                                'nowrap' => 'nowrap="nowrap"',
                                'align' => 'left',
                                'valign' => 'top',
                                'id' => '',
                                'rowalign' => 'left',
                                'extra' => ''
                ),
                'sample' => array(
                                'width' => '10%',
                                'rowwidth' => '10%',
                                'class' => 'alt2',
                                'rowclass' => '',
                                'rowclass' => '',
                                'colspan' => '',
                                'nowrap' => '',
                                'align' => 'center',
                                'valign' => 'top',
                                'id' => '',
                                'rowalign' => 'center',
                                'extra' => ''
                ),
                'price' => array(
                                'width' => '11%',
                                'rowwidth' => '11%',
                                'class' => 'alt2',
                                'rowclass' => '',
                                'colspan' => '',
                                'nowrap' => 'nowrap="nowrap"',
                                'align' => 'left',
                                'valign' => 'top',
                                'id' => '',
                                'rowalign' => 'left',
                                'extra' => ''
                ),
                'shipping' => array(
                                'width' => '8%',
                                'rowwidth' => '8%',
                                'class' => 'alt2',
                                'rowclass' => '',
                                'colspan' => '',
                                'nowrap' => 'nowrap="nowrap"',
                                'align' => 'left',
                                'valign' => 'top',
                                'id' => '',
                                'rowalign' => 'left',
                                'extra' => ''
                ),
                'expert' => array(
                                'width' => '120',
                                'rowwidth' => '120',
                                'class' => 'alt2',
                                'rowclass' => '',
                                'colspan' => '',
                                'nowrap' => 'nowrap="nowrap"',
                                'align' => 'left',
                                'valign' => 'top',
                                'id' => '',
                                'rowalign' => 'left',
                                'extra' => ''
                ),
                'profilelogo' => array(
                                'width' => '1%',
                                'rowwidth' => '1%',
                                'class' => 'alt2',
                                'rowclass' => 'alt1',
                                'colspan' => '',
                                'nowrap' => 'nowrap="nowrap"',
                                'align' => 'center',
                                'valign' => 'top',
                                'id' => '',
                                'rowalign' => 'center',
                                'extra' => ''
                ),
                'credentials' => array(
                                'width' => '3%',
                                'rowwidth' => '3%',
                                'class' => 'alt2',
                                'rowclass' => '',
                                'colspan' => '',
                                'nowrap' => 'nowrap="nowrap"',
                                'align' => 'left',
                                'valign' => 'top',
                                'id' => '',
                                'rowalign' => 'left',
                                'extra' => ''
                ),
                'rated' => array(
                                'width' => '10%',
                                'rowwidth' => '8%',
                                'class' => 'alt2',
                                'rowclass' => '',
                                'colspan' => '',
                                'nowrap' => 'nowrap="nowrap"',
                                'align' => 'left',
                                'valign' => 'top',
                                'id' => '',
                                'rowalign' => 'left',
                                'extra' => ''
                ),
                'feedback' => array(
                                'width' => '12%',
                                'rowwidth' => '12%',
                                'class' => 'alt2',
                                'rowclass' => '',
                                'colspan' => '',
                                'nowrap' => 'nowrap="nowrap"',
                                'align' => 'left',
                                'valign' => 'top',
                                'id' => '',
                                'rowalign' => 'left',
                                'extra' => ''
                ),
                'awards' => array(
                                'width' => '1%',
                                'rowwidth' => '1%',
                                'class' => 'alt2',
                                'rowclass' => '',
                                'colspan' => '',
                                'nowrap' => 'nowrap="nowrap"',
                                'align' => 'left',
                                'valign' => 'top',
                                'id' => '',
                                'rowalign' => 'left',
                                'extra' => ''
                ),
                'earnings' => array(
                                'width' => '8%',
                                'rowwidth' => '8%',
                                'class' => 'alt2',
                                'rowclass' => '',
                                'colspan' => '',
                                'nowrap' => 'nowrap="nowrap"',
                                'align' => 'left',
                                'valign' => 'top',
                                'id' => '',
                                'rowalign' => 'left',
                                'extra' => ''
                ),
                'rateperhour' => array(
                                'width' => '5%',
                                'rowwidth' => '5%',
                                'class' => 'alt2',
                                'rowclass' => '',
                                'colspan' => '',
                                'nowrap' => 'nowrap="nowrap"',
                                'align' => 'left',
                                'valign' => 'top',
                                'id' => '',
                                'rowalign' => 'left',
                                'extra' => ''
                ),
                'portfolio' => array(
                                'width' => '5%',
                                'rowwidth' => '5%',
                                'class' => 'alt2',
                                'rowclass' => '',
                                'colspan' => '',
                                'nowrap' => 'nowrap="nowrap"',
                                'align' => 'left',
                                'valign' => 'top',
                                'id' => '',
                                'rowalign' => 'left',
                                'extra' => ''
                ),
                'city' => array(
                                'width' => '10%',
                                'rowwidth' => '10%',
                                'class' => 'alt2',
                                'rowclass' => '',
                                'colspan' => '',
                                'nowrap' => 'nowrap="nowrap"',
                                'align' => 'left',
                                'valign' => 'top',
                                'id' => '',
                                'rowalign' => 'left',
                                'extra' => ''
                ),
                'zipcode' => array(
                                'width' => '10%',
                                'rowwidth' => '10%',
                                'class' => 'alt2',
                                'rowclass' => '',
                                'colspan' => '',
                                'nowrap' => 'nowrap="nowrap"',
                                'align' => 'left',
                                'valign' => 'top',
                                'id' => '',
                                'rowalign' => 'left',
                                'extra' => ''
                ),
                'state' => array(
                                'width' => '10%',
                                'rowwidth' => '10%',
                                'class' => 'alt2',
                                'rowclass' => '',
                                'colspan' => '',
                                'nowrap' => 'nowrap="nowrap"',
                                'align' => 'left',
                                'valign' => 'top',
                                'id' => '',
                                'rowalign' => 'left',
                                'extra' => ''
                ),
                'country' => array(
                                'width' => '15%',
                                'rowwidth' => '15%',
                                'class' => 'alt2',
                                'rowclass' => '',
                                'colspan' => '',
                                'nowrap' => 'nowrap="nowrap"',
                                'align' => 'left',
                                'valign' => 'top',
                                'id' => '',
                                'rowalign' => 'left',
                                'extra' => ''
                ),
                'sel' => array(
                                'width' => '3%',
                                'rowwidth' => '3%',
                                'class' => 'alt2',
                                'rowclass' => '',
                                'colspan' => '',
                                'nowrap' => 'nowrap="nowrap"',
                                'align' => 'center',
                                'valign' => 'top',
                                'id' => '',
                                'rowalign' => 'center',
                                'extra' => ''
                ),
        );
        
        /**
        * Default table column phrase identifiers
        */
        var $columnphrases = array(
                'title' => '_title',
                'bids' => '_bids',
                'averagebid' => '_average_bid',
                'timeleft' => '_time_left',
                'category' => '_category',
                'views' => '_views',
                'budget' => '_budget',
                'distance' => '_distance',
                'sample' => '_sample',
                'price' => '_price',
                'shipping' => '_shipping',
                'expert' => '_expert',
                'profilelogo' => '_logo',
                'credentials' => '_credentials',
                'rated' => '_rated',
                'feedback' => '_feedback',
                'awards' => '_awards',
                'earnings' => '_earnings',
                'rateperhour' => '_hourly_rate',
                'portfolio' => '_portfolio',
                'city' => '_city',
                'country' => '_country',
                'zipcode' => '_zip',
                'state' => '_state',
                'sel' => '_sel',
        );
        
        /*
        * ...
        *
        * @param       
        *
        * @return      
        */   
        function print_td_list_head($tableheader)
        {
                global $ilance, $phrase, $show, $ilconfig, $ilpage;
                
                $value['colspan'] = (!empty($this->columninfo["$tableheader"]['colspan'])) ? 'colspan="' . $this->columninfo["$tableheader"]['colspan'] . '"' : '';
                $value['nowrap'] = (!empty($this->columninfo["$tableheader"]['nowrap'])) ? 'nowrap="nowrap"' : '';
                $value['extra'] = (!empty($this->columninfo["$tableheader"]['extra'])) ? $this->columninfo["$tableheader"]['extra'] : '';
                $value['class'] = $this->columninfo["$tableheader"]['class'];
                $value['align'] = $this->columninfo["$tableheader"]['align'];
                $value['width'] = $this->columninfo["$tableheader"]['width'];
                $value['tableheader'] = $phrase[$this->columnphrases[$tableheader]];
                
                $html = '';
                
                // #### distance calculation output ############################
                if ($tableheader == 'distance' AND isset($show['distancecolumn']) AND $show['distancecolumn'] AND $ilconfig['globalserver_enabledistanceradius'])
                {
                        $html1 = $this->fetch_template('search_results_list_col_data_distance.html');
                        $html1 = $this->parse_hash('search_results_list_col_data_distance.html', array('ilconfig' => $ilconfig, 'ilpage' => $ilpage, 'value' => $value), $parseglobals = 0, $html1);
                        $html1 = $this->parse_if_blocks('search_results_list_col_data_distance.html', $html1, $addslashes = true);
                        
                        $html1 = stripslashes($html1);
                        $html1 = addslashes($html1);
                        $html1 = str_replace('$', '\$', $html1);
                        
                        eval('$html .= "' . $html1 . '";');
                        unset($html1);
                }
                
                // #### custom profile questions ###############################
                else if (mb_ereg('profile_', $tableheader))
                {
                        $profileqid = explode('_', $tableheader);
                        $value['columnname'] = $ilance->db->fetch_field(DB_PREFIX . "profile_questions", "questionid = '" . intval($profileqid[1]) . "'", "question");
                        $value['nowrap'] = 'nowrap="nowrap"';
                        
                        $html1 = $this->fetch_template('search_results_list_col_data_profilefilter.html');
                        $html1 = $this->parse_hash('search_results_list_col_data_profilefilter.html', array('ilconfig' => $ilconfig, 'ilpage' => $ilpage, 'value' => $value), $parseglobals = 0, $html1);
                        $html1 = $this->parse_if_blocks('search_results_list_col_data_profilefilter.html', $html1, $addslashes = true);
                        
                        $html1 = stripslashes($html1);
                        $html1 = addslashes($html1);
                        $html1 = str_replace('$', '\$', $html1);
                        
                        eval('$html .= "' . $html1 . '";');
                        unset($html1);
                }
                
                // #### all other columns ######################################
                else
                {
                        $html1 = $this->fetch_template('search_results_list_col_data.html');
                        $html1 = $this->parse_hash('search_results_list_col_data.html', array('ilconfig' => $ilconfig, 'ilpage' => $ilpage, 'value' => $value), $parseglobals = 0, $html1);
                        $html1 = $this->parse_if_blocks('search_results_list_col_data.html', $html1, $addslashes = true);
                        
                        $html1 = stripslashes($html1);
                        $html1 = addslashes($html1);
                        $html1 = str_replace('$', '\$', $html1);
                        
                        eval('$html .= "' . $html1 . '";');
                        unset($html1);
                }
                        
                if (!empty($html))
                {
                        $html = stripslashes($html);
                }
                
                return $html;
        }
        
        /*
        * This function is responsible for printing out each "block" or column in the search results when a user is viewing
        * "View Mode: Gallery".  As per example, if you were showing 3 columns per row, this function generates each "column" and
        * the necessary HTML markup language which is now served from the template folder.
        *
        * @param     array      array with $data['vars'] for use like {data[vars]} in the html template
        * @param     string     the type of column to generate (service, product or experts)
        *
        * @return    string     HTML representation of the templated fully parsed ready for browser display
        */
        function print_td_gallery_head($data = array(), $type = 'service')
        {
                global $phrase, $show, $ilconfig, $ilpage, $php_self_urlencoded, $auctiontype;
                
                $html = $html1 = '';
                $bold = $highlite = false;
                
                if (!empty($data) AND is_array($data) AND count($data) > 0)
                {
                        if ($type == 'service')
                        {
                                // grab all columns
                                // run foreach on each column and build $show[xx]
                                
                                $bold = $data['bold'];
                                $highlite = $data['highlite'];
                                $bids = $data['bids'];
                                
                                $html1 = $this->fetch_template('search_results_service_gallery_column.html');
                                $html1 = $this->parse_hash('search_results_service_gallery_column.html', array('ilconfig' => $ilconfig, 'ilpage' => $ilpage, 'data' => $data), $parseglobals = 0, $html1);
                                $html1 = $this->parse_if_blocks('search_results_service_gallery_column.html', $html1, $addslashes = true);
                                
                                $html1 = stripslashes($html1);
                                $html1 = addslashes($html1);
                                $html1 = str_replace('$', '\$', $html1);
                                
                                eval('$html .= "' . $html1 . '";');
                        }
                        else if ($type == 'product')
                        {
                                // grab all columns
                                // run foreach on each column and build $show[xx]
                                
                                $auctiontype = $data['filtered_auctiontype'];
                                $bold = $data['bold'];
                                $highlite = $data['highlite'];
                                $bids = $data['bids'];
                                
                                $html1 = $this->fetch_template('search_results_product_gallery_column.html');
                                $html1 = $this->parse_hash('search_results_product_gallery_column.html', array('ilconfig' => $ilconfig, 'ilpage' => $ilpage, 'data' => $data), $parseglobals = 0, $html1);
                                $html1 = $this->parse_if_blocks('search_results_product_gallery_column.html', $html1, $addslashes = true);
                                
                                $html1 = stripslashes($html1);
                                $html1 = addslashes($html1);
                                $html1 = str_replace('$', '\$', $html1);
                                
                                eval('$html .= "' . $html1 . '";');
                        }
                        else if ($type == 'experts')
                        {
                                // grab all columns
                                // run foreach on each column and build $show[xx]
                                
                                $bold = (isset($data['bold']) ? $data['bold'] : '');
                                $highlite = '';
                                
                                $html1 = $this->fetch_template('search_results_experts_gallery_column.html');
                                $html1 = $this->parse_hash('search_results_experts_gallery_column.html', array('ilconfig' => $ilconfig, 'ilpage' => $ilpage, 'data' => $data), $parseglobals = 0, $html1);
                                $html1 = $this->parse_if_blocks('search_results_experts_gallery_column.html', $html1, $addslashes = true);
                                
                                $html1 = stripslashes($html1);
                                $html1 = addslashes($html1);
                                $html1 = str_replace('$', '\$', $html1);
                                
                                eval('$html .= "' . $html1 . '";');
                        }
                        
                        $html = stripslashes($html);
                }
                
                return $html;
        }
        
        /*
        * ...
        *
        * @param       
        *
        * @return      
        */
        function print_table_head_columns($searchresults = array(), $mode = 'service', $listview = 'list')
        {
                global $ilance, $ilconfig, $ilpage;
                
                // #### CUSTOM USER DESIGNED COLUMN HEADERS ####################
                if (!empty($_SESSION['ilancedata']['user']['searchoptions']))
                {
                        $columnstemp = unserialize($_SESSION['ilancedata']['user']['searchoptions']);
                        
                        switch ($listview)
                        {
                                case 'list':
                                {
                                        switch ($mode)
                                        {
                                                case 'service':
                                                {
                                                        $columns = $columnstemp['serviceselected'];
                                                        break;
                                                }                                        
                                                case 'product':
                                                {
                                                        $columns = $columnstemp['productselected'];
                                                        break;
                                                }
                                                case 'experts':
                                                {
                                                        $columns = $columnstemp['expertselected'];
                                                        break;
                                                }
                                        }
                                        
                                        $html1 = $this->fetch_template('search_results_list_col_header.html');
                                        $html1 = $this->parse_hash('search_results_list_col_header.html', array('ilconfig' => $ilconfig, 'ilpage' => $ilpage), $parseglobals = 0, $html1);
                                        $html1 = $this->parse_if_blocks('search_results_list_col_header.html', $html1, $addslashes = true);
                                        
                                        $html1 = stripslashes($html1);
                                        $html1 = addslashes($html1);
                                        $html1 = str_replace('$', '\$', $html1);
                                        
                                        eval('$html = "' . $html1 . '";');
                                        unset($html1);
                                        
                                        foreach ($columns AS $td)
                                        {
                                                if (isset($td) AND $td == 'distance')
                                                {
                                                        if ($ilconfig['globalserver_enabledistanceradius'])
                                                        {
                                                                $html .= $this->print_td_list_head($td);
                                                        }
                                                }
                                                else
                                                {
                                                        $html .= $this->print_td_list_head($td);
                                                }
                                        }
                                        
                                        $html1 = $this->fetch_template('search_results_list_col_footer.html');
                                        $html1 = $this->parse_hash('search_results_list_col_footer.html', array('ilconfig' => $ilconfig, 'ilpage' => $ilpage), $parseglobals = 0, $html1);
                                        $html1 = $this->parse_if_blocks('search_results_list_col_footer.html', $html1, $addslashes = true);
                                        
                                        $html1 = stripslashes($html1);
                                        $html1 = addslashes($html1);
                                        $html1 = str_replace('$', '\$', $html1);
                                        
                                        eval('$html .= "' . $html1 . '";');
                                        unset($html1);
                                        
                                        break;
                                }
                                
                                case 'gallery':
                                {
                                        $html = '';
                                        $numcols = 3;
                                        $numitems = count($searchresults);
                                        $numrows = ceil($numitems / $numcols);
                                        $columns = $numcols;
                                        
                                        for ($row = 1; $row <= $numrows; $row++)
                                        {
                                                $cell = 0;
                                                $html .= '<tr>';

                                                for ($col = 1; $col <= $numcols; $col++)
                                                {
                                                            if ($col === 1)
                                                            {
                                                                        // generate table data
                                                                        $cell += $row;
                                                                        if (isset($searchresults[$cell - 1]))
                                                                        {
                                                                                $results = $searchresults[$cell - 1];
                                                                        }
                                                                        else
                                                                        {
                                                                                $results = array();
                                                                        }
                                                                        
                                                                        if (isset($results['highlite']) AND $results['highlite'])
                                                                        {
                                                                                $class = 'featured_highlight';
                                                                        }
                                                                        else
                                                                        {
                                                                                $class = 'alt1';
                                                                                if (!empty($results['class']))
                                                                                {
                                                                                        $class = $results['class'];
                                                                                }
                                                                        }
                                                                        
                                                                        $html .= '<td valign="top" width="12.5%" class="alt1">';
                                                                        $html .= $this->print_td_gallery_head($results, $mode);
                                                            }
                                                            else
                                                            {
                                                                        // generate table data
                                                                        $cell += $numrows;
                                                                        if (isset($searchresults[$cell - 1]))
                                                                        {
                                                                                $results = $searchresults[$cell - 1];
                                                                        }
                                                                        else
                                                                        {
                                                                                $results = array();
                                                                        }
                                                                        
                                                                        if (isset($results['highlite']) AND $results['highlite'])
                                                                        {
                                                                                $class = 'featured_highlight';
                                                                        }
                                                                        else
                                                                        {
                                                                                $class = 'alt1';
                                                                                if (!empty($results['class']))
                                                                                {
                                                                                        $class = $results['class'];
                                                                                }
                                                                        }
                                                                        
                                                                        $html .= '<td valign="top" width="12.5%" class="alt1">';
                                                                        $html .= $this->print_td_gallery_head($results, $mode);
                                                            }
                                                            $html .= '</td>';
                                                }
                                                $html .= '</tr>';
                                                $html .= '<tr><td height="1" colspan="' . $numcols . '"></td></tr>';
                                        }
                                        break;
                                }
                        }
                }
                
                $rows = $this->print_td_rows($columns, $searchresults, $listview);
                $columns = count($columns);
                if ($listview == 'gallery')
                {
                        $columns = $numcols;
                }
                
                if (!empty($html))
                {
                        $html = stripslashes($html);
                }
                
                // return html and the number of columns generated (for colspan callback)
                $return = array('columns' => $html, 'rows' => $rows, 'colspan' => $columns);
                
                return $return;
        }
        
        /*
        * Function to handle special column output like title, distance and average bid
        *
        * @param       
        *
        * @return      
        */
        function print_td_rows($columns, $searchresults = array(), $listview = 'list')
        {
                global $ilance, $show, $ilconfig, $phrase, $ilpage;
                
                $ilance->auction_questions = construct_object('api.auction_questions');
                
                if ($listview == 'gallery')
                {
                        return '';
                }
                
                $rows = '';
                if (!empty($searchresults) AND is_array($searchresults))
                {
                        foreach ($searchresults AS $key => $value)
                        {
                                $html1 = $this->fetch_template('search_results_list_row_header.html');
                                $html1 = $this->parse_hash('search_results_list_row_header.html', array('ilconfig' => $ilconfig, 'ilpage' => $ilpage, 'value' => $value), $parseglobals = 0, $html1);
                                $html1 = $this->parse_if_blocks('search_results_list_row_header.html', $html1, $addslashes = true);
                                
                                $html1 = stripslashes($html1);
                                $html1 = addslashes($html1);
                                $html1 = str_replace('$', '\$', $html1);
                                
                                eval('$rows .= "' . $html1 . '";');
                                unset($html1);
                                
                                foreach ($columns AS $column)
                                {
                                        $value['rowclass'] = ($this->columninfo["$column"]['rowclass']) ? 'class="' . $this->columninfo["$column"]['rowclass'] . '"' : '';
                                        $value['colspan'] = (!empty($this->columninfo["$column"]['colspan'])) ? 'colspan="' . $this->columninfo["$column"]['colspan'] . '"' : '';
                                        $value['nowrap'] = (!empty($this->columninfo["$column"]['nowrap'])) ? 'nowrap="nowrap"' : '';
                                        $value['extra'] = (!empty($this->columninfo["$column"]['extra'])) ? $this->columninfo["$column"]['extra'] : '';
                                        $value['class'] = $this->columninfo["$column"]['class'];
                                        $value['align'] = $this->columninfo["$column"]['align'];
                                        $value['valign'] = $this->columninfo["$column"]['valign'];
                                        $value['width'] = $this->columninfo["$column"]['width'];
                                        
                                        if (mb_ereg('profile_', $column))
                                        {
                                                // custom profile question
                                                $profileqid = explode('_', $column);
                                                
                                                $sql = $ilance->db->query("
                                                        SELECT answer, isverified
                                                        FROM " . DB_PREFIX . "profile_answers
                                                        WHERE questionid = '" . intval($profileqid[1]) . "'
                                                                AND user_id = '" . intval($value['user_id']) . "'
                                                ");
                                                if ($ilance->db->num_rows($sql) > 0)
                                                {
                                                        $res = $ilance->db->fetch_array($sql);
                                                        $isverified = '';
                                                        if ($res['isverified'])
                                                        {
                                                                $isverified = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'verified_icon.gif" alt="" border="0" />';
                                                        }
                                                        
                                                        $value['isverified'] = $isverified;
                                                        $value['align'] = $this->columninfo["default"]['rowalign'];
                                                        $value['valign'] = $this->columninfo["default"]['valign'];
                                                        $value['answer'] = $res['answer'];
                                                }
                                                else
                                                {
                                                        $value['isverified'] = '';
                                                        $value['align'] = $this->columninfo["default"]['rowalign'];
                                                        $value['valign'] = $this->columninfo["default"]['valign'];
                                                        $value['answer'] = '-';
                                                }
                                                
                                                $html1 = $this->fetch_template('search_results_list_row_data_profilefilter.html');
                                                $html1 = $this->parse_hash('search_results_list_row_data_profilefilter.html', array('ilconfig' => $ilconfig, 'ilpage' => $ilpage, 'value' => $value), $parseglobals = 0, $html1);
                                                $html1 = $this->parse_if_blocks('search_results_list_row_data_profilefilter.html', $html1, $addslashes = true);
                                                
                                                $html1 = stripslashes($html1);
                                                $html1 = addslashes($html1);
                                                $html1 = str_replace('$', '\$', $html1);
                                                
                                                eval('$rows .= "' . $html1 . '";');
                                                unset($html1);
                                        }
                                        else if ($column == 'title')
                                        {
                                                $value['column'] = $value["$column"];
                                                $value['icons'] = ($this->can_display_element('icons')) ? '<span style="float:right">' . $value['icons'] . '</span>' : '';
                                                $value['description'] = ($this->can_display_element('description')) ? '<div class="smaller gray" style="padding-top:3px">' . $value['description'] . '</div>' : '';
                                                $value['user'] = ($this->can_display_element('username')) ? '<div class="smaller" style="padding-top:3px">' . $value['username'] . '</div>' : '';
                                                $value['proxybit'] = ($value['project_state'] == 'product' AND $this->can_display_element('proxybit') AND !empty($value['proxybit'])) ? $value['proxybit'] : '';
                                                
                                                $html1 = $this->fetch_template('search_results_list_row_data_title.html');
                                                $html1 = $this->parse_hash('search_results_list_row_data_title.html', array('ilconfig' => $ilconfig, 'ilpage' => $ilpage, 'value' => $value), $parseglobals = 0, $html1);
                                                $html1 = $this->parse_if_blocks('search_results_list_row_data_title.html', $html1, $addslashes = true);
                                                
                                                $html1 = stripslashes($html1);
                                                $html1 = addslashes($html1);
                                                $html1 = str_replace('$', '\$', $html1);
                                                
                                                eval('$rows .= "' . $html1 . '";');
                                                unset($html1);
                                        }
                                        else if ($column == 'distance' AND isset($show['distancecolumn']) AND $show['distancecolumn'])
                                        {
                                                if ($ilconfig['globalserver_enabledistanceradius'])
                                                {
                                                        $value['column'] = $value["$column"];
                                                        
                                                        $html1 = $this->fetch_template('search_results_list_row_data_distance.html');
                                                        $html1 = $this->parse_hash('search_results_list_row_data_distance.html', array('ilconfig' => $ilconfig, 'ilpage' => $ilpage, 'value' => $value), $parseglobals = 0, $html1);
                                                        $html1 = $this->parse_if_blocks('search_results_list_row_data_distance.html', $html1, $addslashes = true);
                                                        
                                                        $html1 = stripslashes($html1);
                                                        $html1 = addslashes($html1);
                                                        $html1 = str_replace('$', '\$', $html1);
                                                        
                                                        eval('$rows .= "' . $html1 . '";');
                                                        unset($html1);
                                                }
                                        }
                                        else if ($column == 'averagebid')
                                        {
                                                $value['average'] = (($this->can_display_element('currencyconvert')) ? $value['averagebid'] : $value['averagebid_plain']);
                                                
                                                $html1 = $this->fetch_template('search_results_list_row_data_average.html');
                                                $html1 = $this->parse_hash('search_results_list_row_data_average.html', array('ilconfig' => $ilconfig, 'ilpage' => $ilpage, 'value' => $value), $parseglobals = 0, $html1);
                                                $html1 = $this->parse_if_blocks('search_results_list_row_data_average.html', $html1, $addslashes = true);
                                                
                                                $html1 = stripslashes($html1);
                                                $html1 = addslashes($html1);
                                                $html1 = str_replace('$', '\$', $html1);
                                                
                                                eval('$rows .= "' . $html1 . '";');
                                                unset($html1);
                                        }
                                        else if ($column == 'expert')
                                        {
                                                $value['online'] = ($this->can_display_element('online')) ? '<span style="float:right" class="smaller">' . $value['isonline'] . '</span>' : '';
                                                $value['latestfeedback'] = ($this->can_display_element('latestfeedback') AND !empty($value['latestfeedback'])) ? '<div class="smaller" style="padding-top:2px">' . $phrase['_latest_feedback'] . ': <span class="gray">' . $value['latestfeedback'] . '</span></div>' : '';
                                                $value['skills'] = ($ilconfig['enableskills']) ? '<div style="padding-top:4px"><table border="0" cellpadding="0" cellspacing="0"><tr><td valign="top"><div class="smaller">' . $phrase['_skills'] . ':</td><td>&nbsp;</td><td><span class="smaller blue">' . print_skills($value['user_id']) . '</span></td></tr></table></div>' : '';
                                                $value['profileintro'] = '<div class="gray" style="padding-top:2px">' . fetch_user('profileintro', $value['user_id'], '', '', false) . '</div>';
                                                
                                                $html1 = $this->fetch_template('search_results_list_row_data_expert.html');
                                                $html1 = $this->parse_hash('search_results_list_row_data_expert.html', array('ilconfig' => $ilconfig, 'ilpage' => $ilpage, 'value' => $value), $parseglobals = 0, $html1);
                                                $html1 = $this->parse_if_blocks('search_results_list_row_data_expert.html', $html1, $addslashes = true);
                                                
                                                $html1 = stripslashes($html1);
                                                $html1 = addslashes($html1);
                                                $html1 = str_replace('$', '\$', $html1);
                                                
                                                eval('$rows .= "' . $html1 . '";');
                                                unset($html1);
                                        }
                                        else
                                        {
                                                $value['column'] = $value["$column"];
                                                
                                                $html1 = $this->fetch_template('search_results_list_row_data.html');
                                                $html1 = $this->parse_hash('search_results_list_row_data.html', array('ilconfig' => $ilconfig, 'ilpage' => $ilpage, 'value' => $value), $parseglobals = 0, $html1);
                                                $html1 = $this->parse_if_blocks('search_results_list_row_data.html', $html1, $addslashes = true);
                                                
                                                $html1 = stripslashes($html1);
                                                $html1 = addslashes($html1);
                                                $html1 = str_replace('$', '\$', $html1);
                                                
                                                eval('$rows .= "' . $html1 . '";');
                                                unset($html1);
                                        }
                                }
                                
                                $html1 = $this->fetch_template('search_results_list_row_footer.html');
                                $html1 = $this->parse_hash('search_results_list_row_footer.html', array('ilconfig' => $ilconfig, 'ilpage' => $ilpage, 'value' => $value), $parseglobals = 0, $html1);
                                $html1 = $this->parse_if_blocks('search_results_list_row_footer.html', $html1, $addslashes = true);
                                
                                $html1 = stripslashes($html1);
                                $html1 = addslashes($html1);
                                $html1 = str_replace('$', '\$', $html1);
                                
                                eval('$rows .= "' . $html1 . '";');
                                unset($html1);
                        }
                        
                        $rows = stripslashes($rows);
                }
                
                return $rows;
        }
        
        /*
        * ...
        *
        * @param       
        *
        * @return      
        */
        function can_display_element($option = '')
        {
                if (!empty($_SESSION['ilancedata']['user']['searchoptions']))
                {
                        $temp = unserialize($_SESSION['ilancedata']['user']['searchoptions']);
                        if (isset($temp[$option]) AND $temp[$option] == 'true')
                        {
                                return true;
                        }
                        
                        return false;
                }
                else
                {
                        // default everything enabled (just in case)
                        return true;
                }
        }
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: class.template_files.inc.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>