<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/
$phrase['groups'] = array(
	'livebid',
	'subscription'
);

define('LOCATION','livebid');
function rz(&$item1, $key)
{
	if ($item1[0] == 0)
	{
		$item1 = mb_substr($item1, 1);
	}
}

function convertToTimeStamp($str)
{
	preg_match_all("'(\d{4})-(\d{2})-(\d{2})\s{1}(\d{2}):(\d{2}):(\d{2})'", $str, $m);
	array_walk($m, "rz");
	
	return mktime($m[4][0], $m[5][0], $m[6][0], $m[2][0], $m[3][0], $m[1][0]);
}

// #### USER INFO PARSER CALLED FROM WITHIN THE .SWF ###########################
// serv.load(_parent._parent._parent.serverPrefix + "livebid.php?cmd=userinfo&sid=" + sId + "&bid=" + bidId + "&pid=" + prId + "&r=" + Math.random());
if (isset($_REQUEST['cmd']) AND $_REQUEST['cmd'] == 'userinfo')
{
	require_once('../functions/config.php');
	
	$_REQUEST['pid'] = (isset($_REQUEST['pid']) ? intval($_REQUEST['pid']) : 0);
	$_REQUEST['bid'] = (isset($_REQUEST['bid']) ? intval($_REQUEST['bid']) : 0);
        
	$projectinfo = $userinfo = array();
	
	$projectinfo = $ilance->db->fetch_array($ilance->db->query("
                SELECT project_state, bid_details
                FROM " . DB_PREFIX . "projects
                WHERE project_id = '" . intval($_REQUEST['pid']) . "'
        "));
    
	$ilance->feedback = construct_object('api.feedback');
	
	if ($projectinfo['project_state'] == 'service')
	{
		$biddertype = $phrase['_provider'] . ': ';
		$memberinfo = array();
                $memberinfo = $ilance->feedback->datastore(intval($_REQUEST['bid']));
		$ratings = $memberinfo['rating'];
		$reviews = fetch_service_reviews_reported(intval($_REQUEST['bid']));
		$auctiontype = $phrase['_service_rating'] . ': ';
	}
	else if ($projectinfo['project_state'] == 'product')
	{
		$biddertype = $phrase['_bidder'] . ': ';
		$memberinfo = array();
                $memberinfo = $ilance->feedback->datastore(intval($_REQUEST['bid']));
		$ratings = $memberinfo['rating'];
		$reviews = fetch_product_reviews_reported(intval($_REQUEST['bid']));
		$auctiontype = $phrase['_rating'] . ': ';
	}
	else
	{
		$biddertype = $phrase['_bidder'] . ': ';
		$ratings = '0.00';
		$reviews = '0';
		$auctiontype = $phrase['_rating'] . ': ';
	}
	
	switch ($projectinfo['bid_details'])
	{
		case 'open':
		{
			$userinfo = $ilance->db->fetch_array($ilance->db->query("
                                SELECT username
                                FROM " . DB_PREFIX . "users
                                WHERE user_id = '" . intval($_REQUEST['bid']) . "'
                        "));
			break;
		}	    
		case 'sealed':
		{
			$userinfo = $ilance->db->fetch_array($ilance->db->query("
                                SELECT username
                                FROM " . DB_PREFIX . "users
                                WHERE user_id = '" . intval($_REQUEST['bid']) . "'
                        "));
			break;
		}	    
		case 'blind':
		case 'full':
		{
			$userinfo['username'] = '-- ' . $phrase['_blind'] . ' --';
			break;
		}
	}
	$usernameinfo = stripslashes($userinfo['username']);
        
	//echo "username=" . urlencode($usernameinfo) . "&tooltip=" . urlencode($biddertype) . urlencode($usernameinfo) . "\r" . urlencode($auctiontype) . urlencode($ratings) . "\r" . urlencode($phrase['_feedback']) . ": " . intval($reviews) . "&";
        echo "username=" . urlencode($usernameinfo) . "&tooltip=" . urlencode($biddertype) . urlencode($usernameinfo) . "&";
}

// #### AUCTION INFO PARSER CALLED FROM WITHIN THE .SWF ########################
// serv.load(serverPrefix + "livebid.php?cmd=auctioninfo&from=" + limiter + "&pid=" + prId + "&sid=" + sId + "&r=" + Math.random());
else if (isset($_REQUEST['cmd']) AND $_REQUEST['cmd'] == 'auctioninfo')
{
	require_once('livebid_connect.php');
	
	$pid = (isset($_REQUEST['pid']) ? intval($_REQUEST['pid']) : 0);
	
	$qid = mysql_query("
		SELECT project_title, UNIX_TIMESTAMP(date_end) AS date_end, UNIX_TIMESTAMP(date_starts) AS date_starts, UNIX_TIMESTAMP('" . DATETIME24H . "') AS DATETIME24H
		FROM " . DB_PREFIX . "projects
		WHERE project_id = '" . $pid . "'
	");
	if (mysql_num_rows($qid) == 0)
	{
		die('error=Invalid RFP&');
	}
	else
	{
		$p = mysql_fetch_array($qid);    
		if (!isset($_REQUEST['from']) OR $_REQUEST['from'] == 0)
		{
			$_REQUEST['from'] = 0;
			$dateline = DATETIME24H;
		}
		else
		{
			$_REQUEST['from'] = intval($_REQUEST['from']);
			$dateline = date("Y-m-d H:i:s", $_REQUEST['from']);
		}
		
		$bids = '';
		$c = 0;
		
		$qid2 = mysql_query("
			SELECT id, bid_id, user_id, bidamount, date_added AS d_a, UNIX_TIMESTAMP(date_added) AS date_added
			FROM " . DB_PREFIX . "project_realtimebids
			WHERE project_id = '" . $pid . "'
			ORDER BY id ASC
		");
		if (mysql_num_rows($qid2) > 0)
		{
			while ($bid = mysql_fetch_array($qid2))
			{
				$c++;
				//$bids .= 'newbid' . $c . '_id=' . $bid['bid_id']
				$bids .= 'newbid' . $c . '_id=' . $bid['id']
				      . '&newbid' . $c . '_bidderid=' . $bid['user_id']
				      . '&newbid' . $c . '_amount=' . $bid['bidamount']
				      . '&newbid' . $c . '_time=' . $bid['date_added']
				      . '&newbid' . $c . '_da=' . rawurlencode(date("M-d-Y h:i:s", $bid['date_added']))
				      . '&';
			}
			$bids .= 'newbids_count=' . $c . '&';
			$intervaly = 100;
			$interval = (($p['date_end'] - $p['date_starts']) / 10);
			$interval = ($interval > 100) ? $interval : 100;
                        
			echo 'ctime=' . $p['DATETIME24H'] . '&intervaly=' . $intervaly . '&interval=' . $interval . '&description=' . urlencode(stripslashes($p['project_title'])) . '&date_starts=' . $p['date_starts'] . '&date_ends=' . $p['date_end'] . '&' . $bids;
		}
		else
		{
			
			$bid['id'] = $bid['bid_id'] = $bid['user_id'] = $bid['bidamount'] = $c = 0;
			$bid['date_added'] = '';
                        
			//$bids .= 'newbid' . $c . '_id=' . $bid['bid_id']
			$bids .= 'newbid' . $c . '_id=' . $bid['id']
			      . '&newbid' . $c . '_bidderid=' . $bid['user_id']
			      . '&newbid' . $c . '_amount=' . $bid['bidamount']
			      . '&newbid' . $c . '_time=' . $bid['date_added']
			      . '&newbid' . $c . '_da=' . rawurlencode(date("M-d-Y h:i:s"))
			      . '&newbids_count=' . $c . '&';
			      
			$intervaly = 100;
			$interval = (($p['date_end'] - $p['date_starts']) / 10);
			$interval = $interval > 100 ? $interval : 100;
                        
			echo 'ctime=' . $p['DATETIME24H'] . '&intervaly=' . $intervaly . '&interval=' . $interval . '&description=' . urlencode(stripslashes($p['project_title'])) . '&date_starts=' . $p['date_starts'] . '&date_ends=' . $p['date_end'] . '&' . $bids;
		}
		
		unset($bid);
		unset($p);	
	}
}

// #### AUCTION STATE HANDLER CALLED FROM .SWF #################################
// serv4.load(serverPrefix + "livebid.php?cmd=auctionstate&pid=" + prId + "&sid=" + sId + "&r=" + Math.random());
else if (isset($_REQUEST['cmd']) AND $_REQUEST['cmd'] == 'auctionstate')
{
	require_once('livebid_connect.php');
        
	if (empty($_REQUEST['pid']))
	{
		die('error=Invalid RFP&');
	}
	
	$qidp = mysql_query("
		SELECT project_state, reserve, reserve_price, bid_details
		FROM " . DB_PREFIX . "projects
		WHERE project_id = '" . intval($_REQUEST['pid']) . "'
	");
	if (mysql_num_rows($qidp) == 0)
	{
		die('error=RFP not Found&');
	}
	else
	{
		$p = mysql_fetch_array($qidp);
	}
    
	$winner = $winnertex = '';
	if ($p['project_state'] == 'product')
	{
		// product auction
		$sqlbid = mysql_query("
			SELECT bidamount, user_id
			FROM " . DB_PREFIX . "project_bids
			WHERE project_id = '" . intval($_REQUEST['pid']) . "'
			ORDER BY bidamount DESC
			LIMIT 1
		");
		if (mysql_num_rows($sqlbid) > 0)
		{
			$bid = mysql_fetch_array($sqlbid);
			switch ($p['bid_details'])
			{
				case 'open':
				{
					$bidder = mysql_fetch_array(mysql_query("
						SELECT username
						FROM " . DB_PREFIX . "users
						WHERE user_id = '" . $bid['user_id'] . "'
					"));
					break;
				}
				case 'sealed':
				{
					$bidder = mysql_fetch_array(mysql_query("
						SELECT username
						FROM " . DB_PREFIX . "users
						WHERE user_id = '" . $bid['user_id'] . "'
					"));
					break;
				}
				case 'blind':
				case 'full':
				{
					$bidder['username'] = '-- ' . $phrase['_blind'] . ' --';
					break;
				}
			}
			
			// adhere to merchants reserve price
			if ($p['reserve'] > 0)
			{
				// product auction with reserve activated
				if ($bid['bidamount'] >= $p['reserve_price'])
				{
					// bid amount is good
					$winner = $bidder['username'];
					$winnertex  = '';
				}
				else
				{
					$winner = '';
					$winnertex = '';
				}
			}
			else
			{
				// product without reserve
				$winner = $bidder['username'];
				$winnertex = '';
			}
		}
	}
	else
	{
		// service auction
		$sqlp = mysql_query("
			SELECT user_id
			FROM " . DB_PREFIX . "project_bids
			WHERE project_id = '" . intval($_REQUEST['pid']) . "'
			    AND bidstatus = 'awarded'
			LIMIT 1
		");
		if (mysql_num_rows($sqlp) > 0)
		{
			$bid = mysql_fetch_array($sqlp);
			switch ($p['bid_details'])
			{
				case 'open':
				{
					$bidder = mysql_fetch_array(mysql_query("
                                                SELECT username
                                                FROM " . DB_PREFIX . "users
                                                WHERE user_id = '" . $bid['user_id'] . "'
                                        "));
					break;
				}
				case 'sealed':
				{
					$bidder = mysql_fetch_array(mysql_query("
                                                SELECT username
                                                FROM " . DB_PREFIX . "users
                                                WHERE user_id = '" . $bid['user_id'] . "'
                                        "));
					break;
				}
				case 'blind':
				case 'full':
				{
					$bidder['username'] = '-- ' . $phrase['_blind'] . ' --';
					break;
				}
			}
			$winner = stripslashes($bidder['username']);
		}
	}
	
	unset($p);
	unset($bid);
	
	echo 'winnertext=' . $winnertex . '&winner=' . $winner . '&';
}

// #### AUCTION STATUS PARSER CALLED FROM WITHIN .SWF ##########################
// serv.load(serverPrefix + "livebid.php?cmd=auctionstatus&sid=" + sId + "&pid=" + _projectId + "&r=" + Math.random());
else if (isset($_REQUEST['cmd']) AND $_REQUEST['cmd'] == 'auctionstatus')
{
	require_once('livebid_connect.php');
	
	if (empty($_REQUEST['pid']))
	{
		die('error=Invalid RFP&');
	}
	
	$qid = mysql_query("
		SELECT user_id, status, date_end
		FROM " . DB_PREFIX . "projects
		WHERE project_id = '" . intval($_REQUEST['pid']) . "'
	");
	if (mysql_num_rows($qid) == 0)
	{
		die('error=RFP not Found&');
	}
	else
	{
		$p = mysql_fetch_array($qid);
	}
    
	$qidbid = mysql_query("
		SELECT MIN(bidamount) AS minbidamount, MAX(bidamount) AS maxbidamount
		FROM " . DB_PREFIX . "project_bids
		WHERE project_id = '" . intval($_REQUEST['pid']) . "'
	");
	if (mysql_num_rows($qidbid) == 0)
	{
		$b = '';
	}
	else
	{
		$res = mysql_fetch_array($qidbid);
		$low = number_format($res['minbidamount'], 2);
		$high = number_format($res['maxbidamount'], 2);
	}
    
	$qidvendor = mysql_query("
		SELECT username
		FROM " . DB_PREFIX . "users
		WHERE user_id = '" . $p['user_id'] . "'
	");
	if (mysql_num_rows($qidvendor) == 0)
	{
		die('error=Vendor not found&');
	}
	else
	{
		$v = mysql_fetch_array($qidvendor);
	}
	echo 'now=' . convertToTimeStamp(DATETIME24H) . '&closed=' . ($p['status'] == 'closed' ? 1 : 0) . '&date_ends=' . convertToTimeStamp($p['date_end']) . '&vendor=' . $v['username'] . '&lowestbid=' . $low . '&highestbid=' . $high . '&';
	
	unset($v);
	unset($res);
}

// #### VENDOR INFO CALLED FROM WITHIN .SWF ####################################
// serv.load(serverPrefix + "livebid.php?cmd=vendorinfo&sid=" + sId + "&r=" + Math.random())
else if (isset($_REQUEST['cmd']) AND $_REQUEST['cmd'] == 'vendorinfo')
{
	require_once('../functions/config.php');
        
        $vendor_id = $counter = 0;
        $p = $qb = $maxmin = array();
        
	if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0)
	{
		$vendor_id  = intval($_SESSION['ilancedata']['user']['userid']);
	}
	
	$l = '';
    
	$qid = $ilance->db->query("
		SELECT project_id, project_title
		FROM " . DB_PREFIX . "projects
		WHERE user_id = '" . intval($vendor_id) . "'
	");
	while ($p = $ilance->db->fetch_array($qid))
	{
		$counter++;
		$qb = $ilance->db->fetch_array($ilance->db->query("
			SELECT COUNT(bid_id) AS c
			FROM " . DB_PREFIX . "project_bids
			WHERE project_id = '" . $p['project_id'] . "'
		"));
		
		$maxmin = $ilance->db->fetch_array($ilance->db->query("
			SELECT MAX(bidamount) AS max, MIN(bidamount) AS min
			FROM " . DB_PREFIX . "project_bids
			WHERE project_id = '" . $p['project_id'] . "'
		"));
		
		if ($maxmin['max'] == null) $maxmin['max'] = 0;
		if ($maxmin['min'] == null) $maxmin['min'] = 0;
		
		$l .= 'description' . $counter . '=' . urlencode(stripslashes($p['project_title'])) . '&bids' . $counter . '=' . $qb['c'] . '&minbid' . $counter . '=' . $maxmin['min'] . '&maxbid' . $counter . '=' . $maxmin['max'] . '&';
	}
	unset($p);
        
	echo 'pcount=' . $counter . '&' . $l;
}

// #### TIME SYNC CALLED FROM WITHIN .SWF ######################################
// serv2.load(serverPrefix + "livebid.php?cmd=timesync&sid=" + sId + "&r=" + Math.random());
else if (isset($_REQUEST['cmd']) AND $_REQUEST['cmd'] == 'timesync')
{
	require_once('livebid_connect.php');
	
        $timestamp = strtotime(DATETIME24H);
	echo 't=' . $timestamp . '&';
        
	unset($timestamp);
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: livebid.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>