<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

// #### load required phrase groups ############################################
$phrase['groups'] = array(
	'accounting',
);

// #### define top header nav ##########################################
$topnavlink = array(
	'rss'
);

// #### setup script location ##################################################
define('LOCATION','rss');

// #### require backend ########################################################
require_once('./functions/config.php');

// #### setup default breadcrumb ###############################################
$navcrumb = array("$ilpage[rss]" => $ilcrumbs["$ilpage[rss]"]);

($apihook = $ilance->api('rss_start')) ? eval($apihook) : false;

// #### SYNDICATION SERVICE AUCTIONS ###########################################
if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'syndication' AND isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == 'serviceauctions')
{
	$area_title = $phrase['_syndicating_service_auctions'];
	$page_title = SITE_NAME . ' - ' . $phrase['_syndicating_service_auctions'];

	$ilance->GPC['limit'] = isset($ilance->GPC['limit']) ? intval($ilance->GPC['limit']) : 15;

	$myRSS = construct_object('api.myrss');
	
	$myRSS->channelTitle = SITE_NAME . ' ' . $phrase['_service_auctions'];
	$myRSS->channelLink = HTTP_SERVER;
	$myRSS->channelDesc = $phrase['_service_auctions_open_for_bid'];	
	$myRSS->imageTitle = SITE_NAME . ' ' . $phrase['_service_auctions'];
	$myRSS->imageLink = HTTP_SERVER;
	$myRSS->imageURL = $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'logo.gif';

	// subcategory selection
	if (isset($ilance->GPC['sid']) AND $ilance->GPC['sid'] == 'all')
	{
		$SubCatClause = "AND cid > 0";
	}
	else if (!empty($ilance->GPC['sid']) AND $ilance->GPC['sid'] != 'all')
	{
		$cats = $ilance->GPC['sid'];
		$pieces = explode(',', $cats);
		$count = count($pieces);
		$piece = '';
		if ($count > 1)
		{
			$piece = " AND ( ";
			foreach ($pieces as $subcatvalue)
			{
				$piece .= " (cid = '" . intval($subcatvalue) . "') OR ";
			}
			$SubCatClause = mb_substr($piece, 0, -3);
			$SubCatClause = $SubCatClause . " ) ";
		}
		else
		{
			$piece .= " AND (cid = '" . intval($cats) . "') ";
			$SubCatClause = $piece;
		}
	}
	else
	{
		$SubCatClause = "AND cid > 0";
	
	}
	
	// WHERE clause
	$WhereClause = "WHERE project_state = 'service' AND status = 'open' " . (($ilconfig['globalauctionsettings_payperpost']) ? "AND visible = '1' AND (insertionfee = 0 OR (insertionfee > 0 AND ifinvoiceid > 0 AND isifpaid = '1'))" : "AND visible = '1'") . " " . $SubCatClause;
	$LimitClause = "LIMIT ".intval($ilance->GPC['limit']);
	
	// get the RSS data
	$rssData = $myRSS->GetRSS(
		DB_PREFIX . 'projects',
		'project_title', 
		'description', 
		'project_id, date_starts', 
		HTTP_SERVER . $ilpage['rfp'] . '?id={linkId}',
		$WhereClause, 
		$LimitClause,
		'project_id'
	);
	
	// output the generated RSS XML
	header('Content-type: application/xml; charset="' . $ilconfig['template_charset'] . '"');
	
	echo $rssData;
}

// #### SYNDICATE PRODUCT AUCTIONS #############################################
else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'syndication' AND isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == 'productauctions')
{
	$area_title = $phrase['_syndicating_product_auctions'];
	$page_title = SITE_NAME.' - '.$phrase['_syndicating_product_auctions'];

	$myRSS = construct_object('api.myrss');
	
	$myRSS->channelTitle = SITE_NAME." ".$phrase['_product_auctions'];
	$myRSS->channelLink = HTTP_SERVER;
	$myRSS->channelDesc = $phrase['_product_auctions_open_for_bid'];
	
	$myRSS->imageTitle = SITE_NAME." ".$phrase['_product_auctions'];
	$myRSS->imageLink = HTTP_SERVER;
	$myRSS->imageURL = $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'logo.gif';
	
	// Subcategory Selection
	if (isset($ilance->GPC['sid']) AND $ilance->GPC['sid'] == 'all')
	{
		$SubCatClause = "AND cid > 0";
	}
	else if (isset($ilance->GPC['sid']) AND $ilance->GPC['sid'] != "" AND $ilance->GPC['sid'] != "all")
	{
		$cats = $ilance->GPC['sid'];
		$pieces = explode(",", $cats);
		$piece = '';
		$count = count($pieces);
		if ($count > 1)
		{
			$piece = " AND ( ";
			foreach ($pieces as $subcatvalue)
			{
				$piece .= " (cid = '" . intval($subcatvalue) . "') OR ";
			}
			
			// removes trailing OR	
			$SubCatClause = mb_substr($piece, 0, -3);
			$SubCatClause = $SubCatClause." ) ";
		}
		else
		{
			$piece .= " AND (cid = '$cats') ";
			$SubCatClause = $piece;
		}
	}
	else
	{
		$SubCatClause = "AND cid > 0";
	}
	
	// WHERE clause
	$WhereClause = "WHERE project_state = 'product' AND status = 'open' " . (($ilconfig['globalauctionsettings_payperpost']) ? "AND visible = '1' AND (insertionfee = 0 OR (insertionfee > 0 AND ifinvoiceid > 0 AND isifpaid = '1'))" : "AND visible = '1'") . " " . $SubCatClause;
	$LimitClause = "LIMIT ".intval($ilance->GPC['limit']);
	
	// Get the RSS data
	$rssData = $myRSS->GetRSS(
		DB_PREFIX . 'projects',
		'project_title',
		'description',
		'project_id, date_starts',
		HTTP_SERVER . $ilpage['merch'] . '?id={linkId}',
		$WhereClause,
		$LimitClause,
		'project_id'
	);
	
	// Output the generated RSS XML 
	header('Content-type: application/xml; charset="' . $ilconfig['template_charset'] . '"');
	
	echo $rssData;
}
else
{
	$area_title = $phrase['_syndication_generation_menu'];
	$page_title = SITE_NAME.' - '.$phrase['_syndication_generation_menu'];
	
	$show['generated_feed'] = false;
	if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'generate' AND !empty($ilance->GPC['cats']))
	{
		foreach ($ilance->GPC['cats'] as $value)
		{
			if (isset($categories))
			{
					 $categories .= $value.',';
			}
			else
			{
			    $categories = $value.',';
			}
		}
		$categories =  mb_substr($categories, 0, -1);
		$show['generated_feed'] = true;
		$syndicate_url = HTTP_SERVER . $ilpage['rss'] . '?cmd=syndication&subcmd=' . $ilance->GPC['subcmd'] . '&sid=' . $categories . '&limit=' . intval($ilance->GPC['limit']);
	}
	else
	{
		$show['generated_feed'] = false;
		$syndicate_url = '';
	}
	
	$ilance->categories_pulldown = construct_object('api.categories_pulldown');
	if ($ilconfig['globalauctionsettings_serviceauctionsenabled'])
	{
		$ilance->categories->build_array($cattype = 'service', $_SESSION['ilancedata']['user']['slng'], $mode = 2, $propersort = true);
		$service_category_multiple = $ilance->categories_pulldown->print_cat_pulldown(0, $cattype = 'service', $type = 'levelmulti', $fieldname = 'cats', $showpleaseselectoption = 0, $_SESSION['ilancedata']['user']['slng'], $nooptgroups = 1, $prepopulate = '', $mode = 2, $showallcats = 1, $dojs = 0, $width = '100%', $uid = 0, $forcenocount = 1, $expertspulldown = 0, $canassigntoall = false, $showbestmatching = false, $ilance->categories->cats);
	}	    
	if ($ilconfig['globalauctionsettings_productauctionsenabled'])
	{
		$ilance->categories->build_array($cattype = 'product', $_SESSION['ilancedata']['user']['slng'], $mode = 2, $propersort = true);
		$product_category_multiple = $ilance->categories_pulldown->print_cat_pulldown(0, $cattype = 'product', $type = 'levelmulti', $fieldname = 'cats', $showpleaseselectoption = 0, $_SESSION['ilancedata']['user']['slng'], $nooptgroups = 1, $prepopulate = '', $mode = 2, $showallcats = 1, $dojs = 0, $width = '100%', $uid = 0, $forcenocount = 1, $expertspulldown = 0, $canassigntoall = false, $showbestmatching = false, $ilance->categories->cats);
	}
	
	($apihook = $ilance->api('rss_main')) ? eval($apihook) : false;
	
	$ilance->template->load_file('main', 'main_rss.html');
	$ilance->template->parse_hash('main', array('ilpage' => $ilpage));
	$ilance->template->parse_if_blocks('main');
	$ilance->template->pprint('main', array('syndicate_url','service_category_multiple','product_category_multiple','remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
	exit();
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: rss.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>