<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

// #### load required phrase groups ############################################
$phrase['groups'] = array(
        'portfolio',
        'preferences'
);

// #### define top header nav ##################################################
$topnavlink = array(
	'upload'
);

// #### setup script location ##################################################
define('LOCATION','upload');

// #### require backend ########################################################
require_once('./functions/config.php');

// #### setup default breadcrumb ###############################################
$navcrumb = array("$ilpage[upload]" => $ilcrumbs["$ilpage[upload]"]);

if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0)
{
        $uncrypted = array();
        if (!empty($ilance->GPC['crypted']))
        {
                $uncrypted = decrypt_url($ilance->GPC['crypted']);
        }
        $crypted = $ilance->GPC['crypted'];
        
        $ilance->attachment = construct_object('api.attachment');
        $ilance->subscription = construct_object('api.subscription');
        
        $ilance->GPC['cmd'] = isset($ilance->GPC['cmd']) ? $ilance->GPC['cmd'] : '';
        
        $removeattachments = isset($ilance->GPC['removeattachments']) ? 1 : 0;
        $attachments = isset($ilance->GPC['attachments']) ? $ilance->GPC['attachments'] : '';
        $attach_user_max = print_filesize($ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'attachlimit'));
        $attachmentlistobj = !empty($uncrypted['attachmentlist']) ? $uncrypted['attachmentlist'] : 'attachmentlist';
            
        if (isset($uncrypted['attachtype']) AND $uncrypted['attachtype'] == 'portfolio')
        {
                if (empty($uncrypted['cid']))
                {
                        $uncrypted['cid'] = 0;
                }
                
                $cid = isset($uncrypted['cid']) ? intval($uncrypted['cid']) : 0;
        
                $ilance->categories_pulldown = construct_object('api.categories_pulldown');
                $ilance->categories->build_array($cattype = 'service', $_SESSION['ilancedata']['user']['slng'], $mode = 1, $propersort = true);
		$search_category_pulldown = $ilance->categories_pulldown->print_cat_pulldown(0, $cattype = 'service', $type = 'level', $fieldname = 'cid', $showpleaseselectoption = 0, $_SESSION['ilancedata']['user']['slng'], $nooptgroups = 1, $prepopulate = '', $mode = 1, $showallcats = 1, $dojs = 0, $width = '540px', $uid = 0, $forcenocount = 1, $expertspulldown = 0, $canassigntoall = false, $showbestmatching = false, $ilance->categories->cats);
        }
            
        // attachment storage information
        $attach_usage_total = $attach_usage_left = 0;
        
        $res_file_sum = array();
        $sql_file_sum = $ilance->db->query("
                SELECT SUM(filesize) AS attach_usage_total
                FROM " . DB_PREFIX . "attachment
                WHERE user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
        ");
        if ($ilance->db->num_rows($sql_file_sum) > 0)
        {
                $res_file_sum = $ilance->db->fetch_array($sql_file_sum);
                $attach_usage_total = print_filesize($res_file_sum['attach_usage_total']);
        }
        else
        {
                $res_file_sum['attach_usage_total'] = 0;
        }
        
        $attach_usage_left = ($ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'attachlimit') - $res_file_sum['attach_usage_total']);
        if ($attach_usage_left < 0)
        {
                $attach_usage_left = print_filesize(0);
        }
        else
        {
                $attach_usage_left = print_filesize($attach_usage_left);
        }
        
        // #### REMOVE ATTACHMENTS #################################################
        if (isset($removeattachments) AND $removeattachments AND isset($uncrypted['attachtype']))
        {
                $area_title = $phrase['_removing_file_attachments'];
                $page_title = SITE_NAME . ' - ' . $phrase['_removing_file_attachments'];
                
                $remote_addr = IPADDRESS;
                $referer = REFERRER;
                
                $error_message = '';
                
                $show['error'] = false;
                $show['notice'] = false;
                
                if (isset($attachments) AND is_array($attachments))
                {
                        foreach ($attachments AS $value)
                        {
                                // is this a portfolio attachment?
                                if ($ilance->db->fetch_field(DB_PREFIX."attachment", "attachid = '" . intval($value) . "'", "portfolio_id") > 0)
                                {
                                        $ilance->db->query("
                                                DELETE FROM " . DB_PREFIX . "portfolio
                                                WHERE portfolio_id = '" . $ilance->db->fetch_field(DB_PREFIX . "attachment", "attachid = '" . intval($value) . "'", "portfolio_id") . "'
                                                        AND user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                LIMIT 1
                                        ");
                                }
                                
                                $ilance->db->query("
                                        DELETE FROM " . DB_PREFIX . "attachment
                                        WHERE attachid = '" . intval($value) . "'
                                                AND user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                        LIMIT 1
                                ");
                        }
                }
                else
                {
                        $show['error'] = true;
                        $error_message = $phrase['_you_did_not_select_any_attachments_to_remove_operation_aborted'];
                }
                
                // #### rebuild attachment select list #########################
                $sql_attachments = array();
                
                $uncrypted['project_id'] = isset($uncrypted['project_id']) ? $uncrypted['project_id'] : 0;
                $uncrypted['user_id'] = isset($uncrypted['user_id']) ? $uncrypted['user_id'] : 0;
                
                $condition = $ilance->attachment->handle_attachtype_rebuild_settings($uncrypted['attachtype'], $uncrypted['user_id'], $uncrypted['project_id']);
                
                $maximum_files = $condition['maximum_files'];
                $max_width = $condition['max_width'];
                $max_height = $condition['max_height'];
                $max_filesize = $condition['max_filesize'];
                $max_size = $condition['max_size'];
                $extensions = $condition['extensions'];
                $query = $condition['query'];
                
                // #### check if the total attachment limit permission has exceeded for this members upload
                $futuresize = ($res_file_sum['attach_usage_total']);
                $totalpercentage = round(($futuresize / $ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'attachlimit')) * 100);
                
                if ($totalpercentage > 100)
                {
                        $show['error'] = true;
                        $error_message .= '<div>' . $phrase['_sorry_you_do_not_have_enough_space_to_upload_new_files'] . '</div>';        
                }
                
                unset($condition);
                
                $attachment_list_html = '';
                $attachment_list = '<select multiple name="attachments[]" size="5" style="overflow:hidden;width:380px;">';
                
                $sql_attachments = $ilance->db->query($query);
                if ($ilance->db->num_rows($sql_attachments) >= $maximum_files)
                {
                        $upload_style = 'disabled="disabled"';
                }
                while ($res = $ilance->db->fetch_array($sql_attachments))
                {            
                        $moderated = '';
                        if ($res['visible'] == 0)
                        {
                                $moderated = '[' . $phrase['_review_in_progress'] . ']';
                                $attachment_link = $res['filename'];
                        }
                        else
                        {
                                $attachment_link = '<a href="' . HTTP_SERVER . $ilpage['attachment'] . '?id=' . $res['filehash'] . '" target="_blank">' . $res['filename'] . '</a>';
                        }
                        
                        $attachment_list_html .= '<div><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'paperclip.gif" border="0" alt="' . $res['filename'] . '" /> ' . $attachment_link . ' (' . $res['filesize'] . ' ' . $phrase['_bytes'] . ') ' . $moderated . '</div>';
                        $attachment_list .= '<option value="' . $res['attachid'] . '">' . $res['filename'] . ' (' . print_filesize($res['filesize']) . ') ' . $moderated . '</option>';
                }
                
                $attachment_list .= '</select>';
                
                $js = $ilance->attachment->print_innerhtml_js($attachmentlistobj, $attachment_list_html);
                
                $headinclude .= '
<script type="text/javascript">
<!--
function toggle_id(idobjname)
{
        obj = fetch_js_object(idobjname);
        if (obj)
        {
                if (obj.style.display == "none")
                {
                        obj.style.display = "";
                }
                else
                {
                        obj.style.display = "none";
                }
        }
        return false;
}
';
                // #### PORTFOLIO UPLOAD JAVASCRIPT ############################
                if ($uncrypted['attachtype'] == 'portfolio')
                {
                        $headinclude .= '
function check_upload(formobj)
{
        var haveupload = false;
        var havecaption = false;
        var havedescription = false;
        var havecid = false;
        
        for (var i = 0; i < formobj.elements.length; i++)
        {
                var elm = formobj.elements[i];
                if (elm.type == "file")
                {
                        if (elm.value != "")
                        {
                                haveupload = true;
                        }
                }
                if (elm.name == "cid")
                {
                        if (elm.value != "0")
                        {
                                havecid = true;
                        }
                }
                if (elm.name == "caption")
                {
                        if (elm.value != "")
                        {
                                havecaption = true;
                        }
                }
                if (elm.name == "description")
                {
                        if (elm.value != "")
                        {
                                havedescription = true;
                        }
                }
        }
        if (!havecid)
        {
                alert(phrase[\'_please_select_a_portfolio_category_to_upload_this_attachment\']);
                return false;
        }
        if (!havecaption)
        {
                alert(phrase[\'_please_enter_a_caption_name_to_upload_this_attachment\']);
                return false;
        }
        if (!havedescription)
        {
                alert(phrase[\'_please_enter_a_description_to_upload_this_attachment\']);
                return false;
        }
        if (haveupload)
        {
                toggle_id(\'uploading\');
                return true;
        }
        else
        {
                alert(phrase[\'_please_use_the_browse_button_to_attach_media\']);
                return false;
        }
}
//-->
</script>
';	
                }
                
                // #### UPLOAD JAVASCRIPT ######################################
                else 
                {
                        $headinclude .= '
function check_upload(formobj)
{
        var haveupload = false;
        
        for (var i=0; i < formobj.elements.length; i++)
        {
                var elm = formobj.elements[i];
                if (elm.type == "file")
                {
                        if (elm.value != "")
                        {
                                haveupload = true;
                        }
                }
        }
        if (haveupload)
        {
                toggle_id("uploading");
                return true;
        }
        else
        {
                alert(phrase[\'_please_use_the_browse_button_to_attach_media\']);
                return false;
        }
}
//-->
</script>
';	
                }
                
                // detect if we need to refresh the parent menu after this popup attachment window closes
                // this is useful for places like portfolio menu where the user uploads new images
                $onbeforeunload = '';
                $closeonclick = 'window.close();';
                if (isset($ilance->GPC['refresh']) AND $ilance->GPC['refresh'])
                {
                        $headinclude .= "
<script type=\"text/javascript\">
<!--
function close_popup_window()
{
        window.close();
        if (window.opener && !window.opener.closed)
        {
                window.opener.location.reload();
        }
}
//-->
</script>
";
                        
                        $closeonclick = 'close_popup_window();';
                }
                
                $ilance->template->load_popup('popupheader', 'popup_header.html');
                $ilance->template->load_popup('popupmain', 'popup_upload_attachment.html');
                $ilance->template->load_popup('popupfooter', 'popup_footer.html');
                $ilance->template->parse_hash('popupheader', array('ilpage' => $ilpage));
                $ilance->template->parse_hash('popupmain', array('ilpage' => $ilpage));
                $ilance->template->parse_hash('popupfooter', array('ilpage' => $ilpage));
                $ilance->template->parse_if_blocks('popupheader');
                $ilance->template->parse_if_blocks('popupmain');
                $ilance->template->parse_if_blocks('popupfooter');
                $ilance->template->pprint('popupheader', array('headinclude','onload','onbeforeunload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','meta_desc','meta_keyw') );
                $ilance->template->pprint('popupmain', array('closeonclick','crypted','js','search_category_pulldown','attach_usage_total','attach_usage_left','extensions','max_size','max_width','max_height','error_message','notice_message','maximum_files','attach_user_max','upload_style','pmb_id','attachment_list','project_id','portfolio_id','bid_id','filehash','category_id','user_id','attachtype','max_filesize','input_style','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
                $ilance->template->pprint('popupfooter', array('headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','finaltime','finalqueries'));
                exit();
        }
        
        // #### BEGIN FILE UPLOAD ##############################################
        else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == '_do-upload-now' AND isset($uncrypted['attachtype']))
        {
                $area_title = $phrase['_uploading_attachment_in_progress'];
                $page_title = SITE_NAME . ' - ' . $phrase['_uploading_attachment_in_progress'];
                
                $upload_to = '';
                
                $condition = $ilance->attachment->handle_attachtype_upload_settings($uncrypted['attachtype']);
                
                $max_filesize = $condition['max_filesize'];
                $max_size = $condition['max_size'];
                $upload_to = $condition['upload_to'];
                $extensions = $condition['extensions'];
                
                unset($condition);
                
                // #### PROCESS AND SAVE ATTACHMENT ############################
                $ilance->attachment->temp_file_name = $_FILES['upload']['tmp_name'];
                $ilance->attachment->file_name = $_FILES['upload']['name'];
                $ilance->attachment->file_type = $_FILES['upload']['type'];
                $ilance->attachment->upload_dir = $upload_to;
                $ilance->attachment->max_file_size = $max_filesize;
        
                // #### validation #############################################
                $valid_ext = $ilance->attachment->validate_extension();
                $valid_size = $ilance->attachment->validate_size();
                $max_size = $ilance->attachment->get_max_size();
                $file_size = $ilance->attachment->get_file_size();
                $file_type = $ilance->attachment->get_file_type();
                
                // #### check if the total attachment limit permission has exceeded for this members upload
                $futuresize = ($res_file_sum['attach_usage_total'] + $file_size);
                $totalpercentage = round(($futuresize / $ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'attachlimit')) * 100);
                
                // #### set upload error defaults ##############################
                $show['error'] = false;
                $show['notice'] = false;
                $notice_message = $error_message = $upload_style = $moderated = '';
                
                // #### rebuild attachment select list #########################
                $sql_attachments = array();
                
                $uncrypted['project_id'] = isset($uncrypted['project_id']) ? $uncrypted['project_id'] : 0;
                $uncrypted['user_id'] = isset($uncrypted['user_id']) ? $uncrypted['user_id'] : 0;
                
                $condition = $ilance->attachment->handle_attachtype_rebuild_settings($uncrypted['attachtype'], $uncrypted['user_id'], $uncrypted['project_id']);
                
                $maximum_files = $condition['maximum_files'];
                $max_width = $condition['max_width'];
                $max_height = $condition['max_height'];
                $max_filesize = $condition['max_filesize'];
                $max_size = $condition['max_size'];
                $extensions = $condition['extensions'];
                $query = $condition['query'];
                
                unset($condition);
                
                // #### have we exceeded our account space based on this upload?
                if ($totalpercentage > 100)
                {
                        $error_message .= '<div>' . $phrase['_sorry_you_do_not_have_enough_space_to_upload_new_files'] . '</div>';        
                }
                        
                // #### is the filename extension valid?
                if ($valid_ext == false)
                {
                        $error_message .= '<div>' . $phrase['_the_file_extension_is_invalid_or_the_width_slash_height_exceeds_our_limits'] . '</div>';
                }
                
                // #### is the width or height bad?
                if (!empty($valid_size['failedwidth']) AND $valid_size['failedwidth'] OR !empty($valid_size['failedheight']) AND $valid_size['failedheight'])
                {
                        $error_message .= '<div>' . $phrase['_maximum_width'] . ' <strong>' . $max_width . 'px</strong>,
                        ' . $phrase['_maximum_height'] . ' <strong>' . $max_height . 'px</strong>,
                        ' . $phrase['_maximum_filesize'] . ': <strong>' . $max_size . '</strong>
                        ' . $phrase['_and_your_attachment_was'] . ' <strong>' . $valid_size['uploadwidth'] . 'px</strong>
                        ' . mb_strtolower($phrase['_by']) . ' <strong>' . $valid_size['uploadheight'] . 'px</strong>, ' . $phrase['_upload_size'] . ': <strong>' . print_filesize($valid_size['uploadfilesize']) . '</strong></div>';
                }
                
                // #### is the file size bad?
                if (!empty($valid_size['failedfilesize']) AND $valid_size['failedfilesize'])
                {
                        $error_message .= '<div>' . $phrase['_the_file_size_is_invalid_please_try_again_the_maximum_file_size_is'] . ': <strong>' . $max_size . '</strong> ' . $phrase['_and_your_file_was'] . ': <strong>' . print_filesize($file_size) . '</strong></div>';
                }
                
                if (!empty($error_message))
                {
                        // we have upload errors so set our upload $error to true
                        $show['error'] = true;
                }
                
                // #### begin upload ###########################################
                if ($show['error'] == false)
                {
                        if ($ilance->attachment->save_attachment())
                        {
                                // no error messages detected .. save the attachment
                                $area_title = $phrase['_attachment_uploaded'];
                                $page_title = SITE_NAME . ' - ' . $phrase['_attachment_uploaded'];
                                
                                // does upload menu reveal "uploads in moderation mode" message?
                                if ($ilconfig['attachment_moderationdisabled'] == 0)
                                {
                                        $show['notice'] = true;
                                        $notice_message .= $phrase['_attachments_are_currently_being_moderated_by_our_staff'];
                                }
                        }
                        else
                        {
                                // errors detected .. do not save the attachment
                                $show['error'] = true;
                                
                                $area_title = $phrase['_attachment_could_not_be_saved'];
                                $page_title = SITE_NAME . ' - ' . $phrase['_attachment_could_not_be_saved'];
                
                                $error_message .= $phrase['_your_attachment_could_not_be_uploaded'];
                        }
                }
        
                $attachment_list = '<select multiple name="attachments[]" size="5" style="overflow:hidden; width:380px; font-family: verdana">';
                $attachment_list_html = '';
                
                $sql_attachments = $ilance->db->query($query);
                if ($ilance->db->num_rows($sql_attachments) >= $maximum_files)
                {
                        $upload_style = 'disabled="disabled"';
                }
                
                while ($res = $ilance->db->fetch_array($sql_attachments))
                {
                        $moderated = '';
                        if ($res['visible'] == 0)
                        {
                                $moderated = '[' . $phrase['_review_in_progress'] . ']';
                                $attachment_link = $res['filename'];
                        }
                        else
                        {
                                $attachment_link = '<a href="' . HTTP_SERVER . $ilpage['attachment'] . '?id=' . $res['filehash'] . '" target="_blank">' . $res['filename'] . '</a>';
                        }
                        
                        $attachment_list_html .= '<div><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'paperclip.gif" border="0" alt="' . $res['filename'] . '" /> ' . $attachment_link . ' (' . $res['filesize'] . ' ' . $phrase['_bytes'] . ') ' . $moderated . '</div>';
                        $attachment_list .= '<option value="' . $res['attachid'] . '">' . $res['filename'] . ' (' . print_filesize($res['filesize']) . ') ' . $moderated . '</option>';
                }
                
                $attachment_list .= '</select>';
                
                $js = $ilance->attachment->print_innerhtml_js($attachmentlistobj, $attachment_list_html);
                
                $headinclude .= '
<script type="text/javascript">
<!--
function toggle_id(idobjname)
{
        obj = fetch_js_object(idobjname);
        if (obj)
        {
                if (obj.style.display == "none")
                {
                        obj.style.display = "";
                }
                else
                {
                        obj.style.display = "none";
                }
        }
        return false;
}
';
                
                if ($uncrypted['attachtype'] == 'portfolio')
                {
                        $headinclude .= '
function check_upload(formobj)
{
    var haveupload = false;
    var havecaption = false;
    var havedescription = false;
    var havecid = false;
    
    for (var i = 0; i < formobj.elements.length; i++)
    {
            var elm = formobj.elements[i];
            if (elm.type == "file")
            {
                    if (elm.value != "")
                    {
                            haveupload = true;
                    }
            }
            if (elm.name == "cid")
            {
                    if (elm.value != "0")
                    {
                            havecid = true;
                    }
            }
            if (elm.name == "caption")
            {
                    if (elm.value != "")
                    {
                            havecaption = true;
                    }
            }
            if (elm.name == "description")
            {
                    if (elm.value != "")
                    {
                            havedescription = true;
                    }
            }
    }
    if (!havecid)
    {
            alert(phrase[\'_please_select_a_portfolio_category_to_upload_this_attachment\']);
            return false;
    }
    if (!havecaption)
    {
            alert(phrase[\'_please_enter_a_caption_name_to_upload_this_attachment\']);
            return false;
    }
    if (!havedescription)
    {
            alert(phrase[\'_please_enter_a_description_to_upload_this_attachment\']);
            return false;
    }
    if (haveupload)
    {
            toggle_id("uploading");
            return true;
    }
    else
    {
            alert(phrase[\'_please_use_the_browse_button_to_attach_media\']);
            return false;
    }
}
//-->
</script>
';	
                }
                else 
                {
                        $headinclude .= '
function check_upload(formobj)
{
    var haveupload = false;
    for (var i = 0; i < formobj.elements.length; i++)
    {
            var elm = formobj.elements[i];
            
            if (elm.type == "file")
            {
                    if (elm.value != "")
                    {
                            haveupload = true;
                    }
            }
    }
    if (haveupload)
    {
            toggle_id("uploading");
            return true;
    }
    else
    {
            alert(phrase[\'_please_use_the_browse_button_to_attach_media\']);
            return false;
    }
}
//-->
</script>
';	
                }
                
                // detect if we need to refresh the parent menu after this popup attachment window closes
                // this is useful for places like portfolio menu where the user uploads new images
                $onbeforeunload = '';
                $closeonclick = 'window.close();';
                if (isset($ilance->GPC['refresh']) AND $ilance->GPC['refresh'])
                {
                        $headinclude .= "
<script type=\"text/javascript\">
<!--
function close_popup_window()
{
        window.close();
        if (window.opener && !window.opener.closed)
        {
                window.opener.location.reload();
        }
}
//-->
</script>
";
                        $closeonclick = 'close_popup_window();';
                }
                        
                $ilance->template->load_popup('popupheader', 'popup_header.html');
                $ilance->template->load_popup('popupmain', 'popup_upload_attachment.html');
                $ilance->template->load_popup('popupfooter', 'popup_footer.html');
                $ilance->template->parse_hash('popupmain', array('ilpage' => $ilpage));
                $ilance->template->parse_hash('popupheader', array('ilpage' => $ilpage));
                $ilance->template->parse_hash('popupfooter', array('ilpage' => $ilpage));
                $ilance->template->parse_hash('popupheader', array('ilpage' => $ilpage));
                $ilance->template->parse_hash('popupfooter', array('ilpage' => $ilpage));
                $ilance->template->parse_if_blocks('popupheader');
                $ilance->template->parse_if_blocks('popupmain');
                $ilance->template->parse_if_blocks('popupfooter');
                $ilance->template->pprint('popupheader', array('headinclude','onload','onbeforeunload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','meta_desc','meta_keyw') );
                $ilance->template->pprint('popupmain', array('closeonclick','crypted','js','search_category_pulldown','attach_usage_total','attach_usage_left','extensions','max_size','max_width','max_height','error_message','notice_message','maximum_files','attach_user_max','upload_style','pmb_id','attachment_list','project_id','portfolio_id','bid_id','filehash','category_id','user_id','attachtype','max_filesize','input_style','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
                $ilance->template->pprint('popupfooter', array('headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','finaltime','finalqueries'));
                exit();
        }
        else
        {
                if (empty($uncrypted))
                {
                        $area_title = $phrase['_access_denied_menu_please_login'];
                        $page_title = SITE_NAME . ' - ' . $phrase['_access_denied_menu_please_login'];
                        
                        $ilance->template->load_popup('popupheader', 'popup_header.html');
			$ilance->template->load_popup('popupmain', 'popup_denied.html');
			$ilance->template->load_popup('popupfooter', 'popup_footer.html');
			$ilance->template->parse_hash('popupmain', array('ilpage' => $ilpage));
			$ilance->template->parse_hash('popupheader', array('ilpage' => $ilpage));
			$ilance->template->parse_hash('popupfooter', array('ilpage' => $ilpage));
			$ilance->template->parse_if_blocks('popupheader');
			$ilance->template->parse_if_blocks('popupmain');
			$ilance->template->parse_if_blocks('popupfooter');
			$ilance->template->pprint('popupheader', array('headinclude','onload','onbeforeunload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','meta_desc','meta_keyw','official_time') );
			$ilance->template->pprint('popupmain', array('input_style','remote_addr','rid','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
			$ilance->template->pprint('popupfooter', array('headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','finaltime','finalqueries'));
			exit();
                }
                        
                // #### POPUP LANDING PAGE #####################################
                $area_title = $phrase['_uploading_file_attachments'];
                $page_title = SITE_NAME . ' - ' . $phrase['_uploading_file_attachments'];
                
                $remote_addr = getenv("REMOTE_ADDR");
                $referer = getenv("HTTP_REFERER");
                
                $error_message = '';
                
                // #### rebuild attachment select list #########################
                $sql_attachments = array();
                
                $uncrypted['project_id'] = isset($uncrypted['project_id']) ? $uncrypted['project_id'] : 0;
                $uncrypted['user_id'] = isset($uncrypted['user_id']) ? $uncrypted['user_id'] : 0;
                
                $condition = $ilance->attachment->handle_attachtype_rebuild_settings($uncrypted['attachtype'], $uncrypted['user_id'], $uncrypted['project_id']);
                
                $maximum_files = $condition['maximum_files'];
                $max_width = $condition['max_width'];
                $max_height = $condition['max_height'];
                $max_filesize = $condition['max_filesize'];
                $max_size = $condition['max_size'];
                $extensions = $condition['extensions'];
                $query = $condition['query'];
                
                // #### check if the total attachment limit permission has exceeded for this members upload
                $futuresize = ($res_file_sum['attach_usage_total']);
                $totalpercentage = round(($futuresize / $ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'attachlimit')) * 100);
                
                if ($totalpercentage > 100)
                {
                        $error_message .= '<div>' . $phrase['_sorry_you_do_not_have_enough_space_to_upload_new_files'] . '</div>';        
                }
                
                unset($condition);
                
                if (!empty($error_message))
                {
                        $show['error'] = true;
                }
                
                $attachment_list = '<select multiple name="attachments[]" size="5" style="overflow:hidden;width:380px;">';
                $attachment_list_html = $upload_style = '';
                
                $sql_attachments = $ilance->db->query($query);
                if ($ilance->db->num_rows($sql_attachments) >= $maximum_files)
                {
                        $upload_style = 'disabled="disabled"';
                }
                
                while ($res = $ilance->db->fetch_array($sql_attachments))
                {
                        $moderated = '';
                        if ($res['visible'] == 0)
                        {
                                $moderated = '[' . $phrase['_review_in_progress'] . ']';
                                $attachment_link = $res['filename'];
                        }
                        else
                        {
                                $attachment_link = '<a href="' . HTTP_SERVER . $ilpage['attachment'] . '?id=' . $res['filehash'] . '" target="_blank">' . $res['filename'] . '</a>';
                        }
                        
                        $attachment_list_html .= '<div><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'paperclip.gif" border="0" alt="' . $res['filename'] . '" /> ' . $attachment_link . ' (' . $res['filesize'] . ' ' . $phrase['_bytes'] . ') ' . $moderated . '</div>';
                        $attachment_list .= '<option value="' . $res['attachid'] . '">' . $res['filename'] . ' (' . print_filesize($res['filesize']) . ') ' . $moderated . '</option>';
                }
                
                $attachment_list .= '</select>';
                
                $js = $ilance->attachment->print_innerhtml_js($attachmentlistobj, $attachment_list_html);
                
                $headinclude .= '
<script type="text/javascript">
<!--
function toggle_id(idobjname)
{
        obj = fetch_js_object(idobjname);
        if (obj)
        {
                if (obj.style.display == "none")
                {
                        obj.style.display = "";
                }
                else
                {
                        obj.style.display = "none";
                }
        }
        return false;
}';
                
                // #### PORTFOLIO UPLOAD JAVASCRIPT ####################################
                if ($uncrypted['attachtype'] == 'portfolio')
                {
                        $headinclude .= '
function check_upload(formobj)
{
        var haveupload = false;
        var havecaption = false;
        var havedescription = false;
        var havecid = false;
        
        for (var i = 0; i < formobj.elements.length; i++)
        {
                var elm = formobj.elements[i];
                if (elm.type == "file")
                {
                        if (elm.value != "")
                        {
                                haveupload = true;
                        }
                }			
                if (elm.name == "cid")
                {
                        if (elm.value != "0")
                        {
                                havecid = true;
                        }
                }			
                if (elm.name == "caption")
                {
                        if (elm.value != "")
                        {
                                havecaption = true;
                        }
                }			
                if (elm.name == "description")
                {
                        if (elm.value != "")
                        {
                                havedescription = true;
                        }
                }
        }		
        if (!havecid)
        {
                alert(phrase[\'_please_select_a_portfolio_category_to_upload_this_attachment\']);
                return false;
        }
        if (!havecaption)
        {
                alert(phrase[\'_please_enter_a_caption_name_to_upload_this_attachment\']);
                return false;
        }
        if (!havedescription)
        {
                alert(phrase[\'_please_enter_a_description_to_upload_this_attachment\']);
                return false;
        }		
        if (haveupload)
        {
                toggle_id("uploading");
                return true;
        }
        else
        {
                alert(phrase[\'_please_use_the_browse_button_to_attach_media\']);
                return false;
        }
}
//-->
</script>
';	
                }
                
                // #### UPLOAD JAVASCRIPT ##############################################
                else 
                {
                        $headinclude .= '
function check_upload(formobj)
{
    var haveupload = false;
    
    for (var i = 0; i < formobj.elements.length; i++)
    {
            var elm = formobj.elements[i];
            if (elm.type == "file")
            {
                    if (elm.value != "")
                    {
                            haveupload = true;
                    }
            }
    }		
    if (haveupload)
    {
            toggle_id("uploading");
            return true;
    }
    else
    {
            alert(phrase[\'_please_use_the_browse_button_to_attach_media\']);
            return false;
    }
}
// -->
</script>';	
                }
                
                // detect if we need to refresh the parent menu after this popup attachment window closes
                // this is useful for places like portfolio menu where the user uploads new images
                $onbeforeunload = '';
                $closeonclick = 'window.close();';
                if (isset($ilance->GPC['refresh']) AND $ilance->GPC['refresh'])
                {
                        $headinclude .= "
<script type=\"text/javascript\">
<!--
function close_popup_window()
{
        window.close();
        if (window.opener && !window.opener.closed)
        {
                window.opener.location.reload();
        }
}
//-->
</script>
";
                        $closeonclick = 'close_popup_window();';
                }
                
                $ilance->template->load_popup('popupheader', 'popup_header.html');
                $ilance->template->load_popup('popupmain', 'popup_upload_attachment.html');
                $ilance->template->load_popup('popupfooter', 'popup_footer.html');
                $ilance->template->parse_hash('popupmain', array('ilpage' => $ilpage));
                $ilance->template->parse_hash('popupheader', array('ilpage' => $ilpage));
                $ilance->template->parse_hash('popupfooter', array('ilpage' => $ilpage));
                $ilance->template->parse_if_blocks('popupheader');
                $ilance->template->parse_if_blocks('popupmain');
                $ilance->template->parse_if_blocks('popupfooter');
                $ilance->template->pprint('popupheader', array('headinclude','onload','onbeforeunload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','meta_desc','meta_keyw'));
                $ilance->template->pprint('popupmain', array('closeonclick','crypted','js','search_category_pulldown','attach_usage_total','attach_usage_left','extensions','max_size','max_width','max_height','error_message','notice_message','maximum_files','attach_user_max','upload_style','pmb_id','attachment_list','project_id','portfolio_id','bid_id','filehash','category_id','user_id','attachtype','max_filesize','input_style','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
                $ilance->template->pprint('popupfooter', array('headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','finaltime','finalqueries'));
                exit();
        }
}
else
{
        $area_title = $phrase['_access_denied_menu_please_login'];
        $page_title = SITE_NAME . ' - ' . $phrase['_access_denied_menu_please_login'];
        
	$ilance->template->load_popup('popupheader', 'popup_header.html');
	$ilance->template->load_popup('popupmain', 'popup_denied.html');
	$ilance->template->load_popup('popupfooter', 'popup_footer.html');
	$ilance->template->parse_hash('popupmain', array('ilpage' => $ilpage));
	$ilance->template->parse_hash('popupheader', array('ilpage' => $ilpage));
	$ilance->template->parse_hash('popupfooter', array('ilpage' => $ilpage));
	$ilance->template->parse_if_blocks('popupheader');
	$ilance->template->parse_if_blocks('popupmain');
	$ilance->template->parse_if_blocks('popupfooter');
	$ilance->template->pprint('popupheader', array('headinclude','onload','onbeforeunload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','meta_desc','meta_keyw','official_time') );
	$ilance->template->pprint('popupmain', array('input_style','remote_addr','rid','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
	$ilance->template->pprint('popupfooter', array('headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','finaltime','finalqueries'));
	exit();
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: upload.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>