<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

$area_title = $phrase['_workspace'];
$page_title = SITE_NAME . ' - ' . $phrase['_workspace'];

$navcrumb = array("$ilpage[workspace]" => $ilcrumbs["$ilpage[workspace]"]);

$ilance->template->construct_header('header');
$ilance->template->parse_hash('header', array('ilpage' => $ilpage));
$ilance->template->parse_if_blocks('header');
$ilance->template->pprint('header', array('headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','meta_desc','meta_keyw','official_time'));
?>

<div class="header"><?php echo $phrase['_mediashare_for']; ?> <span class="blue"><?php echo fetch_auction('project_title', $ilmedia['project_id']); ?></span></div>
<div align="justify" class="gray" style="padding-top:4px"><?php echo $phrase['_the_secure_mediashare_system_allows_buyers_and_service_vendors_to_upload_relevant']; ?>&nbsp;<?php echo fetch_auction('project_title', $ilmedia['project_id']); ?>&nbsp;<?php echo $phrase['_rfp_or_for_private_reference_information_you_wish_to_keep_orgainzed']; ?><br /><br /></div>

<?php
if (isset($error_code) AND !empty($error_code)) 
{
        echo '
        <div class="grayborder" style="background:url(' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/bg_gradient_red_1x1000.gif) repeat-x;">
        <div class="n">
                <div class="e">
                        <div class="w"></div>
                </div>
        </div>
        
        <div style="padding:6px"><span style="float:left; padding-right:10px; padding-left:10px"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'infowarning3.gif" border="0" alt="" id="error" /></span><strong>';
        
        switch ($error_code) 
        {
                case 1:
                {
                        echo $phrase['_you_can_use_this_feature_when_you_have_selected_one_or_more_checkboxes'];
                        break;
                }
                case 2:
                {
                        echo $phrase['_you_can_only_select_one_checkbox_at_a_time_for_the_current_action'];
                        break;
                }
                case 3:
                {
                        echo $phrase['_the_uploaded_filesize_is_more_than_your_account_limit_or_maximum_storage_space_exceeds_your_limit_please_reupload'];
                        break;
                }
        }
        
        echo '
        </strong></div>		
        <div class="s">
                <div class="e">
                        <div class="w"></div>
                </div>
        </div>
        </div>
        <div style="padding-bottom:20px"></div>';

}

$cryptedhome = array(
    'project_id' => $ilmedia['project_id'],
    'buyer_id' => $ilmedia['buyer_id'],
    'seller_id' => $ilmedia['seller_id']
);
?>

<form action="<?php echo HTTPS_WS . $ilpage['mediashare']; ?>?crypted=<?php echo encrypt_url($cryptedws); ?>" method="post" accept-charset="UTF-8" style="margin:0px;">
<div class="block-wrapper">

	<div class="block">
	
			<div class="block-top">
					<div class="block-right">
							<div class="block-left"></div>
					</div>
			</div>
			
			<div class="block-header"><?php echo $phrase['_navigation']; ?>: /<span class="blue"><a href="<?php echo HTTPS_WS . $ilpage['workspace']; ?>?crypted=<?php echo encrypt_url($cryptedhome); ?>">home</a></span><?php if (!empty($fold_id)) { echo '/' . mb_substr(print_current_folder_title($fold_id, $p_id, ''), 0, -1); } ?></div>
			

<?php
if (!empty($fold_id) AND $p_id != '-1')
{
    if (!isset($file_id))
    {
        $file_id = 0;
    }
    
    $cryptedws = array(
        'project_id' => $ilmedia['project_id'],
        'buyer_id' => $ilmedia['buyer_id'],
        'seller_id' => $ilmedia['seller_id'],
        'fold_id' => $fold_id,
        'file_id' => $file_id
    );
?>
                        <!-- workspace action buttons -->
                        <div class="block-content-yellow" style="padding:9px">
                        
                        <input type="hidden" name="buyer_id" value="<?php echo $ilmedia['buyer_id']; ?>" />
                        <input type="hidden" name="seller_id" value="<?php echo $ilmedia['seller_id']; ?>" />
                        <input type="hidden" name="project_id" value="<?php echo $ilmedia['project_id']; ?>" />
                        <input type="hidden" name="fold_id" value="<?php echo $fold_id; ?>" />
                        <table width="100%" cellpadding="0" cellspacing="0" border="0">
                        <tr>
                            <td align="center" width="14.2%"><input type="submit" name="newfolder" value="New Folder" class="buttons" /></td>
                            <td align="center" width="14.2%"><input type="submit" name="copyitems" value="Copy Items" class="buttons" /></td>
                            <td align="center" width="14.2%"><input type="submit" name="moveitems" value="Move Items" class="buttons" /></td>
                            <td align="center" width="14.2%"><input type="submit" name="rename" value="Rename" class="buttons" /></td>
                            <td align="center" width="14.2%"><input type="submit" name="delete" value="Delete" class="buttons" /></td>
                            <td align="center" width="14.2%"><input type="submit" name="upload" value="Upload" class="buttons" /></td>
                            <td align="center" width="14.2%"><input type="submit" name="comment" value="Comment" class="buttons" /></td>
                        </tr>
                        </table>
                        
                        </div>
                        <!-- workspace action buttons -->
<?php
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: header.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>