<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

/**
* CSV class to perform the majority of importing and exporting functions within ILance.
*
* @package      iLance
* @version	$Revision: 1.0.0 $
* @author       ILance
*/

class csv
{
        /*
         Constructor
        */
        function csv()
        {
                
        }
        
        function csv_import($filename = '', $fields = array())
        {
                global $ilance, $ilconfig, $phrase;
                
                if (empty($filename))
                {
                        return false;
                }
                
                $html = '';
                $row_count = 0;
                $rows = array();
                
                $handle = fopen($filename, 'r');
                if (!$handle)
                {
                        $html['response'] = $phrase['_cannot_upload_bulk_item_data__no_records_found'];
                        return $html;
                }
                
                while (($data = fgetcsv($handle, 1000, ',')) !== false)
                {
                        $row_count++;
                        foreach ($data AS $key => $value)
                        {
                                $value = str_replace("'", '', $value);
                                $data["$key"] = "'" . $ilance->db->escape_string($value) . "'";
                        }
                        $rows[] = implode(",", $data);
                }                
                fclose($handle);
                //print_r($rows); exit;
        
                if (count($rows))
                {
                        //mysql_query("TRUNCATE TABLE $table") or die("MySQL Error: " . mysql_error()); // delete the existing records
                        //mysql_query($sql_query) or die("MySQL Error: " . mysql_error()); // and insert the new ones.
                        //echo $sql_query;
                        $html['response'] = number_format($row_count) . ' ' . $phrase['_items_uploaded'];
                        $html['array'] = $rows;
                }
                else
                {
                        $html['response'] = $phrase['_cannot_upload_bulk_item_data__no_records_found'];
                        $html['array'] = array();
                }
                
                return $html;
        }
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: class.csv.inc.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>