<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

if (!isset($GLOBALS['ilance']->db))
{
        die('<strong>Warning:</strong> This script cannot be loaded indirectly.  Operation aborted.');
}

($apihook = $ilance->api('cron_dailyreports_start')) ? eval($apihook) : false;

$overall_subscription_earnings = number_format("0", 2);
$sql = $ilance->db->query("
        SELECT SUM(paid) AS paid
        FROM " . DB_PREFIX . "invoices
        WHERE paid != ''
            AND invoicetype = 'subscription'
", 0, null, __FILE__, __LINE__);
if ($ilance->db->num_rows($sql) > 0)
{
        $res = $ilance->db->fetch_array($sql);
        $overall_subscription_earnings = number_format($res['paid'], 2);
}

// #### OVERALL COMMISSION SALES ###############################################
$overall_commission_earnings = number_format("0", 2);
$sql = $ilance->db->query("
        SELECT SUM(paid) AS paid
        FROM " . DB_PREFIX . "invoices
        WHERE paid != ''
            AND invoicetype = 'commission'
", 0, null, __FILE__, __LINE__);
if ($ilance->db->num_rows($sql) > 0)
{
        $res = $ilance->db->fetch_array($sql);
        $overall_commission_earnings = number_format($res['paid'], 2);
}

// #### OVERALL PROVIDER SALES #################################################
$overall_provider_sales_earnings = number_format("0", 2);
$sql = $ilance->db->query("
        SELECT SUM(paid) AS paid
        FROM " . DB_PREFIX . "invoices
        WHERE paid != ''
            AND (invoicetype = 'p2b' OR invoicetype = 'buynow')
", 0, null, __FILE__, __LINE__);
if ($ilance->db->num_rows($sql) > 0)
{
        $res = $ilance->db->fetch_array($sql);
        $overall_provider_sales_earnings = number_format($res['paid'], 2);
}

// #### SUBSCRIPTION FEES PENDING ##############################################
$overall_provider_subscriptions_pending = number_format("0", 2);
$sql = $ilance->db->query("
        SELECT SUM(amount) AS paid
        FROM " . DB_PREFIX . "invoices
        WHERE paid = ''
            AND invoicetype = 'subscription'
", 0, null, __FILE__, __LINE__);
if ($ilance->db->num_rows($sql) > 0)
{
        $res = $ilance->db->fetch_array($sql);
        $overall_provider_subscriptions_pending = number_format($res['paid'], 2);
}

// #### COMMISSION FEES PENDING ################################################
$commission_payments_pending_total = number_format("0", 2);
$sql = $ilance->db->query("
        SELECT SUM(amount) AS paid
        FROM " . DB_PREFIX . "invoices
        WHERE paid = ''
            AND invoicetype = 'commission'
", 0, null, __FILE__, __LINE__);
if ($ilance->db->num_rows($sql) > 0)
{
        $res = $ilance->db->fetch_array($sql);
        $commission_payments_pending_total = number_format($res['paid'], 2);
}

// #### PENDING PAYMENTS SELLERS ARE WAITING ON ################################
$provider_sales_pending_total_count = '0';
$provider_sales_pending_total = number_format("0", 2);
$sql = $ilance->db->query("
        SELECT SUM(amount) AS amount
        FROM " . DB_PREFIX . "invoices
        WHERE paid = ''
            AND (invoicetype = 'p2b' OR invoicetype = 'buynow')
", 0, null, __FILE__, __LINE__);
if ($ilance->db->num_rows($sql) > 0)
{
        $res = $ilance->db->fetch_array($sql);
        $provider_sales_pending_total_count = $ilance->db->num_rows($sql);
        $provider_sales_pending_total = number_format($res['amount'], 2);
}

// #### TOTAL MEMBER COUNT #####################################################
$member_count = '0';
$sql = $ilance->db->query("
        SELECT *
        FROM " . DB_PREFIX . "users
", 0, null, __FILE__, __LINE__);
if ($ilance->db->num_rows($sql) > 0)
{
        $member_count = $ilance->db->num_rows($sql);
}

// #### NEW REGISTRATIONS ######################################################
$member_registrations_count = '0';
$sql = $ilance->db->query("
        SELECT *
        FROM " . DB_PREFIX . "users
        WHERE date_added LIKE ('%" . DATEYESTERDAY . "%')
", 0, null, __FILE__, __LINE__);
if ($ilance->db->num_rows($sql) > 0)
{
        $member_registrations_count = $ilance->db->num_rows($sql);
}

// #### NUMBER OF SERVICE PROJECTS POSTED ######################################
$projects_posted_today_count = '0';
$sql = $ilance->db->query("
        SELECT *
        FROM " . DB_PREFIX . "projects
        WHERE date_added LIKE ('%" . DATEYESTERDAY . "%')
            AND project_state = 'service'
", 0, null, __FILE__, __LINE__);
if ($ilance->db->num_rows($sql) > 0)
{
        $projects_posted_today_count = $ilance->db->num_rows($sql);
}

// #### NUMBER OF PRODUCT AUCTIONS POSTED ######################################
$products_posted_today_count = '0';
$sql = $ilance->db->query("
        SELECT *
        FROM " . DB_PREFIX . "projects
        WHERE date_added LIKE ('%" . DATEYESTERDAY . "%')
            AND project_state = 'product'
", 0, null, __FILE__, __LINE__);
if ($ilance->db->num_rows($sql) > 0)
{
        $products_posted_today_count = $ilance->db->num_rows($sql);
}

// #### NUMBER OF BIDS #########################################################
$project_bids_today_count = '0';
$sql = $ilance->db->query("
        SELECT *
        FROM " . DB_PREFIX . "project_bids
        WHERE date_added LIKE ('%" . DATEYESTERDAY . "%')
", 0, null, __FILE__, __LINE__);
if ($ilance->db->num_rows($sql) > 0)
{
        $project_bids_today_count = $ilance->db->num_rows($sql);
}

// #### COMMISSION FEE COUNT ###################################################
$number_commission_fees_today_count = '0';
$sql = $ilance->db->query("
        SELECT *
        FROM " . DB_PREFIX . "invoices
        WHERE createdate LIKE ('%" . DATEYESTERDAY . "%')
            AND invoicetype = 'commission'
");
if ($ilance->db->num_rows($sql) > 0)
{
        $number_commission_fees_today_count = $ilance->db->num_rows($sql);
}

// #### COMMISSION FEES PAID TODAY #############################################
$amount_paid_commission_fees_today_count_amount = number_format("0", 2);
$sql = $ilance->db->query("
        SELECT SUM(amount) AS paid
        FROM " . DB_PREFIX . "invoices
        WHERE createdate LIKE ('%" . DATEYESTERDAY . "%') 
            AND invoicetype = 'commission' 
            AND status = 'paid'
");
if ($ilance->db->num_rows($sql) > 0)
{
        $res = $ilance->db->fetch_array($sql);
        $amount_paid_commission_fees_today_count_amount = number_format($res['paid'], 2);
}

// #### CREDENTIAL PAYMENT COUNT ###############################################
$number_credential_fees_today_count = '0';
$sql = $ilance->db->query("
        SELECT *
        FROM " . DB_PREFIX . "invoices
        WHERE createdate LIKE ('%" . DATEYESTERDAY . "%') 
            AND invoicetype = 'credential'
", 0, null, __FILE__, __LINE__);
if ($ilance->db->num_rows($sql) > 0)
{
        $number_credential_fees_today_count = $ilance->db->num_rows($sql);
}

// #### CREDENTIAL FEES PAID TODAY #############################################
$amount_paid_credential_fees_today_count_amount = number_format("0", 2);
$sql = $ilance->db->query("
        SELECT SUM(amount) AS paid
        FROM " . DB_PREFIX . "invoices
        WHERE createdate LIKE ('%" . DATEYESTERDAY . "%') 
            AND invoicetype = 'credential' 
            AND status = 'paid'
", 0, null, __FILE__, __LINE__);
if ($ilance->db->num_rows($sql) > 0)
{
        $res = $ilance->db->fetch_array($sql);
        $amount_paid_credential_fees_today_count_amount = number_format($res['paid'], 2);
}

// #### SUBSCRIPTION PAYMENT COUNT #############################################
$number_paid_subscription_fees_today_count = '0';
$sql = $ilance->db->query("
        SELECT *
        FROM " . DB_PREFIX . "invoices
        WHERE createdate LIKE ('%" . DATEYESTERDAY . "%') 
            AND invoicetype = 'subscription' 
            AND status = 'paid'
", 0, null, __FILE__, __LINE__);
if ($ilance->db->num_rows($sql) > 0)
{
        $number_paid_subscription_fees_today_count = $ilance->db->num_rows($sql);
}

// #### SUBSCRIPTION PAYMENTS TODAY ############################################
$amount_paid_subscription_fees_today_count_amount = number_format("0", 2);
$sql = $ilance->db->query("
        SELECT SUM(amount) AS amount
        FROM " . DB_PREFIX . "invoices
        WHERE createdate LIKE ('%" . DATEYESTERDAY . "%') 
            AND invoicetype = 'subscription' 
            AND status = 'paid'
", 0, null, __FILE__, __LINE__);
if ($ilance->db->num_rows($sql) > 0)
{
        $res = $ilance->db->fetch_array($sql);
        $amount_paid_subscription_fees_today_count_amount = number_format($res['amount'], 2);
}

// #### FAILED LOGINS ##########################################################
$number_of_failed_logins_today_count = '0';
$sql = $ilance->db->query("
        SELECT *
        FROM " . DB_PREFIX . "failed_logins
        WHERE datetime_failed LIKE ('%" . DATEYESTERDAY . "%')
", 0, null, __FILE__, __LINE__);
if ($ilance->db->num_rows($sql) > 0)
{
        $number_of_failed_logins_today_count = $ilance->db->num_rows($sql);
}

// cron logic to ensure daily reports only send once per day
$sql = $ilance->db->query("
        SELECT *
        FROM " . DB_PREFIX . "emaillog
        WHERE user_id = '-1'
            AND logtype = 'dailyreport'
            AND date LIKE '%" . DATETODAY . "%'
", 0, null, __FILE__, __LINE__);
if ($ilance->db->num_rows($sql) == 0)
{
        $ilance->email = construct_dm_object('email', $ilance);
                                                        
        // email admin
        $ilance->email->logtype = 'dailyreport';
        $ilance->email->mail = SITE_EMAIL;
        $ilance->email->slng = fetch_site_slng();
        
        $ilance->email->get('cron_daily_reports');		
        $ilance->email->set(array(
                '{{membercount}}' => (int)$member_count,
                '{{memberregistercount}}' => (int)$member_registrations_count,
                '{{subscriptionpaymentstoday}}' => (int)$number_paid_subscription_fees_today_count,
                '{{subscriptionpaymentsamounttoday}}' => $amount_paid_subscription_fees_today_count_amount,
                '{{credentialpaymentstoday}}' => (int)$number_credential_fees_today_count,
                '{{credentialpaymentsamounttoday}}' => $amount_paid_credential_fees_today_count_amount,
                '{{commissionfeestoday}}' => (int)$number_commission_fees_today_count,
                '{{commissionpaymentsamounttoday}}' => $amount_paid_commission_fees_today_count_amount,
                '{{servicespostedtoday}}' => (int)$projects_posted_today_count,
                '{{productspostedtoday}}' => (int)$products_posted_today_count,
                '{{servicebidstoday}}' => (int)$project_bids_today_count,
                '{{failedlogincount}}' => (int)$number_of_failed_logins_today_count,
        ));
        
        $ilance->email->send();
        
        ($apihook = $ilance->api('cron_dailyreports_end')) ? eval($apihook) : false;
        
        log_cron_action('The daily marketplace report was successfully emailed to ' . SITE_EMAIL, $nextitem);
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: cron.dailyreports.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>