/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

/**
* Core javascript search functions within ILance.
*
* @package   	iLance
* @version	$Revision: 1.0.0 $
* @author       ILance
*/

function enable_input_group(inputgroup, checkbool, force)
{
	if (inputgroup == 'hourly')
	{
		if (checkbool)
		{
			fetch_js_object('hourlyfromprice').disabled = false;
			fetch_js_object('hourlytoprice').disabled = false;
			if (force)
			{
				fetch_js_object('cb_hourly').checked = true;
			}
		}
		else
		{
			fetch_js_object('hourlyfromprice').disabled = true;
			fetch_js_object('hourlytoprice').disabled = true;
		}
	}
	else if (inputgroup == 'distance_experts')
	{
		if (checkbool)
		{
			fetch_js_object('expertradiuscountry').disabled = false;
			fetch_js_object('expertradius').disabled = false;
			fetch_js_object('expertradiuszip').disabled = false;
			fetch_js_object('expertcountry').disabled = true;
			fetch_js_object('incity3_3').disabled = true;
			fetch_js_object('state3_3').disabled = true;
			fetch_js_object('zipcode3_3').disabled = true;
			fetch_js_object('cb_expertlocation').checked = false;
			fetch_js_object('cb_expertlocation').disabled = true;
			if (force)
			{
				fetch_js_object('cb_expertdistance').checked = true;
			}
		}
		else
		{
			fetch_js_object('expertradiuscountry').disabled = true;
			fetch_js_object('expertradius').disabled = true;
			fetch_js_object('expertradiuszip').disabled = true;
			fetch_js_object('cb_expertlocation').disabled = false;
		}
	}
	else if (inputgroup == 'distance_service')
	{
		if (checkbool)
		{
			fetch_js_object('serviceradiuscountry').disabled = false;
			fetch_js_object('serviceradius').disabled = false;
			fetch_js_object('serviceradiuszip').disabled = false;
			fetch_js_object('servicecountry').disabled = true;
			fetch_js_object('incity1_3').disabled = true;
			fetch_js_object('state1_3').disabled = true;
			fetch_js_object('zipcode1_3').disabled = true;
			fetch_js_object('cb_servicelocation').checked = false;
			fetch_js_object('cb_servicelocation').disabled = true;
			if (force)
			{
				fetch_js_object('cb_servicedistance').checked = true;
			}
		}
		else
		{
			fetch_js_object('serviceradiuscountry').disabled = true;
			fetch_js_object('serviceradius').disabled = true;
			fetch_js_object('serviceradiuszip').disabled = true;
			fetch_js_object('cb_servicelocation').disabled = false;
		}
	}
	else if (inputgroup == 'distance_product')
	{
		if (checkbool)
		{
			fetch_js_object('productradiuscountry').disabled = false;
			fetch_js_object('productradius').disabled = false;
			fetch_js_object('productradiuszip').disabled = false;
			fetch_js_object('productcountry').disabled = true;
			fetch_js_object('incity2_3').disabled = true;
			fetch_js_object('state2_3').disabled = true;
			fetch_js_object('zipcode2_3').disabled = true;
			fetch_js_object('cb_productlocation').checked = false;
			fetch_js_object('cb_productlocation').disabled = true;
			if (force)
			{
				fetch_js_object('cb_productdistance').checked = true;
			}
		}
		else
		{
			fetch_js_object('productradiuscountry').disabled = true;
			fetch_js_object('productradius').disabled = true;
			fetch_js_object('productradiuszip').disabled = true;
			fetch_js_object('cb_productlocation').disabled = false;
		}
	}
	else if (inputgroup == 'location_experts')
	{
		if (checkbool)
		{
			fetch_js_object('expertcountry').disabled = false;
			fetch_js_object('incity3_3').disabled = false;
			fetch_js_object('state3_3').disabled = false;
			fetch_js_object('zipcode3_3').disabled = false;
			
			if (DISTANCE == 1)
			{
				fetch_js_object('expertradiuscountry').disabled = true;
				fetch_js_object('expertradius').disabled = true;
				fetch_js_object('expertradiuszip').disabled = true;
				fetch_js_object('cb_expertdistance').disabled = true;
			}
			
			if (force)
			{
				fetch_js_object('cb_expertlocation').checked = true;
			}
		}
		else
		{
			fetch_js_object('expertcountry').disabled = true;
			fetch_js_object('incity3_3').disabled = true;
			fetch_js_object('state3_3').disabled = true;
			fetch_js_object('zipcode3_3').disabled = true;
			
			if (DISTANCE == 1)
			{
				fetch_js_object('cb_expertdistance').disabled = false;
			}
		}
	}
	else if (inputgroup == 'location_service')
	{
		if (checkbool)
		{
			fetch_js_object('servicecountry').disabled = false;
			fetch_js_object('incity1_3').disabled = false;
			fetch_js_object('state1_3').disabled = false;
			fetch_js_object('zipcode1_3').disabled = false;
			
			if (DISTANCE == 1)
			{
				fetch_js_object('serviceradiuscountry').disabled = true;
				fetch_js_object('serviceradius').disabled = true;
				fetch_js_object('serviceradiuszip').disabled = true;
				fetch_js_object('cb_servicedistance').disabled = true;
			}
			
			if (force)
			{
				fetch_js_object('cb_servicelocation').checked = true;
			}
		}
		else
		{
			fetch_js_object('servicecountry').disabled = true;
			fetch_js_object('incity1_3').disabled = true;
			fetch_js_object('state1_3').disabled = true;
			fetch_js_object('zipcode1_3').disabled = true;
			
			if (DISTANCE == 1)
			{
				fetch_js_object('cb_servicedistance').disabled = false;
			}
		}
	}
	else if (inputgroup == 'location_product')
	{
		if (checkbool)
		{
			fetch_js_object('productcountry').disabled = false;
			fetch_js_object('incity2_3').disabled = false;
			fetch_js_object('state2_3').disabled = false;
			fetch_js_object('zipcode2_3').disabled = false;
			
			if (DISTANCE == 1)
			{
				fetch_js_object('productradiuscountry').disabled = true;
				fetch_js_object('productradius').disabled = true;
				fetch_js_object('productradiuszip').disabled = true;
				fetch_js_object('cb_productdistance').disabled = true;
			}
			
			if (force)
			{
				fetch_js_object('cb_productlocation').checked = true;
			}
		}
		else
		{
			fetch_js_object('productcountry').disabled = true;
			fetch_js_object('incity2_3').disabled = true;
			fetch_js_object('state2_3').disabled = true;
			fetch_js_object('zipcode2_3').disabled = true;
			
			if (DISTANCE == 1)
			{
				fetch_js_object('cb_productdistance').disabled = false;
			}
		}
	}
	else if (inputgroup == 'expertoptions')
	{
		if (checkbool)
		{
			fetch_js_object('islogd1_1').disabled = false;
			fetch_js_object('images3_1').disabled = false;
			if (force)
			{
				fetch_js_object('cb_expertoptions').checked = true;
			}			
		}
		else
		{
			fetch_js_object('islogd1_1').disabled = true;
			fetch_js_object('images3_1').disabled = true;
		}
	}
	else if (inputgroup == 'servicelisted')
	{
		if (checkbool)
		{
			fetch_js_object('serviceendstart').disabled = false;
			fetch_js_object('serviceendstart_filter').disabled = false;
			if (force)
			{
				fetch_js_object('cb_servicelisted').checked = true;
			}			
		}
		else
		{
			fetch_js_object('serviceendstart').disabled = true;
			fetch_js_object('serviceendstart_filter').disabled = true;
		}
	}
	else if (inputgroup == 'productlisted')
	{
		if (checkbool)
		{
			fetch_js_object('productendstart').disabled = false;
			fetch_js_object('productendstart_filter').disabled = false;
			if (force)
			{
				fetch_js_object('cb_productlisted').checked = true;
			}			
		}
		else
		{
			fetch_js_object('productendstart').disabled = true;
			fetch_js_object('productendstart_filter').disabled = true;
		}
	}
	else if (inputgroup == 'awardrange')
	{
		if (checkbool)
		{
			fetch_js_object('projectrange').disabled = false;
			if (force)
			{
				fetch_js_object('cb_awardrange').checked = true;
			}			
		}
		else
		{
			fetch_js_object('projectrange').disabled = true;
		}
	}
	else if (inputgroup == 'servicebidrange')
	{
		if (checkbool)
		{
			fetch_js_object('servicebidrange').disabled = false;
			if (force)
			{
				fetch_js_object('cb_servicebidrange').checked = true;
			}			
		}
		else
		{
			fetch_js_object('servicebidrange').disabled = true;
		}
	}
	else if (inputgroup == 'productbidrange')
	{
		if (checkbool)
		{
			fetch_js_object('productbidrange').disabled = false;
			if (force)
			{
				fetch_js_object('cb_productbidrange').checked = true;
			}			
		}
		else
		{
			fetch_js_object('productbidrange').disabled = true;
		}
	}
	else if (inputgroup == 'servicesearchuser')
	{
		if (checkbool)
		{
			fetch_js_object('servicesearchuser').disabled = false;
			fetch_js_object('serviceexactname').disabled = false;
			if (force)
			{
				fetch_js_object('cb_servicesearchuser').checked = true;
			}			
		}
		else
		{
			fetch_js_object('servicesearchuser').disabled = true;
			fetch_js_object('serviceexactname').disabled = true;
		}
	}
	else if (inputgroup == 'productsearchuser')
	{
		if (checkbool)
		{
			fetch_js_object('productsearchuser').disabled = false;
			fetch_js_object('productexactname').disabled = false;
			if (force)
			{
				fetch_js_object('cb_productsearchuser').checked = true;
			}			
		}
		else
		{
			fetch_js_object('productsearchuser').disabled = true;
			fetch_js_object('productexactname').disabled = true;
		}
	}
	else if (inputgroup == 'ratingrange')
	{
		if (checkbool)
		{
			fetch_js_object('rating').disabled = false;
			if (force)
			{
				fetch_js_object('cb_ratingrange').checked = true;
			}			
		}
		else
		{
			fetch_js_object('rating').disabled = true;
		}
	}
	else if (inputgroup == 'listingtype')
	{
		if (checkbool)
		{
			fetch_js_object('auctiontype').disabled = false;
			if (force)
			{
				fetch_js_object('cb_listingtype').checked = true;
			}			
		}
		else
		{
			fetch_js_object('auctiontype').disabled = true;
		}
	}
	else if (inputgroup == 'productlistingtype')
	{
		if (checkbool)
		{
			fetch_js_object('productlistingtype').disabled = false;
			if (force)
			{
				fetch_js_object('cb_productlistingtype').checked = true;
			}			
		}
		else
		{
			fetch_js_object('productlistingtype').disabled = true;
		}
	}
	else if (inputgroup == 'servicelistingtype')
	{
		if (checkbool)
		{
			fetch_js_object('servicelistingtype').disabled = false;
			if (force)
			{
				fetch_js_object('cb_servicelistingtype').checked = true;
			}			
		}
		else
		{
			fetch_js_object('servicelistingtype').disabled = true;
		}
	}
	else if (inputgroup == 'serviceoptions')
	{
		if (checkbool)
		{
			fetch_js_object('budget1_1').disabled = false;
			fetch_js_object('pboard1_1').disabled = false;
			
			if (ESCROW == '1')
			{
				fetch_js_object('escrow1_1').disabled = false;
			}			
			if (force)
			{
				fetch_js_object('cb_serviceoptions').checked = true;
			}			
		}
		else
		{
			fetch_js_object('budget1_1').disabled = true;
			fetch_js_object('pboard1_1').disabled = true;
			
			if (ESCROW == '1')
			{
				fetch_js_object('escrow1_1').disabled = true;
			}
		}
	}
	else if (inputgroup == 'productoptions')
	{
		if (checkbool)
		{
			fetch_js_object('buynow2_1').disabled = false;
			fetch_js_object('images2_1').disabled = false;
			fetch_js_object('pboard2_1').disabled = false;
			fetch_js_object('freesh2_1').disabled = false;
			fetch_js_object('laslot2_1').disabled = false;
			if (ESCROW == '1')
			{
				fetch_js_object('escrow2_1').disabled = false;
			}			
			if (force)
			{
				fetch_js_object('cb_productoptions').checked = true;
			}			
		}
		else
		{
			fetch_js_object('buynow2_1').disabled = true;
			fetch_js_object('images2_1').disabled = true;
			fetch_js_object('pboard2_1').disabled = true;
			fetch_js_object('freesh2_1').disabled = true;
			fetch_js_object('laslot2_1').disabled = true;
			if (ESCROW == '1')
			{
				fetch_js_object('escrow2_1').disabled = true;
			}
		}
	}
	else if (inputgroup == 'pricerange')
	{
		if (checkbool)
		{
			fetch_js_object('frompricerange').disabled = false;
			fetch_js_object('topricerange').disabled = false;
			if (force)
			{
				fetch_js_object('cb_pricerange').checked = true;
			}
		}
		else
		{
			fetch_js_object('frompricerange').disabled = true;
			fetch_js_object('topricerange').disabled = true;
		}
	}
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: functions_search.js,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/