<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

// this script is to be placed somewhere best suited within the vbulletin application specifically when vbulletin is
// authenticating a user based on an existing cookie (to auto-log them in) without them having to enter username or password
// additionally, this should also be placed where a vbulletin user has registered to the marketplace and when vbulletin builds
// proper member sessions, this should also create a cookie for the user so he can login to ILance without a user/pass menu

############################################################################################################################
// #### REQUIRED!!!!! ENTER THE 3 KEYS FROM YOUR ADMINCP > SETTINGS > PAYMENT MODULES > ENC-KEYS TAB #######################
############################################################################################################################
$cookie['key1'] = '';      // <-------------- key1
$cookie['key2'] = '';      // <-------------- key2
$cookie['key3'] = '';      // <-------------- key3

// #### FINALLY MAKE SURE YOU SUPPLY THE 3 VARIABLES BELOW BASED ON THE VBULLETIN USER #####################################
// in this situation, you need to make userid, username and password available so we can encrypt them and save the cookie
// so that this vb user being authenticated in vbulletin can now access ilance marketplace without any additional logins

$cookie['userid']   = '';   // <-------------- plain text userid of the vbulletin user should be put here using vb's code for the userid (ie: $bbuserinfo['userid'])
$cookie['username'] = '';   // <-------------- plain text username of vbulletin user should be put here using vb's code for the username (ie: $bbuserinfo['username'])
$cookie['password'] = '';   // <-------------- md5 hashed vbulletin password (this password is the one from the user table of vbulletin: field: 'password'; $bbuserinfo['password'])
$cookie['cookiename'] = 'ilance_'; // <-------------- set this to what your ilance cookie name is

// ### DO NOT TOUCH BELOW ######################################################

// convert local vb date & time constants into constants required by ilance
define('TIMESTAMPNOW', TIMENOW);
define('DATETIME24H', gmdate('Y-m-d H:i:s', TIMENOW));

function key_ed($txt = '', $encrypt_key = '')
{
        $ctr = 0;
        $tmp = '';
        
        for ($i = 0; $i < mb_strlen($txt); $i++)
        {
                if ($ctr == mb_strlen($encrypt_key))
                {
                        $ctr = 0;
                }
                $tmp .= mb_substr($txt, $i, 1) ^ mb_substr($encrypt_key, $ctr, 1);
                $ctr++;
        }
        
        return $tmp;
}

function encrypt($txt = '', $key = '')
{
        $ctr = 0;
        $tmp = '';
        srand((double)microtime()*1000000);
        $encrypt_key = md5(rand(0, 32000));
        
        for ($i = 0; $i < mb_strlen($txt); $i++)
        {
                if ($ctr == mb_strlen($encrypt_key))
                {
                            $ctr = 0;
                }
                $tmp .= mb_substr($encrypt_key, $ctr, 1) . (mb_substr($txt, $i, 1) ^ mb_substr($encrypt_key, $ctr, 1));
                $ctr++;
        }
        
        return key_ed($tmp,$key);
}

function three_layer_encrypt($text_plain = '', $key1 = '', $key2 = '', $key3 = '')
{
        return base64_encode(key_ed(encrypt(key_ed($text_plain, $key1), $key2), $key3));
}

// set cookies for auto-logins for an ILance user being authenticated from vbulletin
setcookie($cookie['cookiename'] . 'userid', three_layer_encrypt($cookie['userid'], $cookie['key1'], $cookie['key2'], $cookie['key3']), TIMESTAMPNOW + 31622400, '/', '');
setcookie($cookie['cookiename'] . 'password', three_layer_encrypt($cookie['password'], $cookie['key1'], $cookie['key2'], $cookie['key3']), TIMESTAMPNOW + 31622400, '/', '');
setcookie($cookie['cookiename'] . 'username', three_layer_encrypt($cookie['username'], $cookie['key1'], $cookie['key2'], $cookie['key3']), TIMESTAMPNOW + 31622400, '/', '');
setcookie($cookie['cookiename'] . 'lastvisit', DATETIME24H, TIMESTAMPNOW + 31622400, '/', '');
setcookie($cookie['cookiename'] . 'lastactivity', DATETIME24H, TIMESTAMPNOW + 31622400, '/', '');

// cleanup some memory and let vbulletin continue it's execution..
unset($cookie);

// right here at this point the cookies for the user surfing ilance should be created and it should know who the person is.  Remember, this will only work
// if the user already exists within ilance.

?>