<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

// #### load required phrase groups ############################################
$phrase['groups'] = array(
        'buying',
        'selling',
);

// #### setup script location ##################################################
define('LOCATION','nonprofits');

// #### define top header nav ##################################################
$topnavlink = array(
        'nonprofits'
);

// #### require backend ########################################################
require_once('./functions/config.php');

// #### setup default breadcrumb ###############################################
$navcrumb = array("$ilpage[nonprofits]" => $ilcrumbs["$ilpage[nonprofits]"]);

$area_title = $phrase['_nonprofits'];
$page_title = SITE_NAME . ' - ' . $phrase['_nonprofits'];

($apihook = $ilance->api('nonprofits_start')) ? eval($apihook) : false;

if ($ilconfig['enablenonprofits'] == 0)
{
	$navcrumb = array("nonprofits.php" => $phrase['_nonprofits']);
	print_notice($phrase['_disabled'], $phrase['_were_sorry_this_feature_is_currently_disabled'], HTTPS_SERVER . $ilpage['main'], $phrase['_main_menu']);
	exit();
}

$ilance->template->fetch('main', 'nonprofits.html');
$ilance->template->parse_hash('main', array('ilpage' => $ilpage));
$ilance->template->parse_if_blocks('main');
$ilance->template->pprint('main', array('type','abusetype_pulldown','requesturi','url','cmd','id','input_style','remote_addr','rid','login_include','headinclude','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
exit();

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: nonprofits.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>