<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

// #### load required phrase groups ############################################
$phrase['groups'] = array(
        'rfp',
        'buying',
        'selling',
        'watchlist'
);

// #### setup script location ##################################################
define('LOCATION','notify');

// #### require backend ########################################################
require_once('./functions/config.php');

// #### setup default breadcrumb ###############################################
$navcrumb = array("$ilpage[notify]" => $ilcrumbs["$ilpage[notify]"]);

if (isset($ilance->GPC['crypted']))
{
	$uncrypted = decrypt_url($ilance->GPC['crypted']);
}

// #### CONTACT US FORM HANDLER ################################################
if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == '_submit-contactus')
{
	if (isset($ilance->GPC['subject']) AND $ilance->GPC['subject'] == 'other')
	{
		$subject = un_htmlspecialchars($ilance->GPC['subject_other']);	
	}
	else if (isset($ilance->GPC['subject']) AND $ilance->GPC['subject'] == '1')
	{
		$subject = $phrase['_registration'];
	}
	else
	{
		$subject = $phrase['_feedback'];	
	}
        if (!empty($ilance->GPC['message']))
        {
                $message = un_htmlspecialchars($ilance->GPC['message']);
        }
        else
        {
		$url = ($ilconfig['globalauctionsettings_seourls']) ? HTTPS_SERVER . 'main-contact' : HTTPS_SERVER . $ilpage['main'] . '?cmd=contact';
                print_notice($phrase['_invalid_message'], $phrase['_sorry_in_order_to_send_a_contact_us_message_you_must_type_your_message_please_try_again'], $url, $phrase['_contact_us']);
                exit();
        }
        if (!empty($ilance->GPC['email']))
        {
                $email = un_htmlspecialchars($ilance->GPC['email']);
        }
        else
        {
		$url = ($ilconfig['globalauctionsettings_seourls']) ? HTTPS_SERVER . 'main-contact' : HTTPS_SERVER . $ilpage['main'] . '?cmd=contact';
                print_notice($phrase['_invalid_email_address'], $phrase['_were_sorry_in_order_to_send_a_contact_us_message_you_must_specify_your_email_address_please_try_again'], $url, $phrase['_contact_us']);
                exit();
        }
	if (!empty($ilance->GPC['name']))
        {
		$name = un_htmlspecialchars($ilance->GPC['name']);
	}
	else
	{
		$name = 'Guest';
	}
        
	send_email(SITE_EMAIL, $subject, $message, $email, $name);
        
	print_notice($phrase['_your_message_was_sent'], $phrase['_your_message_was_sent_and_delivered_to_customer_support'], $ilpage['main'], $phrase['_main_menu']);
	exit();
}
else
{
	refresh($ilpage['login'] . '?redirect=' . urlencode($ilpage['notify'] . print_hidden_fields($string = true, $excluded = array(), $questionmarkfirst = true)));
	exit();
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: notify.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>