<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

$count = 0;

if (!empty($ilance->GPC['crypted']))
{
	$cryptedws = decrypt_url($ilance->GPC['crypted']);
	
	$fold_id = $cryptedws['fold_id'];
	$project_id = $cryptedws['project_id'];
	$seller_id = $cryptedws['seller_id'];
	$buyer_id = $cryptedws['buyer_id'];
	$file_id = isset($cryptedws['file_id']) ? $cryptedws['file_id'] : 0;
}

$query = $ilance->db->query("
	SELECT attachid, attachtype, user_id, portfolio_id, project_id, pmb_id, category_id, date, filename, filetype, visible, counter, filesize, filehash, ipaddress, tblfolder_ref
	FROM " . DB_PREFIX . "attachment
");
if ($ilance->db->num_rows($query) > 0)
{
	while ($row = $ilance->db->fetch_array($query))
	{
		$name = $row['filename'];
		$temp = 'file' . $row['attachid'];
		if (!empty($ilance->GPC[$temp]) AND $ilance->GPC[$temp] == 'on')
		{
			$nfile_id = $row['attachid'];
			$count++;
		}
	}
}

$query2 = $ilance->db->query("
	SELECT id, name
	FROM " . DB_PREFIX . "attachment_folder
");
if ($ilance->db->num_rows($query2) > 0) 
{
	while ($row2 = $ilance->db->fetch_array($query2))
	{
		$name = $row2['name'];
		$temp = 'fold' . $row2['id'];
		if (!empty($ilance->GPC[$temp]) AND $ilance->GPC[$temp] == 'on')
		{
			$nfoldId = $row2['id'];
			$count++;
		}
	}
}

if (isset($oneFileCheck) AND $oneFileCheck == 1)
{
	if (isset($count) AND $count < 1)
	{
		$cryptedws = array(
			'project_id' => $project_id,
			'buyer_id' => $buyer_id,
			'seller_id' => $seller_id,
			'fold_id' => $fold_id,
			'error_code' => '1'
		);
		
		header("Location: " . $ilpage['mediashare'] . "?crypted=" . encrypt_url($cryptedws));
	}
}
else
{
	if (isset($count) AND $count > 1 OR isset($count) AND $count < 1)
	{
		$cryptedws = array(
			'project_id' => $project_id,
			'buyer_id' => $buyer_id,
			'seller_id' => $seller_id,
			'fold_id' => $fold_id,
			'error_code' => '1'
		);
		
		header("Location: " . $ilpage['mediashare'] . "?crypted=" . encrypt_url($cryptedws));
	}
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: file_value_checks.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>