<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/
require_once('../functions/config.php');

function print_fixed_string($str = '')
{
	$str = trim($str);
	$str = str_replace("'", "''", $str);
	$str = str_replace("\'", "'", $str);
	$str = str_replace("", ",", $str);
	$str = str_replace("\\", "", $str);
	$str = str_replace("\"", "&#34;", $str);
	$str = str_replace('\"', '"', $str);
        
	return $str;
}

function fetch_max_id($tblName = '')
{
	global $con_id, $ilance;
        
	$rs = $ilance->db->query("SELECT MAX(id) AS mx FROM $tblName");
        
	return $id = mysql_result($rs, 0, "mx");
}

function insert_record($strTable, $arrValue)
{
        global $ilance;
        
	$strQuery = " INSERT INTO $strTable (";
	if (!isset($arrValue))
        {
                $arrValue = array();
        }
	@reset($arrValue);
	while (list ($strKey, $strVal) = each($arrValue))
        {
		$strQuery .= $strKey . ",";
	}
	
	// remove last comma
	$strQuery = mb_substr($strQuery, 0, mb_strlen($strQuery) - 1);
	$strQuery .= ") VALUES (";
	if (!isset($arrValue))
        {
                $arrValue = array();
        }
	@reset($arrValue);
	while(list ($strKey, $strVal) = each($arrValue))
        {
		$strQuery .= "'" . print_fixed_string($strVal) . "',";
	}
	
	// remove last comma
	$strQuery = mb_substr($strQuery, 0, mb_strlen($strQuery) - 1);
	$strQuery .= ");";
	$ilance->db->query($strQuery);
        
	return fetch_max_id($strTable);
}
				
function update_record($strTable, $strWhere, $arrValue)
{
        global $ilance;
        
        $strQuery = "UPDATE $strTable SET ";
	if (!isset($arrValue))
        {
                $arrValue = array();
        }
	@reset($arrValue);
	while (list ($strKey, $strVal) = each($arrValue))
        {
		$strQuery .= $strKey . "='" . print_fixed_string($strVal) . "',";
	}
	$strQuery = mb_substr($strQuery, 0, mb_strlen($strQuery) - 1);
	$strQuery .= " WHERE ".$strWhere;
        
	$ilance->db->query($strQuery);
}

function fetch_field_count($tbl, $criteria)
{
	global $con_id, $ilance;
        
	if (!empty($criteria))
        {
		$where = "WHERE $criteria";
	}
        
	$query = "SELECT COUNT(*) AS cnt FROM $tbl $where";
	$result = $ilance->db->query($query);
        
	return mysql_result($result,0,"cnt");
}

function construct_attachment_folder($folder_name, $folder_comments, $folder_parent, $folder_project, $folder_buyer, $folder_seller, $folder_size, $folder_type)
{
	$today = DATETODAY;
        
	$folderId = insert_record(DB_PREFIX."attachment_folder", array(
		"name" => $folder_name,
		"comments" => $folder_comments,
		"p_id" => $folder_parent,
		"project_id" => $folder_project,
		"buyer_id" => $folder_buyer,
		"seller_id" => $folder_seller,
		"folder_size" => $folder_size,
		"folder_type" => $folder_type,
		"create_date" => $today)
	);
        
	return $folderId;
}

function fetch_folder_parent_id($folderid)
{
	global $ilance, $ilmedia, $ilpage;
	
	$parentid = 0;
	
	$rs = $ilance->db->query("
		SELECT p_id
		FROM " . DB_PREFIX . "attachment_folder
		WHERE id = '".intval($folderid)."'
	");
	while ($rows = $ilance->db->fetch_array($rs))
	{
		$parentid = $rows['p_id'];
	}
	if ($parentid == '-1')
	{
		$parentid = 0;
	}
        
	return $parentid;
}

function print_current_folder_title($id, $parentid = 0, $strString)
{
	global $ilance, $ilmedia, $ilpage, $cryptedws;
        
	if ($id == '-1' OR empty($id))
	{
		return '';
	}
        
	$rs = $ilance->db->query("
		SELECT *
		FROM " . DB_PREFIX . "attachment_folder
		WHERE id = '" . intval($id) . "'
	");
	while ($rows = $ilance->db->fetch_array($rs))
	{
		$parentid = $rows['p_id'];
		$strName = $rows['name'];
		
		if ($parentid == '-1')
		{
			$crypted = array(
                                'project_id' => $ilmedia['project_id'],
                                'buyer_id' => $ilmedia['buyer_id'],
                                'seller_id' => $ilmedia['seller_id'],
                                'fold_id' => $id,
                                'p_id' => $parentid
                        );
                        
			$strString = '<span class="blue"><a href="' . HTTPS_WS . $ilpage['mediashare'] . '?crypted=' . encrypt_url($crypted) . '">' . mb_strtolower(stripslashes($strName)) . '</a></span>/' . $strString;
			
			return $strString;
		}
		else
		{
			if ($rows['id'] == $cryptedws['fold_id'])
			{
				$strString = mb_strtolower($strName) . '/' . $strString;
			}
			else
			{
				$crypted = array(
                                        'project_id' => $ilmedia['project_id'],
                                        'buyer_id' => $ilmedia['buyer_id'],
                                        'seller_id' => $ilmedia['seller_id'],
                                        'fold_id' => $id,
                                        'p_id' => $parentid
                                );
                                
				$strString = '<span class="blue"><a href="' . HTTPS_WS . $ilpage['mediashare'] . '?crypted=' . encrypt_url($crypted) .'">' . mb_strtolower(stripslashes($strName)) . '</a></span>/' . $strString;
			}
			
			$strString = print_current_folder_title($parentid, $id, $strString);
			
			return $strString;
		}
	}
}

function print_hidden_input_folders()
{
	global $arrFolder;
        
	for ($i = 0; $i < count($arrFolder); $i++)
        {
		echo '<input type="hidden" name="fold' . $arrFolder["$i"] . '" value="on" />';
	}
}

function print_hidden_input_files()
{
	global $arrFiles;
        
	for ($i = 0; $i < count($arrFiles); $i++)
        {
		echo '<input type="hidden" name="file' . $arrFiles["$i"] . '" value="on" />';
	}
}

function print_arrow($nNo)
{
	$html = '';
        
	for ($i = 0; $i < $nNo; $i++)
	{
		$html .= " &gt;";
	}
        
	return $html;
}

function print_folder_option_values($root_id, $cfold_id)
{
	global $ilance, $gPath;
        
	if ($root_id == $cfold_id)
        {
		return 0;
	}
        
	$rs = $ilance->db->query("
                SELECT *
                FROM " . DB_PREFIX . "attachment_folder
                WHERE p_id = '" . intval($root_id) . "'
        ");
	while ($rows = $ilance->db->fetch_array($rs))
        {
		$arrow = print_arrow($gPath);
                
		echo '<option value="' . $rows['id'] . '">' . $arrow . '&nbsp;' . stripslashes($rows['name']) . '</option>';
                
		if (fetch_field_count(DB_PREFIX . "attachment_folder", "p_id = " . $rows['id']) > 0)
                {
			$gPath++;
			print_folder_option_values($rows['id'], $cfold_id);
		}
	}
	$gPath--;
}

function construct_date($strDate)
{
        if (empty($strDate))
        {
                return 'Never';
        }
        
	$strTemp = explode(' ', $strDate);
	$strTemp = explode('-', $strTemp[0]);
	$strDate = $strTemp[2] . '-' . $strTemp[1] . '-' . $strTemp[0];
        
	return $strDate;			
}

function copyFiles($nFold, $newFolderId)
{
	global $ilmedia, $ilance;
	
	$query = $ilance->db->query("
		SELECT attachid, attachtype, user_id, portfolio_id, project_id, pmb_id, category_id, date, filename, filetype, visible, counter, filesize, filehash, ipaddress, tblfolder_ref
		FROM " . DB_PREFIX . "attachment
		WHERE tblfolder_ref = '" . intval($nFold) . "'
	");
	while ($row = $ilance->db->fetch_array($query))
	{
		$ilance->db->query("
			INSERT INTO " . DB_PREFIX . "attachment
			(attachid, attachtype, user_id, project_id, date, filename, filedata, filetype, visible, counter, filesize, filehash, ipaddress, tblfolder_ref)
			VALUES(
			NULL,
			'ws',
			'" . $_SESSION['ilancedata']['user']['userid'] . "',
			'" . intval($ilmedia['project_id']) . "',
			'" . DATETIME24H . "',
			'" . addslashes($row['filename']) . "',
			'" . addslashes($row['filedata']) . "',
			'" . addslashes($row['filetype']) . "',
			'1',
			'0',
			'" . $row['filesize'] . "',
			'" . $row['filehash'] . "',
			'" . addslashes($_SERVER['REMOTE_ADDR']) . "',
			'" . (int)$newFolderId . "')
		");
		
		//get size of folder file is copying to
		$nSize = ($ilance->db->fetch_field(DB_PREFIX . "attachment_folder", "id = '" . intval($newFolderId) . "'", "folder_size") + $row['filesize']);
		
		// updating new folder id with new filesize
		update_record(DB_PREFIX . "attachment_folder", "id = '" . intval($newFolderId) . "'", array('folder_size' => $nSize,));
	}
}

function copyIntFolders($nFold, $newParent)
{
	global $ilance;
	
	$nFold = intval($nFold);
	
	$query = $ilance->db->query("
		SELECT *
		FROM " . DB_PREFIX . "attachment_folder
		WHERE p_id = '" . intval($nFold) . "'
	");
	if ($ilance->db->num_rows($query) > 0)
	{
		while ($row = $ilance->db->fetch_array($query))
		{
			$created_folder_id = construct_attachment_folder(addslashes($row['name']), addslashes($row['comments']), $newParent, -1, -1, -1, $row['folder_size'], -1);
			
			copyFiles($row['id'], $created_folder_id);
			
			if (fetch_field_count(DB_PREFIX . "attachment_folder", "p_id = '" . $row['id'] . "'") > 0)
			{
				copyIntFolders($row['id'], $created_folder_id);
			}
		}					
	}
}

function checkPrivateFolder($sellerid, $buyerid)
{
	global $ilance, $ilmedia;
	
	if (!empty($sellerid) AND !empty($_SESSION['ilancedata']['user']['userid']) AND $sellerid == $_SESSION['ilancedata']['user']['userid'])
	{
		$value = fetch_field_count(DB_PREFIX . "attachment_folder", "seller_id = '" . intval($sellerid) . "'");
		if (empty($value))
		{
			// create private folder for seller
			construct_attachment_folder("Private", "", -1, $ilmedia['project_id'], 0, intval($sellerid), 0, 1);
		}
	}
	
	if (!empty($buyerid) AND !empty($_SESSION['ilancedata']['user']['userid']) AND $buyerid == $_SESSION['ilancedata']['user']['userid'])
	{
		$value = fetch_field_count(DB_PREFIX . "attachment_folder", "buyer_id = '" . intval($buyerid) . "'");
		if (empty($value))
		{
			// create private folder for buyer
			construct_attachment_folder("Private", "", -1, $ilmedia['project_id'], intval($buyerid), 0, 0, 1);
		}
	}
}

function checkSharedFolder($projectid)
{
	global $ilance, $ilmedia;
	
	$value = fetch_field_count(DB_PREFIX . "attachment_folder", "project_id = '" . intval($projectid) . "' AND folder_type = '2'");
	if (empty($value))
	{
		// create shared folder for a specific auction
		construct_attachment_folder("Shared", "", -1, $projectid, 0, 0, 0, 2);
	}
}

function showFolder($fold_id, $disFlag)
{
	global $ilance, $ilconfig, $ilmedia, $arrFolder, $ilpage;
	
	$html = '';
	
	$query = $ilance->db->query("
		SELECT *
		FROM " . DB_PREFIX . "attachment_folder
		WHERE p_id = '" . intval($fold_id) . "'
	");
	if ($ilance->db->num_rows($query) > 0)
	{
		while ($row = $ilance->db->fetch_array($query))
		{
			$temp = 'fold' . $row['id'];
			if ($disFlag == 1)
			{
				if (in_array($row['id'], $arrFolder))
				{
					$html .= '<tr><td width="10"></td><td width="10"><input type="checkbox" name="' . $temp . '" disabled="disabled" checked="checked" /></td>';
				}
				else
				{
					$html .= '<tr><td width="10"></td><td width="10"><input type="checkbox" name="' . $temp . '" disabled="disabled" /></td>';
				}
			}
			else
			{
				$html .= '<tr><td width="10"></td><td width="10"><input type="checkbox" name="' . $temp . '" /></td>';
			}
			
			$cryptedws = array(
				'project_id' => $ilmedia['project_id'],
				'buyer_id' => $ilmedia['buyer_id'],
				'seller_id' => $ilmedia['seller_id'],
				'fold_id' => $row['id'],
				'p_id' => $row['p_id']
			);
			
			$html .= '<td width="25" align="center"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'folder.gif" width="16" height="13"></td><td><span class="blue"><a href="' . HTTPS_WS . $ilpage['mediashare'] . '?crypted=' . encrypt_url($cryptedws) . '">' . stripslashes($row['name']) . '</a></span></td></tr>';
			$html .= '<tr><td height="1" colspan="3"></td></tr>';
		}
	}
	
	return $html;
}

function showFiles($fold_id, $disFlag)
{
	global $ilance, $ilmedia, $arrFiles, $ilconfig, $ilpage;
	
	$html = '';
	
	$query = $ilance->db->query("
		SELECT attachid, attachtype, user_id, portfolio_id, project_id, pmb_id, category_id, date, filename, filetype, visible, counter, filesize, filehash, ipaddress, tblfolder_ref
		FROM " . DB_PREFIX . "attachment
		WHERE tblfolder_ref = '" . intval($fold_id) . "'
	");
	if ($ilance->db->num_rows($query) > 0)
	{
		while ($row = $ilance->db->fetch_array($query))
		{
			$temp = 'file' . $row['attachid'];
			if ($disFlag == 1)
			{
				if (in_array($row['attachid'], $arrFiles))
				{
					$html .= '<tr><td width="12"></td><td width="10"><input type="checkbox" name="' . $temp . '" disabled="disabled" checked="checked" /></td>';
				}
				else
				{
					$html .= '<tr><td width="12"></td><td width="10"><input type="checkbox" name="' . $temp . '" disabled="disabled" /></td>';
				}
			}
			else
			{
				$html .= '<tr><td width="12"></td><td width="10"><input type="checkbox" name="' . $temp . '" /></td>';
			}
			
			$attachextension = fetch_extension($row['filename']) . '.gif';
			if (file_exists(DIR_SERVER_ROOT . $ilconfig['template_imagesfolder'] . 'icons/' . $attachextension))
			{
				$attachextension = fetch_extension($row['filename']) . '.gif';
			}
			else
			{
				$attachextension = 'attach.gif';
			}
			
			$html .= '<td width="25" align="center"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/' . $attachextension . '" width="16" height="16" /></td><td><span class="blue"><a href="' . HTTP_SERVER . $ilpage['attachment'] . '?id=' . $row['filehash'] . '" class="top_link" target="_new">' . $row['filename'] . '</a></span> &nbsp;(' . print_filesize($row['filesize']) . ')</td></tr>';
			$html .= '<tr><td colspan="3"></td></tr>';
		}
	}
	
	return $html;
}

if (!empty($ilance->GPC['crypted']))
{
	$crypted = decrypt_url($ilance->GPC['crypted']);
}

$fold_id = $file_id = $p_id = 0;

if (!empty($crypted['fold_id']))
{
        $fold_id = $crypted['fold_id'];
}
if (!empty($crypted['file_id']))
{
	$file_id = $crypted['file_id'];
}
if (!empty($crypted['p_id']))
{
	$p_id = $crypted['p_id'];
}
if ($fold_id > 0)
{
	$crypted['p_id'] = fetch_folder_parent_id($fold_id);
	$p_id = $crypted['p_id'];
}

$ilmedia['project_id'] = isset($crypted['project_id']) ? intval($crypted['project_id']) : 0;
$ilmedia['buyer_id'] = isset($crypted['buyer_id']) ? intval($crypted['buyer_id']) : 0;
$ilmedia['seller_id'] = isset($crypted['seller_id']) ? intval($crypted['seller_id']) : 0;
$ilmedia['fold_id'] = isset($crypted['fold_id']) ? intval($crypted['fold_id']) : 0;
$ilmedia['p_id'] = isset($crypted['p_id']) ? intval($crypted['p_id']) : 0;

$cryptedws = array("project_id" => $ilmedia['project_id'], "buyer_id" => $ilmedia['buyer_id'], "seller_id" => $ilmedia['seller_id'], "fold_id" => $ilmedia['fold_id'], "p_id" => $ilmedia['p_id']);
$encodedws = serialize($cryptedws);

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: functions.inc.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>