<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/
$phrase['groups'] = array(
	'mediashare',
	'rfp',
	'buying',
	'selling',
	'feedback',
	'javascript'
);

define('LOCATION','mediashare');

include('functions.inc.php');

$ilance->workspace = construct_object('api.workspace');

$navcrumb = array("$ilpage[workspace]" => $ilcrumbs["$ilpage[workspace]"]);

if (empty($_SESSION['ilancedata']['user']['userid']) OR !isset($_SESSION['ilancedata']['user']['userid']))
{
	refresh($ilpage['login'], HTTPS_SERVER . $ilpage['login']);
	exit();
}

if (!empty($ilance->GPC['crypted']))
{
	$cryptedws = decrypt_url($ilance->GPC['crypted']);
	
	$fold_id = isset($cryptedws['fold_id']) ? $cryptedws['fold_id'] : 0;
	$file_id = 0;
	
	$ilmedia['project_id'] = $cryptedws['project_id'];
	$ilmedia['seller_id'] = $cryptedws['seller_id'];
	$ilmedia['buyer_id'] = $cryptedws['buyer_id'];
	$ilmedia['fold_id'] = $cryptedws['fold_id'];
	$cryptedws['p_id'] = isset($cryptedws['p_id']) ? $cryptedws['p_id'] : 0;
	
	if (isset($cryptedws['file_id'])) 
	{
		$file_id = $cryptedws['file_id'];
	}
	
	if (isset($cryptedws['error_code'])) 
	{
		$error_code = $cryptedws['error_code'];
	}
}

$arrFolder = $arrFiles = array();
$icounter = 0;

$rs = $ilance->db->query("
	SELECT *
	FROM " . DB_PREFIX . "attachment_folder
");
while ($row = $ilance->db->fetch_array($rs))
{
	// fold1, fold2, fold3, etc
	$temp = 'fold' . $row['id']; 
	if (isset($ilance->GPC[$temp]) AND $ilance->GPC[$temp] == 'on')
	{
		$arrFolder[$icounter] = $row['id'];
		$icounter++;
	}
}
$icounter = 0;

$query = $ilance->db->query("
	SELECT attachid, attachtype, user_id, portfolio_id, project_id, pmb_id, category_id, date, filename, filetype, visible, counter, filesize, filehash, ipaddress, tblfolder_ref
	FROM " . DB_PREFIX . "attachment
");
while ($row = $ilance->db->fetch_array($query))
{
	$temp = 'file' . $row['attachid'];
	if (isset($ilance->GPC[$temp]) AND $ilance->GPC[$temp] == 'on')
	{
		$arrFiles[$icounter] = $row['attachid'];
		$icounter++;
	}
}

$disFlag = 0;
if (isset($ilance->GPC['newfolder']))
{
	$external['script'] = 'newfolder.html.php';
	$disFlag = 1;
}
else if (isset($ilance->GPC['upload']))
{
	$external['script'] = 'upload.html.php';
	$disFlag = 1;
}
else if (isset($ilance->GPC['comment']))
{
	include('file_value_checks.php');
	$external['script'] = 'comment.html.php';
	$disFlag = 1;
}
else if (isset($ilance->GPC['delete']))
{
	$oneFileCheck = 1;
	include('file_value_checks.php');
	include(DIR_WS_TEMPLATES.'delete.html.php');
	$external['script'] = '';
}
else if (isset($ilance->GPC['rename']))
{
	include('file_value_checks.php');
	$external['script'] = 'rename.html.php';
	$disFlag = 1;
}
else if (isset($ilance->GPC['moveitems']))
{
	$oneFileCheck = 1; // go  more than one but not empty
	include('file_value_checks.php');
	$external['script'] = 'move.html.php';
	$disFlag = 1;
}
else if (isset($ilance->GPC['copyitems']))
{
	$oneFileCheck = 1; // go  more than one but not empty
	include('file_value_checks.php');
	$external['script'] = 'copy.html.php';
	$disFlag = 1;
}

include (DIR_WS_TEMPLATES . 'header.php');
?>

<!-- folder selection -->
<div class="block-content" style="padding:0px">

<div style="padding: 6px;">
<div>
<table width="100%" cellpadding="6" cellspacing="1" border="0">
<tr>
	<td width="50%" valign="top">
		<table width="100%" cellpadding="1" cellspacing="0" border="0">
<?php
		echo showFolder($fold_id, $disFlag);
		echo showFiles($fold_id, $disFlag);
?>
		</table>
	</td>
	<td width="50%" valign="top">
<?php
	 include (DIR_WS_TEMPLATES . 'defaultfolder.html.php');
?>
	</td>
</tr>
</table>
    	
</div>
</div>

</div>
<!-- folder selection -->

<div class="block-footer">
	<div class="block-right">
		<div class="block-left"></div>
	</div>
</div>

</div>
</div>
	
</form>


<?php 
if (isset($external['script']) AND !empty($external['script']))
{
	include(DIR_WS_TEMPLATES . $external['script']);
}

$ilance->template->construct_footer('msfooter');
$ilance->template->parse_if_blocks('msfooter');
$ilance->template->parse_hash('msfooter', array('ilpage' => $ilpage));
$ilance->template->pprint('msfooter', array('area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','finaltime','finalqueries'));

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: mediashare.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>